SunnArt = LibStub("AceAddon-3.0"):NewAddon("SunnArt", "AceConsole-3.0", "AceEvent-3.0")

local L = LibStub("AceLocale-3.0"):GetLocale("SunnArt", true)

SunnArt.overlap = {}

function SunnArt:OnInitialize()
	dprint("+OnInitialize",10)
	self.options = SunnArt_OPTIONS -- from SunnArt_Options.lua
	self.db = LibStub("AceDB-3.0"):New("SunnArt3DB", SunnArt_DEFAULTS, "Default") -- from SunnArt_Defaults.lua
	self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("SunnArt", self.options)

	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("SunnArt", "SunnArt")
	self:RegisterChatCommand("SunnArt", "ChatCommand")
	self:RegisterChatCommand("sa", "ChatCommand")
	self:RegisterChatCommand("sunn", "ChatCommand")
	self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileCopied")
	self.db.RegisterCallback(self, "OnProfileReset", "OnProfileReset")
	self.OnMenuRequest = self.options
	
	BINDING_HEADER_SUNNART = L["Sunn - Viewport Art"]
	BINDING_NAME_SUNNARTUI = L["Toggle UI"]
	

	self:CreateFrames()
	
	
	for themename,themefile in pairs(SunnCustomTheme) do
		SunnArt.options.args.theme.values[themename]=themefile
	end
	for themename,themeoverlap in pairs(SunnCustomOverlap) do
		SunnArt.overlap[themename]=themeoverlap
	end
	
	DEFAULT_CHAT_FRAME:AddMessage(strconcat("|cFF0000FF",L["SunnArt"],"|r:",L["Loaded"]))
end

function SunnArt:OnEnable() dprint("+OnEnable",10); self:Enable(); dprint("-OnEnable",10); end
function SunnArt:OnProfileChanged() dprint("+OnProfileChanged",10); self:Reload(); dprint("-OnProfileChanged",10)end
function SunnArt:OnProfileCopied() dprint("+OnProfileCopied",10); self:Reload(); dprint("-OnProfileCopied",10); end
function SunnArt:OnProfileReset() dprint("+OnProfileReset",10); self:Reload(); dprint("-OnProfileReset",10);  end
function SunnArt:OnDisable() dprint("OnDisable",10); self:Disable(); dprint("-OnDisable",10); end

function SunnArt:ChatCommand(input)
	dprint("ChatCommand",10)
	if not input or input:trim() == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	else
		LibStub("AceConfigCmd-3.0").HandleCommand(SunnArt, "sa", "SunnArt", input)
	end
end

function SunnArt:Enable()
	dprint("+Enable",10)
	local temp
	if (not(self.dummyframe or self.frame1 or self.frame2 or self.frame3 or self.frame4)) then self:CreateFrames() end
	temp=self.dummyframe:GetTop()
	temp=self.dummyframe:GetBottom()
	temp=self.dummyframe:GetLeft()
	temp=self.dummyframe:GetRight()
	self:SetBars()
	temp=self.dummyframe:GetTop()
	temp=self.dummyframe:GetBottom()
	temp=self.dummyframe:GetLeft()
	temp=self.dummyframe:GetRight()
	self:SetViewport(self.db.profile.topbar,self.db.profile.bottombar,self.db.profile.leftbar,self.db.profile.rightbar,self:GetThemeOverlap())
	temp=self.dummyframe:GetTop()
	temp=self.dummyframe:GetBottom()
	temp=self.dummyframe:GetLeft()
	temp=self.dummyframe:GetRight()
	if (self.db.profile.artwork) then
		self.frame1:Show()
		self.frame2:Show()
		self.frame3:Show()
		self.frame4:Show()
	end
	temp=self.dummyframe:GetTop()
	temp=self.dummyframe:GetBottom()
	temp=self.dummyframe:GetLeft()
	temp=self.dummyframe:GetRight()
	self:UpdateViewport()
	temp=self.dummyframe:GetTop()
	temp=self.dummyframe:GetBottom()
	temp=self.dummyframe:GetLeft()
	temp=self.dummyframe:GetRight()
	SAVisible=true;
	if (BattlefieldMinimap) then
		BattlefieldMinimap:SetFrameStrata(self.db.profile.bfframestrata)
	end
	dprint("-Enable",10)
end

function SunnArt:CreateFrames()
	dprint("+CreateFrames",10)
	self.vertratio = UIParent:GetHeight()/100
	self.horizratio = UIParent:GetWidth()/100

	if (not self.dummyframe) then
		self.dummyframe = CreateFrame("Frame", "SunnArtDummyFrame")
		self.dummyframe:SetFrameStrata("BACKGROUND")
		self.dummyframe:EnableMouse(false)
		self.dummyframe:SetMovable(false)
	end
	if (not self.frame1) then
		self.frame1 = CreateFrame("Frame", "SunnArtFrameBottom")
		self.frame1:SetFrameStrata(self.db.profile.framestrata)
		self.frame1:SetFrameLevel(1)
		self.frame1:EnableMouse(false)
		self.frame1:SetMovable(false)
		self["art11"] = self.frame1:CreateTexture("$parentArt1","BACKGROUND")
		self["art12"] = self.frame1:CreateTexture("$parentArt2","BACKGROUND")
		self["art13"] = self.frame1:CreateTexture("$parentArt3","BACKGROUND")
	end
	if (not self.frame2) then
		self.frame2 = CreateFrame("Frame", "SunnArtFrameTop")
		self.frame2:SetFrameStrata(self.db.profile.framestrata)
		self.frame2:SetFrameLevel(1)
		self.frame2:EnableMouse(false)
		self.frame2:SetMovable(false)
		self["art21"] = self.frame2:CreateTexture("$parentArt1","BACKGROUND")
		self["art22"] = self.frame2:CreateTexture("$parentArt2","BACKGROUND")
		self["art23"] = self.frame2:CreateTexture("$parentArt3","BACKGROUND")
	end
	if (not self.frame3) then
		self.frame3 = CreateFrame("Frame", "SunnArtFrameLeft")
		self.frame3:SetFrameStrata(self.db.profile.framestrata)
		self.frame3:EnableMouse(false)
		self.frame3:SetMovable(false)
		self["art31"] = self.frame3:CreateTexture("$parentArt1","BACKGROUND")
		self["art32"] = self.frame3:CreateTexture("$parentArt2","BACKGROUND")
		self["art33"] = self.frame3:CreateTexture("$parentArt3","BACKGROUND")
	end
	if (not self.frame4) then
		self.frame4 = CreateFrame("Frame", "SunnArtFrameRight")
		self.frame4:SetFrameStrata(self.db.profile.framestrata)
		self.frame4:EnableMouse(false)
		self.frame4:SetMovable(false)
		self["art41"] = self.frame4:CreateTexture("$parentArt1","BACKGROUND")
		self["art42"] = self.frame4:CreateTexture("$parentArt2","BACKGROUND")
		self["art43"] = self.frame4:CreateTexture("$parentArt3","BACKGROUND")
	end
	dprint("-CreateFrames",10)
end

function SunnArt:SetViewport(topheight,bottomheight,leftwidth,rightwidth,olap)
	if (topheight==nil) then topheight=0 end
	if (bottomheight==nil) then bottomheight=0 end
	if (leftwidth==nil) then leftwidth=0 end
	if (rightwidth==nil) then rightwidth=0 end
	
	topheight=-topheight*self.vertratio
	bottomheight=bottomheight*self.vertratio
    leftwidth=leftwidth*self.horizratio
    rightwidth=-rightwidth*self.horizratio
	
	bottomheight=bottomheight-((self["art11"]:GetHeight()/100)*olap)
	topheight=topheight+((self["art21"]:GetHeight()/100)*olap)
	leftwidth=leftwidth-((self["art31"]:GetWidth()/100)*olap)
	rightwidth=rightwidth+((self["art41"]:GetWidth()/100)*olap)

	self.dummyframe:ClearAllPoints()
	self.dummyframe:SetPoint("TOPLEFT", leftwidth, topheight)
	self.dummyframe:SetPoint("BOTTOMRIGHT", rightwidth, bottomheight)
end

function SunnArt:SetBars()
	dprint("+SetBars",10)
	local temp
	local texturepath
	
	self.frame1:ClearAllPoints()
	self.frame1:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", -1, 0)
	self.frame1:SetPoint("TOPRIGHT",UIParent,"BOTTOMRIGHT",0,self.db.profile.bottombar*self.vertratio)
	
	self.frame2:ClearAllPoints()
	self.frame2:SetPoint("BOTTOMLEFT", UIParent, "TOPLEFT", -1, -self.db.profile.topbar*self.vertratio)
	self.frame2:SetPoint("TOPRIGHT",UIParent,"TOPRIGHT",0,0)
		
	actualheight=SunnArtFrameBottom:GetHeight()
	scaledheight=TextureMinHeight(SunnArtFrameBottom:GetWidth(),SunnArt.db.profile.bottomscale)
	if actualheight<scaledheight then bottomol=-(actualheight-scaledheight)*self:GetThemeOverlap()/100 else bottomol=0 end
	actualheight=SunnArtFrameTop:GetHeight()
	scaledheight=TextureMinHeight(SunnArtFrameTop:GetWidth(),SunnArt.db.profile.topscale)
	if actualheight<scaledheight then topol=-(actualheight-scaledheight)*self:GetThemeOverlap()/100 else topol=0 end
	
	self.frame3:ClearAllPoints()
	self.frame3:SetPoint("BOTTOMLEFT", self.frame1, "TOPLEFT", 0, -(self.frame1:GetHeight()*self:GetThemeOverlap()/100)-bottomol)
	self.frame3:SetPoint("TOPRIGHT",self.frame2,"BOTTOMLEFT",self.db.profile.leftbar*self.horizratio,(self.frame2:GetHeight()*self:GetThemeOverlap()/100)+topol)
	
	
	self.frame4:ClearAllPoints()
	self.frame4:SetPoint("BOTTOMLEFT", self.frame1, "TOPRIGHT", -self.db.profile.rightbar*self.horizratio, -(self.frame1:GetHeight()*self:GetThemeOverlap()/100)-bottomol)
	self.frame4:SetPoint("TOPRIGHT",self.frame2,"BOTTOMRIGHT",0,(self.frame2:GetHeight()*self:GetThemeOverlap()/100)+topol)
  
	for i=1,3 do
		texturepath="Interface\\Addons\\"..self.db.profile.Theme..i
		if not self.db.profile.rotatetop then
			if i==1 then texturepath2="Interface\\Addons\\"..self.db.profile.Theme.."3" end
			if i==2 then texturepath2="Interface\\Addons\\"..self.db.profile.Theme.."2" end
			if i==3 then texturepath2="Interface\\Addons\\"..self.db.profile.Theme.."1" end
		else
			texturepath2=texturepath
		end
		
		self["art1"..i]:SetWidth(SunnArtFrameBottom:GetWidth()/3)
		self["art1"..i]:SetHeight(SunnArtFrameBottom:GetHeight())
		if (self.db.profile.Theme ~= "solid") then self["art1"..i]:SetTexture(texturepath) else self["art1"..i]:SetTexture(self.db.profile.colourred,self.db.profile.colourgreen,self.db.profile.colourblue) end
		self["art1"..i]:ClearAllPoints()
		
		if self.db.profile.rotatetop then self["art2"..i]:SetTexCoord(1,1,1,0,0,1,0,0) else self["art2"..i]:SetTexCoord(0,0,0,1,1,0,1,1) end
		self["art2"..i]:SetWidth(SunnArtFrameTop:GetWidth()/3)
		self["art2"..i]:SetHeight(SunnArtFrameTop:GetHeight())
		if not self.db.profile.rotatetop then usetexture=texturepath2 else usetexture=texturepath end
		if (self.db.profile.Theme ~= "solid") then self["art2"..i]:SetTexture(usetexture) else self["art2"..i]:SetTexture(self.db.profile.colourred,self.db.profile.colourgreen,self.db.profile.colourblue) end
		self["art2"..i]:ClearAllPoints()
		
		self["art3"..i]:SetTexCoord(0,1,1,1,0,0,1,0)
		self["art3"..i]:SetWidth(SunnArtFrameLeft:GetWidth())
		self["art3"..i]:SetHeight(SunnArtFrameLeft:GetHeight()/3)
		if (self.db.profile.Theme ~= "solid") then self["art3"..i]:SetTexture(texturepath) else self["art3"..i]:SetTexture(self.db.profile.colourred,self.db.profile.colourgreen,self.db.profile.colourblue) end
		self["art3"..i]:ClearAllPoints()
		
		self["art4"..i]:SetTexCoord(1,0,0,0,1,1,0,1)
		self["art4"..i]:SetWidth(SunnArtFrameRight:GetWidth())
		self["art4"..i]:SetHeight(SunnArtFrameRight:GetHeight()/3)
		if (self.db.profile.Theme ~= "solid") then self["art4"..i]:SetTexture(texturepath) else self["art4"..i]:SetTexture(self.db.profile.colourred,self.db.profile.colourgreen,self.db.profile.colourblue) end
		self["art4"..i]:ClearAllPoints()
		
		if i == 1 then
			self["art1"..i]:SetPoint("TOPLEFT", self.frame1, "TOPLEFT", 0, 0)
			if self.db.profile.rotatetop then
				self["art2"..i]:SetPoint("BOTTOMRIGHT", self.frame2, "BOTTOMRIGHT", 0, 0)
			else
				actualheight=SunnArtFrameTop:GetHeight()
				scaledheight=TextureMinHeight(SunnArtFrameTop:GetWidth(),SunnArt.db.profile.topscale)
				if actualheight<scaledheight then topol=-(actualheight-scaledheight)*self:GetThemeOverlap()/100 else topol=0 end
				newtop=(self["art21"]:GetHeight()*self:GetThemeOverlap()/100)+topol
				if newtop<0 then newtop=0 end
				self["art2"..i]:SetPoint("BOTTOMRIGHT",self.frame2,"BOTTOMRIGHT",0,newtop)
			end
			self["art3"..i]:SetPoint("TOPRIGHT", self.frame3, "TOPRIGHT", 0, 0)
			self["art4"..i]:SetPoint("BOTTOMLEFT", self.frame4, "BOTTOMLEFT", 0, 0)
		else
			self["art1"..i]:SetPoint("TOPLEFT", self["art1"..i-1], "TOPRIGHT", 0, 0)
			self["art2"..i]:SetPoint("TOPRIGHT", self["art2"..i-1], "TOPLEFT", 0, 0)
			self["art3"..i]:SetPoint("TOPLEFT", self["art3"..i-1], "BOTTOMLEFT", 0, 0)
			self["art4"..i]:SetPoint("BOTTOMRIGHT", self["art4"..i-1], "TOPRIGHT", 0, 0)
		end
		
		temp=TextureMinHeight(SunnArtFrameBottom:GetWidth(),SunnArt.db.profile.bottomscale)
		if (SunnArtFrameBottom:GetHeight()<=temp or not self.db.profile.autostretchbottom) then self["art1"..i]:SetHeight(temp) end
		temp=TextureMinHeight(SunnArtFrameTop:GetWidth(),SunnArt.db.profile.topscale)
		if (SunnArtFrameTop:GetHeight()<=temp or not self.db.profile.autostretchtop) then self["art2"..i]:SetHeight(temp) end
		temp=TextureMinHeight(SunnArtFrameLeft:GetHeight(),SunnArt.db.profile.leftscale)
		if (SunnArtFrameLeft:GetWidth()<=temp or not self.db.profile.autostretchleft) then self["art3"..i]:SetWidth(temp) end
		temp=TextureMinHeight(SunnArtFrameRight:GetHeight(),SunnArt.db.profile.rightscale)
		if (SunnArtFrameRight:GetWidth()<=temp or not self.db.profile.autostretchright) then self["art4"..i]:SetWidth(temp) end
				
		if (SunnArtFrameBottom:GetHeight()~=0) then self["art1"..i]:Show() end
		if (SunnArtFrameTop:GetHeight()~=0) then self["art2"..i]:Show() end
		if (SunnArtFrameLeft:GetWidth()~=0) then self["art3"..i]:Show() end
		if (SunnArtFrameRight:GetWidth()~=0) then self["art4"..i]:Show() end
	end
	self.frame1:Hide()
	self.frame2:Hide()
	self.frame3:Hide()
	self.frame4:Hide()
	if (self.db.profile.artwork==true) then
		self.frame1:Show()
		self.frame2:Show()
		self.frame3:Show()
		self.frame4:Show()
	end
	self:UpdateAlpha()
	dprint("-SetBars",10)
end

function SunnArt:UpdatePanelSizes(panel, resize)
	dprint("+UpdatePanelSizes",10)
	-- Placeholder for next version
	dprint("-UpdatePanelSizes",10)
end

function SunnArt:UpdateArtwork(panel, theme, red, green, blue)
	dprint("+UpdateArtwork",10)
	-- Placeholder
	dprint("-UpdateArtwork",10)
end

function SunnArt:UpdatePanelVisibility(vis)
	dprint("+UpdatePanelVisibility",10)
	-- Placeholder
	dprint("-UpdatePanelVisibility",10)
end

function SunnArt:UpdateAlpha()
	SunnArtFrameBottom:SetAlpha(self.db.profile.bottomalpha)
	SunnArtFrameTop:SetAlpha(self.db.profile.topalpha)
	SunnArtFrameLeft:SetAlpha(self.db.profile.leftalpha)
	SunnArtFrameRight:SetAlpha(self.db.profile.rightalpha)
end


function SunnArt:UpdateViewport()
	dprint("+UpdateViewport",10)
	local ULx,ULy
	local LRx,LRy
	
	if (self.db.profile.leftviewport)  then ULx=0 else ULx=-SunnArtFrameLeft:GetWidth() end
	if (self.db.profile.rightviewport) then LRx=0 else LRx=SunnArtFrameRight:GetWidth() end
	if (self.db.profile.topviewport)   then ULy=0 else ULy=SunnArtFrameTop:GetHeight() end
	if (self.db.profile.bottomviewport) then LRy=0 else LRy=-SunnArtFrameBottom:GetHeight() end

	WorldFrame:ClearAllPoints()	
	WorldFrame:SetPoint("TOPLEFT", self.dummyframe, "TOPLEFT", ULx, ULy)
	WorldFrame:SetPoint("BOTTOMRIGHT", self.dummyframe, "BOTTOMRIGHT", LRx, LRy)
	dprint("-UpdateViewport",10)
end

function SunnArt:Disable()
	dprint("+Disable",10)
	if (self.frame1) then self.frame1:Hide() end
	if (self.frame2) then self.frame2:Hide() end
	if (self.frame3) then self.frame3:Hide() end
	if (self.frame4) then self.frame4:Hide() end
	
    if (self.db.profile.leftviewport or self.db.profile.rightviewport or self.db.profile.topviewport or self.db.profile.bottomviewport) then
		self:DisableViewport()
	end
	SAVisible=false;
	dprint("-Disable",10)
end

function SunnArt:DisableViewport()
	dprint("+DisableViewport",10)
	WorldFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)
	WorldFrame:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT",0,0)
	dprint("-DisableViewport",10)
end

function SunnArt:ToggleUI()
	dprint("+ToggleUI",10)
	if (UIParent:GetAlpha()~=0) then
		UIParent:SetAlpha(0)
		Minimap:Hide()
		SunnArt:Disable()
  	else
		UIParent:SetAlpha(1)
		Minimap:Show()
		SunnArt:Enable()
	end
	dprint("-ToggleUI",10)
end

function SunnArt:ImportOverlaps()
	dprint("+ImportOverlaps()",10)
	-- Placeholder
	dprint("-ImportOverlaps()",10)
end

function SunnArt:GetThemeOverlap(theme)
	temp=0
	if self.overlap==nil then
		temp=0
	else
		for name,value in pairs(self.overlap) do
			if name==self.db.profile.Theme then temp=value end
		end
	end
	return temp
end

function SunnArt:ChangeTheme(theme, panel)
	dprint("+ChangeTheme",10)
	--Placeholder
	dprint("-ChangeTheme",10)
end

function SunnArt:UpdateStrata()
	--Placeholder
end

function SunnArt:UpgradeVersion()
	dprint("+UpgradeVersion",10)
	--Placeholder
	dprint("-UpgradeVersion",10)
end

function SunnArt:PanelToggle(panel, enabled)
	--Placeholder
end

function SunnArt:GetThemeList()
	--Placeholder
end

function SunnArt:SetAll(name,value)
	--Placeholder
end

function SunnArt:GetAll(name)
	--Placeholder
end

function TextureMinHeight(Panelwidth,scale)
	local ret = 0
	ret=scale*Panelwidth/6
	return ret
end


function SunnArt:Reload()
	self:Disable()
	self:Enable()
end

-- Debug Functions
local OutCount = 0
local Indent = 0
local DebugLevel = 0

function dprint(dtext, dlevel)
	local indent
	local temp

	temp = string.find(dtext,"-",1,true) or 0
	if temp > 0 and temp < 2 then
		Indent = Indent - 1
		dtext = "} " .. string.sub(dtext,temp+1)
	end

	indent = string.rep("   ", Indent)

	temp = string.find(dtext,"+",1,true) or 0
	if temp > 0 and temp < 2 then
		Indent = Indent + 1
		dtext = string.sub(dtext,temp+1) .. " {"
	end

	if (dlevel == nil) then dlevel = 1 end
	OutCount = OutCount + 1
	if (DebugLevel >= dlevel) then
		DEFAULT_CHAT_FRAME:AddMessage(strconcat(indent,dtext,"   ",OutCount,":",string.len(indent)/3))
	end
end
-- end Debug Functions