﻿--[[
    Name:           Titan Microbuttons
	Description:	Titan Panel plugin for WOW Microbuttons
    Author:         Suddendeath2000
    Version:        3.3.7a
    ]]--
    
TPMicVersion = "3.3.7a"
TPMicC1 = "|cffffffff"
TPMicC2 = "|cffff9933"
TPMicC3 = "|cff00ff00"
TPMicC4 = "|cffffcc00"
TPMicC5 = "|cff666666"
TPMicTotAddon = 0

function TitanPanelMicrobuttonsButton_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage(TPMicC1..TPMicTP..TPMicC2.."["..TPMicID.."] "..TPMicC1.."v"..TPMicC2..TPMicVersion.." "..TPMicC1..TPMicBY.."|cff999999Suddendeath2000")
          
    self.registry = {
		id = TPMicID,
	    version = TPMicVersion,
        menuText = TPMicID,        
        category = "Information",
        tooltipTitle = TPMicC4..TPMicID,
        tooltipTextFunction = "TitanPanelMicrobuttonsButton_GetTooltipText",
	    icon = "Interface\\Addons\\TitanMicrobuttons\\TitanMicrobuttons",
        iconButtonWidth = 16,
        iconWidth = 16,        
        savedVariables = {
			ShowIcon = 1,			
	}}
    
    tinsert(TITAN_PANEL_NONMOVABLE_PLUGINS, TPMicID)
    
    TPMicBuild = GetBuildInfo()
    TPMicRealm = GetRealmName()
    TPMicLocale = GetLocale()        
    UpdateAddOnMemoryUsage()
    for i =  1, GetNumAddOns() do
      local mem = GetAddOnMemoryUsage(i)
      TPMicTotAddon = TPMicTotAddon + mem
  end
    if TPMicTotAddon > 0 then
      if TPMicTotAddon > 1000 then
        TPMicTotAddonMem = format(TPMicC4..TPMicTAM..TPMicC1.."%.2f MB", TPMicTotAddon/1000)
        else TPMicTotAddonMem = format(TPMicC4..TPMicTAM..TPMicC1.."%.0f KB", TPMicTotAddon)
    end
  end
   if GetAccountExpansionLevel() == 0 then TPMicExSet = TPMicOW
      elseif GetAccountExpansionLevel() == 1 then TPMicExSet = TPMicBC
        elseif GetAccountExpansionLevel() == 2 then TPMicExSet = TPMicWLK
          elseif GetAccountExpansionLevel() == 3 then TPMicExSet = TPMicCata
  end
    if IsLinuxClient() then TPMicClient = TPMicLinux
       elseif IsMacClient() then TPMicClient = TPMicMac
         elseif IsWindowsClient() then TPMicClient = TPMicWin
           else TPMicClient = TPMicUnknown
  end  
end

function TitanPanelMicrobuttonsButton_GetTooltipText()   
    TPMicFR = GetFramerate()   
    _, _, TPMicLag = GetNetStats()
    return TPMicC4..TPMicCurrent..TPMicC1..TPMicExSet.."\n"..TPMicC4..TPMicGameS..TPMicC1..TPMicBuild.."\n"..TPMicC4..TPMicClientS..TPMicC1..TPMicClient.."\n"..TPMicC4..TPMicLocaleS..TPMicC1..TPMicLocale.."\n"..TPMicC4..TPMicRealmS..TPMicC1..TPMicRealm.."\n"..TPMicC4..TPMicFrameS..TPMicC1..floor(TPMicFR).." fps\n"..TPMicC4..TPMicLatencyS..TPMicC1..TPMicLag.." ms\n"..TPMicTotAddonMem.."\n"..TPMicC4..TPMicRC..TPMicC3..TPMicDLC.."\n"..TPMicC3..TPMicSDLC
end   

function TitanPanelRightClickMenu_PrepareMicrobuttonsMenu(button)         
    local info = {}  
    
    if  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TPMicCF )then
  TitanPanelRightClickMenu_AddTitle(TPMicCF, UIDROPDOWNMENU_MENU_LEVEL)
  
        info.text = TPMicCharacter
		info.func = function () PlaySound("igMainMenuOption") ToggleCharacter("PaperDollFrame") end
  	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = TPMicPets
		info.func = function () PlaySound("igMainMenuOption") ToggleCharacter("PetPaperDollFrame") end        
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
        
        info.text = TPMicRep
		info.func = function () PlaySound("igMainMenuOption") ToggleCharacter("ReputationFrame") end
  	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = TPMicSkill
		info.func = function () PlaySound("igMainMenuOption") ToggleCharacter("SkillFrame") end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = TPMicCur
		info.func = function () PlaySound("igMainMenuOption") ToggleCharacter("TokenFrame") end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)  
        
    elseif  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TPMicSocial )then
  TitanPanelRightClickMenu_AddTitle(TPMicSocial, UIDROPDOWNMENU_MENU_LEVEL)
  
        info.text = TPMicFriend
		info.func = function () PlaySound("igMainMenuOption") ToggleFriendsFrame(1) end
  	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = TPMicWho
		info.func = function () PlaySound("igMainMenuOption") ToggleFriendsFrame(2) end        
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
        
        if (IsInGuild()) then
          info.text = TPMicGuild
		  info.func = function () PlaySound("igMainMenuOption") ToggleFriendsFrame(3) end
  	      UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end      
       
		info.text = TPMicChat
		info.func = function () PlaySound("igMainMenuOption") ToggleFriendsFrame(4) end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = TPMicRaid
		info.func = function () PlaySound("igMainMenuOption") ToggleFriendsFrame(5) end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
    elseif  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TPMicGame )then
  TitanPanelRightClickMenu_AddTitle(TPMicGame, UIDROPDOWNMENU_MENU_LEVEL)    
  
        info.text = TPMicVideo
		info.func = function () PlaySound("igMainMenuOption") VideoOptionsFrame:Show() end
  	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = TPMicSV
		info.func = function () PlaySound("igMainMenuOption") AudioOptionsFrame:Show() end        
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)        
        
        info.text = TPMicInterface
		info.func = function () PlaySound("igMainMenuOption") InterfaceOptionsFrame:Show()end
  	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        if (IsMacClient()) then
          info.text = TPMicMacOp
		  info.func = function () PlaySound("igMainMenuOption") HideUIPanel(GameMenuFrame) ShowUIPanel(MacOptionsFrame) end
  	      UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end        
       
		info.text = TPMicKeys
		info.func = function ()  PlaySound("igMainMenuOption") KeyBindingFrame_LoadUI() KeyBindingFrame.mode = 1 ShowUIPanel(KeyBindingFrame) GameMenuButtonContinue:Click() end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = TPMicMacro
		info.func = function () PlaySound("igMainMenuOption") ShowMacroFrame() end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        if IsAddOnLoaded("ACP") then
          info.text = TPMicACP
          info.func = function () ACP_AddonList:Show() end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end
        
        if (GetLocale() == "koKR") then
          info.text = TPMicKRM
		  info.func = function () PlaySound("igMainMenuOption") HideUIPanel(GameMenuFrame) ShowUIPanel(RatingMenuFrame) end
		  UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end      
        
    elseif  ( UIDROPDOWNMENU_MENU_LEVEL == 2 ) and ( UIDROPDOWNMENU_MENU_VALUE == TPMicUI )then
  TitanPanelRightClickMenu_AddTitle(TPMicUI, UIDROPDOWNMENU_MENU_LEVEL)

		info.text = TPMicRUI
		info.func = function () ReloadUI() end
  	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
       
		info.text = TPMicGraphics
		info.func = function () RestartGx() end
		UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)    

    else   
    
        TitanPanelRightClickMenu_AddTitle(TPMicID)
        TitanPanelRightClickMenu_AddSpacer()
        
        info = {}
        info.text = TPMicCF
        info.value = TPMicCF
        info.func = nil
        info.hasArrow = 1        
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

        info.text = TPMicSpellAbil
        info.hasArrow = nil
        info.func = function () PlaySound("igMainMenuOption") SpellBookFrame:Show() end        
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        if (UnitLevel("player") >= 10) then
          info.text = TPMicTalent
          info.hasArrow = nil
          info.func = function () PlaySound("igMainMenuOption") ToggleTalentFrame() end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)   
          
          else
          
          info.text = TPMicC5..TPMicTalent
          info.hasArrow = nil
          info.func = function () UIErrorsFrame:AddMessage("Must Be Level 10 to Access Talents") end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
  end
          
          if (UnitLevel("player") >= 10) or (GetTotalAchievementPoints() >= 1) then 
          info.text = TPMicAchieve
          info.hasArrow = nil
          info.func = function () PlaySound("igMainMenuOption") ToggleAchievementFrame() end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
                    
          else
          
          info.text = TPMicC5..TPMicAchieve
          info.hasArrow = nil
          info.func = function () UIErrorsFrame:AddMessage("Must Be Level 10 or Have Completed An Achievement to Access Achievements") end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL) 
  end
        
        info.text = TPMicQuest
        info.func = function () PlaySound("igMainMenuOption") QuestLogFrame:Show() end
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = TPMicSocial
        info.value = TPMicSocial
        info.func = nil
        info.hasArrow = 1        
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)

        
        if (UnitLevel("player") >= 10) then
          info.text = TPMicPVP
          info.hasArrow = nil
          info.func = function () PlaySound("igMainMenuOption") PVPParentFrame:Show() end
	      UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
          
          else
        
          info.text = TPMicC5..TPMicPVP
          info.hasArrow = nil
          info.func = function () UIErrorsFrame:AddMessage("Must Be Level 10 to Access Player vs. Player") end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end
        
        if (UnitLevel("player") >= 15) then
          info.text = TPMicDF
          info.hasArrow = nil
          info.func = function () PlaySound("igMainMenuOption") ToggleLFDParentFrame() end
	      UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
          
          else
        
          info.text = TPMicC5..TPMicDF
          info.hasArrow = nil
          info.func = function () UIErrorsFrame:AddMessage("Must Be Level 15 to Open Dungeon Finder")
          end
          UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end        
        
        info.text = TPMicGame
        info.value = TPMicGame
        info.func = nil
        info.hasArrow = 1        
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        info.text = TPMicHR
        info.hasArrow = nil   
        info.func = function () PlaySound("igMainMenuOption") ToggleHelpFrame() end        
	    UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
        TitanPanelRightClickMenu_AddSpacer()
     
        info.text = TPMicLogout
        info.func = function () PlaySound("igMainMenuOption") Logout() end
        UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
        
		info.text = TPMicQuit
		info.func = function () PlaySound("igMainMenuOption") ForceQuit() end
        UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)		
        
        TitanPanelRightClickMenu_AddSpacer()
        
        info = {}
        info.text = TPMicUI
        info.value = TPMicUI
        info.hasArrow = 1
        UIDropDownMenu_AddButton(info, UIDROPDOWNMENU_MENU_LEVEL)
  end
end

function TitanPanelMicrobuttonsButton_OnDoubleClick(button)    
    if button == "LeftButton" then 
      if IsShiftKeyDown() then FollowUnit("target")        
            else Screenshot()
    end     
  end
end

function TitanPanelMicrobuttonsButton_OnUpdate()      
    TitanPanelButton_UpdateButton(TPMicID)   
end