﻿--[[
    Name:           Titan Mount
	Description:	Titan Panel plugin for mounting.
	Author:         Suddendeath2000
	Version:        3.3i
    --]]

MountID = "Mount"
MountVersion = "3.3 Interim"
MountC1 = "|cffffffff"
MountC2 = "|cff993300"
MountC3 = "|cff00ff00"
MountC4 = "|cffffcc00"
MountC5 = "|cff999999"
mountIconShow = "-"
mountNameShow = "-"

function TitanPanelMountButton_OnLoad(self)
    DEFAULT_CHAT_FRAME:AddMessage(MountC1.."Titan Panel "..MountC2.."["..MountID.."] "..MountC1.."v"..MountC2..MountVersion.." "..MountC1.."by |cff999999Suddendeath2000")
    
    this:RegisterEvent("ADDON_LOADED")
    this:RegisterEvent("PLAYER_LOGOUT")
  
    self.registry = {
		id = MountID,
	    version = MountVersion,
        menuText = MountID,
        buttonTextFunction = "TitanPanelMountButton_GetButtonText",	
        category = "General",
        tooltipTitle = MountC4..MountID,
		tooltipTextFunction = "TitanPanelMountButton_GetTooltipText",
        iconButtonWidth = 16,
        iconWidth = 16,        
        savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1,  
            ShowTooltipText = 1,
            ShowMenuOptions = 1,
            ShowAdvancedMenus = 1,                
            }}     
end

function TitanPanelMountButton_GetButtonText(event)   
    local Button = TitanUtils_GetButton(MountID, true)
      _, mount, _, _, _ = GetCompanionInfo(MountID, 1)
    if mount == nil then mountName = "No Mounts Found"
                         mountIcon = "Interface\\Icons\\INV_Misc_QuestionMark"  
      elseif IsMounted() == nil then  mountName = "None"
                                      mountIcon = "Interface\\minimap\\TRACKING\\StableMaster"
        elseif IsMounted() == 1 and UnitOnTaxi("player") ~= 1 and mountNameShow == nil then mountName = "Please Dismount"  
                                                                                            mountIcon = "Interface\\minimap\\TRACKING\\StableMaster"
          elseif UnitOnTaxi("player") then mountName = "On Taxi"                                                                                  
                                           mountIcon = "Interface\\CURSOR\\taxi"                                                                                            
            elseif IsMounted() == 1 and UnitOnTaxi("player") ~= 1 and mountNameShow ~= nil then mountName = mountNameShow
                                                                                                mountIcon = mountIconShow
              else mountName = "-"
                   mountIcon = "Interface\\minimap\\TRACKING\\StableMaster"
  end
    if IsOutdoors() == nil then mountColor = MountC5                               
      else mountColor = MountC3
  end  
    Button.registry.icon = mountIcon  
    return "Mount: "..mountColor..mountName
end

function TitanPanelMountButton_GetTooltipText()
    if mount == nil then return MountC3.."Right-click for Mount Menu"
      elseif mountNameShow == nil then return MountC3.."Right-click for Mount Menu\n"..MountC3.."Double Left-click to Recall Last Mount"
        else 
		if IsMounted() then
		  return MountC3.."Right-click for Mount Menu\n"..MountC3.."Double Left-click to Dismount"
		    else
			  return MountC3.."Right-click for Mount Menu\n"..MountC3.."Double Left-click to Recall Last Mount\n"..GREEN_FONT_COLOR_CODE.."------------------------------------------------\nLast Mount Called: |cffffffff"..mountNameShow
	end
  end
end

function TitanPanelRightClickMenu_PrepareMountMenu()
      local info = {}
      
      TitanPanelRightClickMenu_AddTitle(MountID) 
      
      for i = 1, GetNumCompanions(MountID) do
         _, info.text, _, _, info.checked = GetCompanionInfo(MountID, i)
         info.func =  function () TitanPanelMountButton_MountToggle(MountID, i)
  end      
               
         UIDropDownMenu_AddButton(info,UIDROPDOWNMENU_MENU_LEVEL)
  end
         TitanPanelRightClickMenu_AddSpacer()
         
         TitanPanelRightClickMenu_AddToggleIcon(MountID)
end

 
function TitanPanelMountButton_MountToggle(MountID, i)
    if IsMounted() then Dismount()
      elseif mount ~= nil then CallCompanion(MountID, i)
  end   
    _, mountNameShow, _, mountIconShow, _ = GetCompanionInfo(MountID, i)      
      mountNumber = i
end

function TitanPanelMountButton_OnDoubleClick(button)
    if IsMounted() then Dismount()
      elseif button == "LeftButton" and mount ~= nil and mountNumber ~= nil then           
          CallCompanion(MountID, mountNumber)    
  end
end

function TitanPanelMountButton_OnEvent(event, arg1)         
    if event == "ADDON_LOADED" and arg1 == "TitanMount" then
      mountNameShow = mountNameOver
      mountIconShow = mountIconOver
      mountNumber = mountNumberOver
  end
    if event == "PLAYER_LOGOUT" then
      mountNameOver = mountNameShow
      mountIconOver = mountIconShow
      mountNumberOver = mountNumber
  end
end    

function TitanPanelMountButton_OnUpdate(self)         
    TitanPanelButton_UpdateButton(MountID)
end