local _, addon = ...

-- database of buff spells and reagents
addon.buffs = {
	DEATHKNIGHT = {
		{	-- Raise Dead
			spellIDs = {46584},
			reagentIDs = {37201},
		},
	},
	DRUID = {
		{	-- Gift of the Wild
			spellIDs = {21849},
			reagentIDs = {
				17021,	-- [1] Wild Berries
				17026,	-- [2] Wild Thornroot
				22148,	-- [3] Wild Quillvine
				44605,	-- [4] Wild Spineleaf
			},
		},
		{	-- Rebirth
			spellIDs = {20484},
			reagentIDs = {
				17034, -- [1] Maple Seed
				17035, -- [2] Stranglethorn Seed
				17036, -- [3] Ashwood Seed
				17037, -- [4] Hornbeam Seed
				17038, -- [5] Ironwood Seed
				22147, -- [6] Flintweed Seed
				44614, -- [7] Starleaf Seed
			},
		},
	},
	MAGE = {
		{	-- Arcane Brilliance
			spellIDs = {23028},
			reagentIDs = {17020},
		},
		{	-- Teleports
			spellIDs = {
				53140,	-- Dalaran
				33690,	-- Shattrath (Alliance)
				35715,	-- Shattrath (Horde)
				3561,	-- Stormwind
				3562,	-- Ironforge
				3565,	-- Darnassus
				32271,	-- Exodar
				3567,	-- Orgrimmar
				3563,	-- Undercity
				3566,	-- Thunder Bluff
				32272,	-- Silvermoon
			},
			reagentIDs = {17031},
		},
		{	-- Portals
			spellIDs = {
				53142,	-- Dalaran
				33691,	-- Shattrath
				35717,	-- Shattrath
				10059,	-- Stormwind
				11416,	-- Ironforge
				11419,	-- Darnassus
				32266,	-- Exodar
				11417,	-- Orgrimmar
				11418,	-- Undercity
				11420,	-- Thunder Bluff
				32267,	-- Silvermoon
				49360,	-- Theramore
				49361,	-- Stonard
			},
			reagentIDs = {17032},
		},
		{	-- Slow fall
			spellIDs = {130},
			reagentIDs = {17056},
		},
	},
	PALADIN = {
		{	-- Greater Blessings
			spellIDs = {
				25782,	-- Might
				25894,	-- Wisdom
			},
			reagentIDs = {21177},
		},
		{	-- Divine Intervention
			spellIDs = {19752},
			reagentIDs = {17033},
		},
	},
	PRIEST = {
		{	-- Prayer of Fortitude
			spellIDs = {21562},
			reagentIDs = {
				17028,	-- [1] Holy Candle
				17029,	-- [2] Sacred Candle
				17029,	-- [3]   -- "" --
				44615,	-- [4] Devout Candle
			},
		},
		{	-- Prayer of Shadow Protection
			spellIDs = {27683},
			reagentIDs = {
				17029,	-- [1] Sacred Candle
				17029,	-- [2]   -- "" --
				44615,	-- [3] Devout Candle
			},
		},
		{
			-- Levitate
			spellIDs = {1706},
			reagentIDs = {17056},
		}
	},
	SHAMAN = {
		{	-- Reincarnation
			spellIDs = {20608},
			reagentIDs = {17030},
		},
		{	-- Water breathing
			spellIDs = {131},
			reagentIDs = {17057},
		},
		{	-- Water walking
			spellIDs = {546},
			reagentIDs = {17058},
		},
	},
	WARLOCK = {
		{	-- Soul Shard
			spellIDs = {
				697,	-- Summon Voidwalker
				6201,	-- Create Healthstone
			},
			reagentIDs = {6265},
		},
		{	-- Inferno
			spellIDs = {1122},
			reagentIDs = {5565},
		},
		{	-- Ritual of Doom
			spellIDs = {18540},
			reagentIDs = {16583},
		},
	}
}