VUHDO_IN_COMBAT_RELOG = false;


VUHDO_RAID = { };
local VUHDO_RAID;

VUHDO_RAID_NAMES = { };
local VUHDO_RAID_NAMES = VUHDO_RAID_NAMES;

VUHDO_GROUPS = { };
local VUHDO_GROUPS = VUHDO_GROUPS;

VUHDO_RAID_GUIDS = { };
local VUHDO_RAID_GUIDS = VUHDO_RAID_GUIDS;

VUHDO_RAID_GUID_NAMES = { };
local VUHDO_RAID_GUID_NAMES = VUHDO_RAID_GUID_NAMES;

VUHDO_EMERGENCIES = { };
local VUHDO_EMERGENCIES = VUHDO_EMERGENCIES;

VUHDO_CLUSTER_BASE_RAID = { };
local VUHDO_CLUSTER_BASE_RAID = VUHDO_CLUSTER_BASE_RAID;

VUHDO_PLAYER_TARGETS = { };


local VUHDO_IS_SUSPICIOUS_ROSTER = false;

local VUHDO_RAID_SORTED = { };
local VUHDO_MAINTANKS = { };
local VUHDO_IS_RESURRECTING = false;


VUHDO_PLAYER_CLASS = nil;
VUHDO_PLAYER_NAME = nil;
VUHDO_PLAYER_RAID_ID = nil;

VUHDO_GLOBAL = getfenv();

-- BURST CACHE ---------------------------------------------------
local VUHDO_getUnitIds;
local VUHDO_getUnitNo;
local VUHDO_isInRange;
local VUHDO_determineDebuff;
local VUHDO_getUnitGroup;
local VUHDO_getPetUnit;
local VUHDO_tableUniqueAdd;
local VUHDO_getTargetUnit;
local VUHDO_updateHealthBarsFor;
local VUHDO_trimInspected;
local VUHDO_CONFIG;
local VUHDO_getUnitButtons;
local VUHDO_updatePlayerTargetFrame;
local VUHDO_getPlayerRaidUnit;
local VUHDO_getModelType;
local VUHDO_isConfigDemoUsers;

local GetRaidTargetIndex = GetRaidTargetIndex;
local UnitIsDeadOrGhost = UnitIsDeadOrGhost;
local UnitExists = UnitExists;
local UnitHealth = UnitHealth;
local UnitHealthMax = UnitHealthMax;
local string = string;
local UnitIsAFK = UnitIsAFK;
local UnitIsConnected = UnitIsConnected;
local UnitIsCharmed = UnitIsCharmed;
local UnitCanAttack = UnitCanAttack;
local GetNumRaidMembers = GetNumRaidMembers;
local UnitName = UnitName;
local UnitMana = UnitMana;
local UnitManaMax = UnitManaMax;
local UnitThreatSituation = UnitThreatSituation;
local UnitClass = UnitClass;
local UnitPowerType = UnitPowerType;
local UnitInVehicle = UnitInVehicle;
local UnitHasVehicleUI = UnitHasVehicleUI;
local UnitGroupRolesAssigned = UnitGroupRolesAssigned;
local GetRaidRosterInfo = GetRaidRosterInfo;
local table = table;
local UnitGUID = UnitGUID;
local tinsert = tinsert;
local tremove = tremove;
local strfind = strfind;
local gsub = gsub;
--local VUHDO_PANEL_MODELS;
local VUHDO_determineRole;
local VUHDO_getUnitHealthPercent;

function VUHDO_vuhdoInitBurst()
	VUHDO_CONFIG = VUHDO_GLOBAL["VUHDO_CONFIG"];
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_getUnitIds = VUHDO_GLOBAL["VUHDO_getUnitIds"];
	VUHDO_getUnitNo = VUHDO_GLOBAL["VUHDO_getUnitNo"];
	VUHDO_isInRange = VUHDO_GLOBAL["VUHDO_isInRange"];
	VUHDO_determineDebuff = VUHDO_GLOBAL["VUHDO_determineDebuff"];
	VUHDO_getUnitGroup = VUHDO_GLOBAL["VUHDO_getUnitGroup"];
	VUHDO_getPetUnit = VUHDO_GLOBAL["VUHDO_getPetUnit"];
	VUHDO_updateHealthBarsFor = VUHDO_GLOBAL["VUHDO_updateHealthBarsFor"];
	VUHDO_tableUniqueAdd = VUHDO_GLOBAL["VUHDO_tableUniqueAdd"];
	VUHDO_trimInspected = VUHDO_GLOBAL["VUHDO_trimInspected"];
	VUHDO_getTargetUnit = VUHDO_GLOBAL["VUHDO_getTargetUnit"];
	VUHDO_getModelType = VUHDO_GLOBAL["VUHDO_getModelType"];

	VUHDO_getUnitButtons = VUHDO_GLOBAL["VUHDO_getUnitButtons"];
	VUHDO_updatePlayerTargetFrame = VUHDO_GLOBAL["VUHDO_updatePlayerTargetFrame"];
	VUHDO_getPlayerRaidUnit = VUHDO_GLOBAL["VUHDO_getPlayerRaidUnit"];
	--VUHDO_PANEL_MODELS = VUHDO_GLOBAL["VUHDO_PANEL_MODELS"];
	VUHDO_determineRole = VUHDO_GLOBAL["VUHDO_determineRole"];
	VUHDO_getUnitHealthPercent = VUHDO_GLOBAL["VUHDO_getUnitHealthPercent"];
	VUHDO_isConfigDemoUsers = VUHDO_GLOBAL["VUHDO_isConfigDemoUsers"];
end

----------------------------------------------------



--
local tUnit, tInfo;
local function VUHDO_updateAllRaidNames()
	table.wipe(VUHDO_RAID_NAMES);

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if (tUnit ~= "focus") then
			-- ensure not to overwrite a player name with a pet's identical name
			if (VUHDO_RAID_NAMES[tInfo.name] == nil or not tInfo.isPet) then
				VUHDO_RAID_NAMES[tInfo.name] = tUnit;
			end
		end
	end
end



--
local tInfo;
local function VUHDO_isValidEmergency(aUnit)
	tInfo = VUHDO_RAID[aUnit];

	return
		not tInfo.dead
		and tInfo.connected
		and not tInfo.charmed
		and tInfo.range
		and not tInfo.isPet;
end




--
local tUnit;
local tIndex;
local function VUHDO_setTopEmergencies(aMaxAnz)
	table.wipe(VUHDO_EMERGENCIES);
	tIndex = 0;
	for _, tUnit in ipairs(VUHDO_RAID_SORTED) do
		if (VUHDO_isValidEmergency(tUnit)) then
			tIndex = tIndex + 1;
			VUHDO_EMERGENCIES[tUnit] = tIndex;
			if (tIndex == aMaxAnz) then
				break;
			end
		end
	end
end



--
local tInfoA, tInfoB;
local VUHDO_EMERGENCY_SORTERS = {
	[VUHDO_MODE_EMERGENCY_MOST_MISSING]
		= function(aUnit, anotherUnit)
				tInfoA = VUHDO_RAID[aUnit];
				tInfoB = VUHDO_RAID[anotherUnit];

				return (tInfoA.healthmax - tInfoA.health
							> tInfoB.healthmax - tInfoB.health);
			end,

	[VUHDO_MODE_EMERGENCY_PERC]
		= function(aUnit, anotherUnit)
				tInfoA = VUHDO_RAID[aUnit];
				tInfoB = VUHDO_RAID[anotherUnit];

					return (tInfoA.health / tInfoA.healthmax
								< tInfoB.health / tInfoB.healthmax);
			end,

	[VUHDO_MODE_EMERGENCY_LEAST_LEFT]
		= function(aUnit, anotherUnit)
				return VUHDO_RAID[aUnit].health < VUHDO_RAID[anotherUnit].health;
			end,
}



--
local tUnit, tInfo;
local function VUHDO_sortEmergencies()
	table.wipe(VUHDO_RAID_SORTED);

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if (VUHDO_getUnitHealthPercent(tInfo) < VUHDO_CONFIG["EMERGENCY_TRIGGER"]) then
			tinsert(VUHDO_RAID_SORTED, tUnit);
		end
	end

	table.sort(VUHDO_RAID_SORTED,	VUHDO_EMERGENCY_SORTERS[VUHDO_CONFIG["MODE"]]);
	VUHDO_setTopEmergencies(VUHDO_CONFIG["MAX_EMERGENCIES"]);
end



-- Avoid reordering sorting by max-health if someone dies or gets offline
local function VUHDO_getUnitSortMaxHp(aUnit)
	if (VUHDO_RAID[aUnit] ~= nil and VUHDO_RAID[aUnit].healthmax ~= nil and VUHDO_isInFight()) then
		return VUHDO_RAID[aUnit].healthmax;
	else
		return UnitHealthMax(aUnit);
	end
end



--
local VUHDO_UNIT_AFK_DC = { };
local tIsAfk;
local tIsConnected;
local function VUHDO_updateAfkDc(aUnit)
	tIsAfk = UnitIsAFK(aUnit);
	tIsConnected = UnitIsConnected(aUnit)
	if (tIsAfk or not tIsConnected) then
		if (VUHDO_UNIT_AFK_DC[aUnit] == nil) then
			VUHDO_UNIT_AFK_DC[aUnit] = GetTime();
		end
	else
		VUHDO_UNIT_AFK_DC[aUnit] = nil;
	end

	return tIsAfk, tIsConnected;
end



--
function VUHDO_getAfkDcTime(aUnit)
	return VUHDO_UNIT_AFK_DC[aUnit];
end



--
local tOwner;
function VUHDO_getOwner(aUnit, anIsPet)
	if (anIsPet) then
		tOwner = gsub(aUnit, "pet", "");
		if ("" == tOwner) then
			return "player";
		else
			return tOwner;
		end
	else
		return nil;
	end
end
local VUHDO_getOwner = VUHDO_getOwner;



--
local function VUHDO_isUnitCharmed(aUnit)
	return VUHDO_CONFIG["DETECT_DEBUFFS"] and UnitIsCharmed(aUnit) and UnitCanAttack("player", aUnit);
end



-- Sets a Member info into raid array
local tUnitId;
local tIsPet;
local tClassName;
local tPowerType;
local tIsAfk, tIsConnected;
local tIsOnVehicle;
local tLocalClass;
local tIsDead;
local tClassId;
local tInfo;
local tNewHealth;
local tName, tRealm;
local function VUHDO_setHealth(aUnit, aMode)

	tUnitId, _, _ = VUHDO_getUnitIds();
	tIsPet = strfind(aUnit, "pet", 1, true) ~= nil;

	if (strfind(aUnit, tUnitId, 1, true) ~= nil
			or tIsPet
			or aUnit == "player"
			or aUnit == "focus") then

		tIsDead = UnitIsDeadOrGhost(aUnit);
		if (tIsDead) then
			VUHDO_removeAllDebuffIcons(aUnit);
			VUHDO_removeHots(aUnit);
		end

		if (VUHDO_UPDATE_ALL == aMode) then
			tLocalClass, tClassName = UnitClass(aUnit);
			tPowerType = UnitPowerType(aUnit);
			tIsAfk, tIsConnected = VUHDO_updateAfkDc(aUnit);
			tIsOnVehicle = UnitInVehicle(aUnit) and UnitHasVehicleUI(aUnit);
			tClassId = VUHDO_CLASS_IDS[tClassName];

			if (tClassId == nil or (tIsPet and not VUHDO_USER_CLASS_COLORS.petClassColor)) then
				tClassId = VUHDO_ID_PETS;
			end

			if (VUHDO_RAID[aUnit] == nil) then
				VUHDO_RAID[aUnit] = { };
			end
			tName, tRealm = UnitName(aUnit);
			tInfo = VUHDO_RAID[aUnit];
			tInfo["healthmax"] = UnitHealthMax(aUnit);
			tInfo["health"] = UnitHealth(aUnit);
			tInfo["name"] = tName;
			tInfo["number"] = VUHDO_getUnitNo(aUnit);
			tInfo["unit"] = aUnit;
			tInfo["class"] = tClassName;
			tInfo["range"] = VUHDO_isInRange(aUnit);
			tInfo["debuff"], tInfo["debuffName"] = VUHDO_determineDebuff(aUnit, tClassName);
			tInfo["isPet"] = tIsPet;
			tInfo["powertype"] = tonumber(tPowerType);
			tInfo["power"] = UnitMana(aUnit);
			tInfo["powermax"] = UnitManaMax(aUnit);
			tInfo["charmed"] = VUHDO_isUnitCharmed(aUnit);
			tInfo["aggro"] = false;
			tInfo["group"] = VUHDO_getUnitGroup(aUnit, tIsPet);
			tInfo["dead"] = tIsDead;
			tInfo["afk"] = tIsAfk;
			tInfo["connected"] = tIsConnected;
			tInfo["threat"] = UnitThreatSituation(aUnit);
			tInfo["threatPerc"] = 0;
			tInfo["isVehicle"] = tIsOnVehicle;
			tInfo["ownerUnit"] = VUHDO_getOwner(aUnit, tIsPet);
			tInfo["className"] = tLocalClass or "";
			tInfo["petUnit"] = VUHDO_getPetUnit(aUnit);
			tInfo["targetUnit"] = VUHDO_getTargetUnit(aUnit);
			tInfo["classId"] = tClassId;
			tInfo["sortMaxHp"] = VUHDO_getUnitSortMaxHp(aUnit);
			tInfo["prole"], tInfo["srole"] = VUHDO_determineRole(aUnit);

			if (tRealm ~= nil and strlen(tRealm) > 0) then
				tInfo["fullName"] = tName .. "-" .. tRealm;
			else
				tInfo["fullName"] = tName;
			end
			tInfo["raidIcon"] = GetRaidTargetIndex(aUnit);
			--tInfo["missbuff"] = nil;
			--tInfo["mibucateg"] = nil;
			--tInfo["mibuvariants"] = nil;

			if (aUnit ~= "focus") then
				if (not tIsPet and tInfo["fullName"] == tName and VUHDO_RAID_NAMES[tName] ~= nil) then
					VUHDO_IS_SUSPICIOUS_ROSTER = true;
				end

				-- ensure not to overwrite a player name with a pet's identical name
				if (VUHDO_RAID_NAMES[tName] == nil or not tIsPet) then
					VUHDO_RAID_NAMES[tName] = aUnit;
				end
			end

		elseif (VUHDO_RAID[aUnit] ~= nil) then
			tInfo = VUHDO_RAID[aUnit];
			tIsAfk, tInfo["connected"] = VUHDO_updateAfkDc(aUnit);

			if(VUHDO_UPDATE_HEALTH == aMode) then
				tNewHealth = UnitHealth(aUnit);
				if (not tIsDead) then
					tInfo["lifeLossPerc"] = tNewHealth / tInfo.health;
				end

				tInfo.health = tNewHealth;

				if (tInfo.dead ~= tIsDead) then
					if (tInfo.dead and not tIsDead) then
						tInfo.healthmax = UnitHealthMax(aUnit);
					end
					tInfo.dead = tIsDead;
					VUHDO_updateHealthBarsFor(aUnit, VUHDO_UPDATE_ALIVE);
				end
			elseif(VUHDO_UPDATE_HEALTH_MAX == aMode) then
				tInfo.dead = tIsDead;
				tInfo.healthmax = UnitHealthMax(aUnit);
				tInfo.sortMaxHp = VUHDO_getUnitSortMaxHp(aUnit);
			elseif(VUHDO_UPDATE_DEBUFF == aMode) then
				tInfo.debuff, tInfo.debuffName = VUHDO_determineDebuff(aUnit, tInfo.class);
			elseif(VUHDO_UPDATE_AFK == aMode) then
				tInfo.afk = tIsAfk;
			end

		else -- Update fr unbekanntes Raid-Member? Lieber mal neu laden

			if (not VUHDO_isReloadPending()) then
				VUHDO_quickRaidReload();
			end

		end
	end
end



--
local function VUHDO_setHealthSafe(aUnit, aMode)
	if (not UnitExists(aUnit)) then
		return;
	end
	VUHDO_setHealth(aUnit, aMode);
end



-- Callback for UNIT_HEALTH / UNIT_MAXHEALTH events
local tUnit;
local tOwner;
local tInfo;
function VUHDO_updateHealth(aUnit, aMode)
	tInfo = VUHDO_RAID[aUnit];

	VUHDO_setHealth(aUnit, aMode);
	VUHDO_updateHealthBarsFor(aUnit, aMode);

	if (tInfo.isPet) then
		tOwner = tInfo.ownerUnit;
	else
		tOwner = nil;
	end

	if (tOwner ~= nil and VUHDO_RAID[tOwner].isVehicle) then
		VUHDO_setHealth(tOwner, aMode);
		VUHDO_updateHealthBarsFor(tOwner, aMode);
	end

	if (VUHDO_MODE_NEUTRAL ~= VUHDO_CONFIG["MODE"]
		and (VUHDO_UPDATE_HEALTH == aMode or VUHDO_UPDATE_HEALTH_MAX == aMode)) then
		-- Remove old emergencies
		VUHDO_FORCE_RESET = true;
		for tUnit, _ in pairs(VUHDO_EMERGENCIES) do
			VUHDO_updateHealthBarsFor(tUnit, VUHDO_UPDATE_EMERGENCY);
		end
		VUHDO_sortEmergencies();
		-- Set new Emergencies
		VUHDO_FORCE_RESET = false;
		for tUnit, _ in pairs(VUHDO_EMERGENCIES) do
			VUHDO_updateHealthBarsFor(tUnit, VUHDO_UPDATE_EMERGENCY);
		end
	end
end



--
local tUnit, tInfo;
function VUHDO_updateAllRaidTargetIndices()
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		tInfo.raidIcon = GetRaidTargetIndex(tUnit);
	end
end



-- Add to groups 1-8
local tOwnGroup;
local function VUHDO_addUnitToGroup(aUnit, aGroupNum)
	if (aUnit == VUHDO_PLAYER_RAID_ID and VUHDO_CONFIG["OMIT_SELF"]) then
		return;
	end

	tOwnGroup = VUHDO_getUnitGroup(VUHDO_PLAYER_RAID_ID, false);
	if (not VUHDO_CONFIG["OMIT_OWN_GROUP"] or aGroupNum ~= tOwnGroup) then
		if (VUHDO_GROUPS[aGroupNum] == nil) then
			VUHDO_GROUPS[aGroupNum] = { };
		end
		tinsert(VUHDO_GROUPS[aGroupNum], aUnit);
	end

	if (tOwnGroup == aGroupNum) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_GROUP_OWN], aUnit);
	end
end



--
local function VUHDO_addUnitToClass(aUnit, aClassId)
	if (aClassId == nil) then
		return;
	end

	tinsert(VUHDO_GROUPS[aClassId], aUnit);
end



--
local tModelId, tAllUnits, tIndex, tUnit;
local function VUHDO_removeUnitFromAllModelsBut(aUnit)
	for tModelId, tAllUnits in pairs(VUHDO_GROUPS) do
		if (tModelId ~= VUHDO_ID_MAINTANKS
			and tModelId ~= VUHDO_ID_PRIVATE_TANKS
			and tModelId ~= VUHDO_ID_MAIN_ASSISTS) then
			for tIndex, tUnit in ipairs(tAllUnits) do
				if (tUnit == aUnit) then
					tremove(tAllUnits, tIndex);
				end
			end
		end
	end
end



--
local function VUHDO_removeFromAllMainGroups()
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if (VUHDO_CONFIG["OMIT_MAIN_TANKS"] and VUHDO_isUnitInModel(tUnit, VUHDO_ID_MAINTANKS)) then
			VUHDO_removeUnitFromAllModelsBut(tUnit);
		elseif (VUHDO_CONFIG["OMIT_PLAYER_TARGETS"] and VUHDO_isUnitInModel(tUnit, VUHDO_ID_PRIVATE_TANKS)) then
			VUHDO_removeUnitFromAllModelsBut(tUnit);
		elseif (VUHDO_CONFIG["OMIT_MAIN_ASSIST"] and VUHDO_isUnitInModel(tUnit, VUHDO_ID_MAIN_ASSISTS)) then
			VUHDO_removeUnitFromAllModelsBut(tUnit);
		end
	end
end



--
local tRole, tIsTank;
local function VUHDO_addUnitToSpecial(aUnit)
	tIsTank, _, _ = UnitGroupRolesAssigned(aUnit);
	if (tIsTank and VUHDO_CONFIG["OMIT_DFT_MTS"]) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_MAINTANKS], aUnit);
	end

	if (GetNumRaidMembers() == 0) then
		return;
	end
	_, _, _, _, _, _, _, _, _, tRole, _ = GetRaidRosterInfo(VUHDO_getUnitNo(aUnit));

	-- MTs
	if ("MAINTANK" == tRole and not tIsTank) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_MAINTANKS], aUnit);
	end

	-- Main Assist
	if ("MAINASSIST" == tRole) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_MAIN_ASSISTS], aUnit);
	end
end



--
local tCnt;
local tUnit;
local function VUHDO_addUnitToCtraMainTanks()
	for tCnt = 1, VUHDO_MAX_MTS do
		tUnit = VUHDO_MAINTANKS[tCnt];
		if (tUnit ~= nil) then
			VUHDO_tableUniqueAdd(VUHDO_GROUPS[VUHDO_ID_MAINTANKS], tUnit)
		end
	end
end



--
local tUnit, tName;
local function VUHDO_addUnitToPrivateTanks()
	if (not VUHDO_CONFIG["OMIT_FOCUS"]) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_PRIVATE_TANKS], "focus");
	end

	for tName, _ in pairs(VUHDO_PLAYER_TARGETS) do
		tUnit = VUHDO_RAID_NAMES[tName];
		if (tUnit ~= nil) then
			VUHDO_tableUniqueAdd(VUHDO_GROUPS[VUHDO_ID_PRIVATE_TANKS], tUnit);
		else
			VUHDO_PLAYER_TARGETS[tName] = nil;
		end
	end
end



--
local tOwner;
local function VUHDO_addUnitToPets(aPetUnit)
	tOwner = VUHDO_RAID[aPetUnit].ownerUnit;
	if (tOwner == nil or not VUHDO_RAID[tOwner].isVehicle) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_PETS], aPetUnit);
	end
end



--
local tPrimaryRole, tSecondaryRole;
local function VUHDO_addUnitToRole(aUnit)
	tPrimaryRole = VUHDO_RAID[aUnit].prole;
	tSecondaryRole = VUHDO_RAID[aUnit].srole;

	if (tPrimaryRole ~= nil) then
		tinsert(VUHDO_GROUPS[tPrimaryRole], aUnit);
	end

	if (tSecondaryRole ~= nil) then
		tinsert(VUHDO_GROUPS[tSecondaryRole], aUnit);
	end
end



--
local tPetUnit;
local function VUHDO_addUnitToVehicles(aUnit)
	tPetUnit = VUHDO_RAID[aUnit].petUnit;
	if (tPetUnit ~= nil) then
		tinsert(VUHDO_GROUPS[VUHDO_ID_VEHICLES], tPetUnit);
	end
end



-- Get an empty array for each group
local tType, tTypeMembers, tMember;
local function VUHDO_initGroupArrays()
	table.wipe(VUHDO_GROUPS);

	for tType, tTypeMembers in pairs(VUHDO_ID_TYPE_MEMBERS) do
		for _, tMember in pairs(tTypeMembers) do
			VUHDO_GROUPS[tMember] = { };
		end
	end
end



--
local tUnit, tInfo;
local function VUHDO_updateGroupArrays()
	VUHDO_initGroupArrays();

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if ("focus" == tUnit) then
			VUHDO_addUnitToSpecial(tUnit);
		elseif (not tInfo.isPet) then
			VUHDO_addUnitToGroup(tUnit, tInfo.group);
			VUHDO_addUnitToClass(tUnit, tInfo.classId);
			VUHDO_addUnitToVehicles(tUnit);
			VUHDO_addUnitToSpecial(tUnit);
		else
			VUHDO_addUnitToPets(tUnit);
		end
	end
	tinsert(VUHDO_GROUPS[VUHDO_ID_SELF], VUHDO_PLAYER_RAID_ID);

	VUHDO_addUnitToCtraMainTanks();
	VUHDO_addUnitToPrivateTanks();

	-- Need MTs for role estimation
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if ("focus" ~= tUnit and not tInfo.isPet) then
			VUHDO_addUnitToRole(tUnit);
		end
	end
	VUHDO_removeFromAllMainGroups();
	VUHDO_initDynamicPanelModels();
end



--
local tGroup;
local tUnit;
local function VUHDO_isInSpecialGroup(aUnit, aModelId)
	tGroup = VUHDO_GROUPS[aModelId];
	if (tGroup ~= nil) then
		for _, tUnit in pairs(tGroup) do
			if (aUnit == tUnit) then
				return true;
			end
		end
	end

	return false;
end



--
local tModelType, tModelId, tSpecialModels;
function VUHDO_isUnitInModel(aUnit, aModelId)

	tModelType = VUHDO_getModelType(aModelId);

	if (VUHDO_ID_TYPE_GROUP == tModelType) then
		return aModelId == VUHDO_RAID[aUnit].group;
	elseif(VUHDO_ID_TYPE_CLASS == tModelType) then
		return aModelId == VUHDO_RAID[aUnit].classId;
	elseif(VUHDO_ID_VEHICLES == tModelType) then
		return strfind(aUnit, "PET", 1, true);
	else -- VUHDO_ID_TYPE_SPECIAL
		tSpecialModels = VUHDO_ID_TYPE_MEMBERS[VUHDO_ID_TYPE_SPECIAL];
		for _, tModelId in pairs(tSpecialModels) do
			if (tModelId == aModelId and VUHDO_isInSpecialGroup(aUnit, aModelId)) then
				return true;
			end
		end

		return false;
	end
end
local VUHDO_isUnitInModel = VUHDO_isUnitInModel;



--
local tModelId;
local function VUHDO_isUnitInPanel(aPanelNum, aUnit)
	for _, tModelId in pairs(VUHDO_PANEL_MODELS[aPanelNum]) do
		if (VUHDO_isUnitInModel(aUnit, tModelId)) then
			return true;
		end
	end

	return false;
end



--
local tIndex, tModelId;
function VUHDO_getPanelUnitFirstModel(aPanelNum, aUnit)
	for tIndex, tModelId in ipairs(VUHDO_PANEL_MODELS[aPanelNum]) do
		if (VUHDO_isUnitInModel(aUnit, tModelId)) then
			return tIndex;
		end
	end

	return 9999;
end



--
local tPanelModels;
local tModel;
local function VUHDO_isModelInPanel(aPanelNum, aModelId)
	tPanelModels = VUHDO_PANEL_MODELS[aPanelNum];
	for _, tModel in pairs(tPanelModels) do
		if (aModelId == tModel) then
			return true;
		end
	end

	return false;
end



-- Uniquely buffer all units defined in a panel
local tPanelUnits = { };
local tPanelNum;
local tHasVehicles;
local tVehicleUnit;
local tUnit;
local function VUHDO_updateAllPanelUnits()

	for tPanelNum = 1, VUHDO_MAX_PANELS do
		table.wipe(VUHDO_PANEL_UNITS[tPanelNum]);

		if (VUHDO_PANEL_MODELS[tPanelNum] ~= nil) then
			tHasVehicles = VUHDO_isModelInPanel(tPanelNum, VUHDO_ID_VEHICLES);
			table.wipe(tPanelUnits);
			for tUnit, _ in pairs(VUHDO_RAID) do
				if (VUHDO_isUnitInPanel(tPanelNum, tUnit)) then
					tPanelUnits[tUnit] = tUnit;
				end

				if (tHasVehicles and not VUHDO_RAID[tUnit].isPet) then
					tVehicleUnit =	VUHDO_RAID[tUnit].petUnit;
					if (tVehicleUnit ~= nil) then -- e.g. "focus"
						tPanelUnits[tVehicleUnit] = tVehicleUnit;
					end
				end
			end

			for tIndex, tUnit in pairs(tPanelUnits) do
				tinsert(VUHDO_PANEL_UNITS[tPanelNum], tUnit);
			end
		end
	end
end



--
local tGuid, tUnit, tInfo;
local function VUHDO_updateAllGuids()
	table.wipe(VUHDO_RAID_GUIDS);
	table.wipe(VUHDO_RAID_GUID_NAMES);
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		tGuid = UnitGUID(tUnit);
		if (tGuid ~= nil) then
			VUHDO_RAID_GUIDS[tGuid] = tUnit;
			VUHDO_RAID_GUID_NAMES[tGuid] = tInfo.name;
		end
	end
end



--
local tCnt, tName;
local function VUHDO_convertMainTanks()
	-- Discard deprecated
	for tCnt = 1, VUHDO_MAX_MTS do
		tName = VUHDO_MAINTANK_NAMES[tCnt];
		if (tName ~= nil and VUHDO_RAID_NAMES[tName] == nil) then
			VUHDO_MAINTANK_NAMES[tCnt] = nil;
		end
	end

	-- Convert to units instead of names
	table.wipe(VUHDO_MAINTANKS);
	for tCnt, tName in pairs(VUHDO_MAINTANK_NAMES) do
		VUHDO_MAINTANKS[tCnt] = VUHDO_RAID_NAMES[tName];
	end
end



--
local tUnit, tInfo;
local function VUHDO_createIndexedUnits()
	table.wipe(VUHDO_CLUSTER_BASE_RAID);
	VUHDO_resetClusterCoordDeltas();

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if (not tInfo.isPet -- won't work for pets
				and "focus" ~= tUnit) then

			tinsert(VUHDO_CLUSTER_BASE_RAID, tInfo);
		end
	end
end



--
-- Reload all raid members into the raid array e.g. in case of raid roster change
local i;
local tPlayer, tPet;
local tMaxMembers;
local tUnit, tPetUnit;

function VUHDO_reloadRaidMembers()
	if (not UnitExists("player")) then
		VUHDO_IN_COMBAT_RELOG = true;
		VUHDO_updateAllRaidNames();
		-- Do nothing raid roster is not known yet
	elseif (VUHDO_isConfigDemoUsers()) then
		VUHDO_reloadRaidDemoUsers();
		VUHDO_updateAllRaidNames();
	else
		VUHDO_IN_COMBAT_RELOG = false;
		tUnit, tPetUnit = VUHDO_getUnitIds();

		if ("raid" == tUnit) then
			tMaxMembers = 40;
		elseif ("party" == tUnit) then
			tMaxMembers = 5;
		else
			tMaxMembers = 0;
		end

		table.wipe(VUHDO_RAID);
		table.wipe(VUHDO_RAID_NAMES);
		VUHDO_IS_SUSPICIOUS_ROSTER = false;

		if (tMaxMembers > 0) then
			for i = 1, tMaxMembers do
				tPlayer = tUnit .. i;
				if (UnitExists(tPlayer)) then
					VUHDO_setHealth(tPlayer, VUHDO_UPDATE_ALL);

					tPet = tPetUnit .. i;
					VUHDO_setHealthSafe(tPet, VUHDO_UPDATE_ALL);
				end
			end

			if ("party" == tUnit) then
				VUHDO_setHealthSafe("player", VUHDO_UPDATE_ALL);
				VUHDO_setHealthSafe("playerpet", VUHDO_UPDATE_ALL);
			end
		else
			VUHDO_setHealthSafe(tUnit, VUHDO_UPDATE_ALL);
			VUHDO_setHealthSafe(tPetUnit, VUHDO_UPDATE_ALL);
		end

		VUHDO_setHealthSafe("focus", VUHDO_UPDATE_ALL);

		if (VUHDO_IS_SUSPICIOUS_ROSTER) then
			--VUHDO_Msg("Suspicious raid roster, reloading...");
			VUHDO_normalRaidReload();
		end

		VUHDO_PLAYER_RAID_ID = VUHDO_getPlayerRaidUnit();
	end

	--VUHDO_RAID_NAMES["player"] = VUHDO_PLAYER_NAME;

	VUHDO_trimInspected();
	VUHDO_convertMainTanks();
	VUHDO_updateGroupArrays();
	VUHDO_updateAllPanelUnits();
	VUHDO_updateAllGuids();
	VUHDO_updateBuffRaidGroup();
	VUHDO_updateBuffPanel();
	VUHDO_sortEmergencies();
	VUHDO_createIndexedUnits();
end



--
function VUHDO_spellcastStop(aUnit)
	if ("player" ~= aUnit) then
		return;
	end
	if (VUHDO_IS_RESURRECTING) then
		VUHDO_sendCtraMessage("RESNO");
		VUHDO_IS_RESURRECTING = false;
	end
end
local VUHDO_spellcastStop = VUHDO_spellcastStop;



--
function VUHDO_spellcastFailed(aUnit, aSpellName)
	VUHDO_spellcastStop(aUnit, aSpellName);
end



--
local function VUHDO_activateSpellForSpec(aSpecId)
	local tName = VUHDO_SPEC_LAYOUTS[aSpecId];
	if (tName ~= nil and strlen(tName) > 0) then
		VUHDO_Msg("Specc change to #" .. aSpecId .. " detected.");

		if (VUHDO_SPELL_LAYOUTS[tName] ~= nil) then
			VUHDO_activateLayout(tName);
		else
			VUHDO_Msg("Spell layout \"" .. tName .. "\" doesn't exist.", 1, 0.4, 0.4);
		end
	end
end



--
local function VUHDO_activateSpecc(aSpeccNum)
	VUHDO_activateSpellForSpec("" .. aSpeccNum);
end



--
function VUHDO_spellcastSucceeded(aUnit, aSpellName)
	if (aUnit ~= nil and (VUHDO_SPELL_ID_ACTIVATE_FIRST_TALENT == aSpellName
		or VUHDO_SPELL_ID_ACTIVATE_SECOND_TALENT == aSpellName)) then
		VUHDO_resetTalentScan(aUnit);
		VUHDO_timeReloadUI(3);
	end

	if ("player" ~= aUnit) then
		return;
	end

	if (VUHDO_SPELL_ID_ACTIVATE_FIRST_TALENT == aSpellName) then
		VUHDO_activateSpecc(1);
	elseif (VUHDO_SPELL_ID_ACTIVATE_SECOND_TALENT == aSpellName) then
		VUHDO_activateSpecc(2);
	end
end



--
local tTargetUnit;
local tFirstRes, tSecondRes;
local tUniqueSpells = nil;
local tUniqueCategs;
local tSpellName;
local tCateg;
local tText;
function VUHDO_spellcastSent(aUnit, aSpellName, aSpellRank, aTargetName)
	if ("player" ~= aUnit or aTargetName == nil) then
		return;
	end

	if (VUHDO_IS_GCD_SET and VUHDO_CONFIG["IS_SHOW_GCD"]) then
		VUHDO_initGcd();
	end

	aTargetName = string.match(aTargetName, "^[^-]*");
	tTargetUnit = VUHDO_RAID_NAMES[aTargetName];

	-- Resurrection?
	tFirstRes, tSecondRes = VUHDO_getResurrectionSpells();
	if ((aSpellName == tFirstRes or aSpellName == tSecondRes) and aTargetName ~= nil) then
		VUHDO_sendCtraMessage("RES " .. aTargetName);
		VUHDO_IS_RESURRECTING = true;

		if (VUHDO_CONFIG["RES_IS_SHOW_TEXT"]) then
			tText = gsub(VUHDO_CONFIG["RES_ANNOUNCE_TEXT"], "vuhdo", aTargetName);

			if (GetNumRaidMembers() > 0) then
				SendChatMessage(tText, "RAID", nil, nil);
			elseif (GetNumPartyMembers() > 0) then
				SendChatMessage(tText, "PARTY", nil, nil);
			else
				SendChatMessage(tText, "WHISPER", nil, aTargetName);
			end
		end
		return;
	end

	-- Auto track single target unique spells?
	if (tUniqueSpells == nil) then
		tUniqueSpells = { };

		local tUnique, tUniqueCategs = VUHDO_getAllUniqueSpells();
		for _, tSpellName in pairs(tUnique) do
			tUniqueSpells[tSpellName] = tUniqueCategs[tSpellName];
		end
	end

	tCateg = tUniqueSpells[aSpellName];
	if (tCateg ~= nil and tTargetUnit ~= nil and not VUHDO_isInFight()) then
		if (VUHDO_BUFF_SETTINGS ~= nil and VUHDO_BUFF_SETTINGS[tCateg] ~= nil and aTargetName ~= VUHDO_BUFF_SETTINGS[tCateg].name) then
			VUHDO_Msg(VUHDO_I18N_SET_BUFF_TARGET_1 .. tCateg .. VUHDO_I18N_SET_BUFF_TARGET_2 .. aTargetName);
			VUHDO_BUFF_SETTINGS[tCateg].name = aTargetName;
			VUHDO_reloadBuffPanel();
		end
	end
end



--
local VUHDO_CURR_PLAYER_TARGET = nil;
local tTargetUnit;
local tAllButtons, tButton;
function VUHDO_updatePlayerTarget()
	if (VUHDO_CURR_PLAYER_TARGET ~= nil) then
		tAllButtons = VUHDO_getUnitButtons(VUHDO_CURR_PLAYER_TARGET);
		if (tAllButtons ~= nil) then
			for _, tButton in pairs(tAllButtons) do
				VUHDO_updatePlayerTargetFrame(VUHDO_getPlayerTargetFrame(tButton), VUHDO_CURR_PLAYER_TARGET);
			end
		end
	end

	tTargetUnit = VUHDO_RAID_NAMES[UnitName("target")];

	if (VUHDO_CONFIG["PLAYER_TARGET_FRAME"]) then
		if (tTargetUnit ~= nil) then
			tAllButtons =  VUHDO_UNIT_BUTTONS[tTargetUnit];
			if (tAllButtons ~= nil) then
				for _, tButton in pairs(tAllButtons) do
					VUHDO_updatePlayerTargetFrame(VUHDO_getPlayerTargetFrame(tButton), tTargetUnit);
				end
			end
		end
	end

	VUHDO_CURR_PLAYER_TARGET = tTargetUnit;
end
