local VUHDO_HIGLIGHT_CLUSTER = { };
local VUHDO_ICON_CLUSTER = { };
local sClusterConfig;

local VUHDO_CLUSTER_UNIT = nil;

--
local tinsert = tinsert;
local table = table;

local VUHDO_GLOBAL = getfenv();

local VUHDO_BUTTON_CACHE = { };
local VUHDO_PANEL_SETUP = { };
local VUHDO_CONFIG = { };
local VUHDO_RAID = { };

local VUHDO_getUnitsInRadialClusterWith
local VUHDO_getUnitButtons;
local VUHDO_getHealthBar;
local VUHDO_getClusterBorderFrame;
function VUHDO_customClustersInitBurst()
  VUHDO_BUTTON_CACHE = VUHDO_GLOBAL["VUHDO_BUTTON_CACHE"];
  VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];
  VUHDO_CONFIG = VUHDO_GLOBAL["VUHDO_CONFIG"];
  VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];

  VUHDO_getUnitsInRadialClusterWith = VUHDO_GLOBAL["VUHDO_getUnitsInRadialClusterWith"];
  VUHDO_getUnitButtons = VUHDO_GLOBAL["VUHDO_getUnitButtons"];
  VUHDO_getHealthBar = VUHDO_GLOBAL["VUHDO_getHealthBar"];
  VUHDO_getClusterBorderFrame = VUHDO_GLOBAL["VUHDO_getClusterBorderFrame"];

  sClusterConfig = VUHDO_CONFIG["CLUSTER"];
end



--
local tPanelNum;
local tHotSlots;
local tHotName;
local tIndex;
local tPrefix, tIcon, tTimer;
local tColor;
local function VUHDO_customizeClusterIcons(aButton, aNumLow, anInfo)
	tPanelNum = VUHDO_BUTTON_CACHE[aButton:GetName()];
	tHotSlots = VUHDO_PANEL_SETUP[tPanelNum]["HOTS"]["SLOTS"];

	for tIndex, tHotName in pairs(tHotSlots) do
		if ("CLUSTER" == tHotName) then
			tPrefix = VUHDO_getHealthBar(aButton, 1):GetName() .. "Ic" .. tIndex;
			tIcon = VUHDO_GLOBAL[tPrefix .. "I"];
			tTimer = VUHDO_GLOBAL[tPrefix .. "T"];

		  if (aNumLow < sClusterConfig["THRESH_FAIR"] or not anInfo.range) then
		    tIcon:Hide();
		    tTimer:SetText("");
		  else
  		  if (aNumLow < sClusterConfig["THRESH_GOOD"]) then
  		    tColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["CLUSTER_FAIR"];
  		  else
  		    tColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["CLUSTER_GOOD"];
  		  end

		    tIcon:SetVertexColor(tColor.R, tColor.G, tColor.B, tColor.O);
		    tIcon:Show();
		    if (sClusterConfig["IS_NUMBER"]) then
  		    tTimer:SetText(aNumLow);
		    end
		  end
		end
	end
end



--
local tDestCluster = { };
local tHealthLimit, tInfo, tSrcInfo, tIsRaid;
local function VUHDO_getDestCluster(aUnit, anArray)
  table.wipe(anArray);
  if (sClusterConfig["DISPLAY_SOURCE"] == 1 and aUnit ~= VUHDO_PLAYER_RAID_ID) then
    return anArray;
  end

	tSrcInfo = VUHDO_RAID[aUnit];
	if (tSrcInfo == nil or tSrcInfo.isPet or "focus" == aUnit) then
    return anArray;
	end

  if (sClusterConfig["MODE"] == 1) then
  	VUHDO_getUnitsInRadialClusterWith(aUnit, sClusterConfig["RANGE"], tDestCluster);
  else
  	VUHDO_getUnitsInChainClusterWith(aUnit, sClusterConfig["RANGE"], tDestCluster, sClusterConfig["CHAIN_MAX_JUMP"]);
  end

  tHealthLimit = sClusterConfig["BELOW_HEALTH_PERC"] * 0.01;
  tIsRaid = sClusterConfig["DISPLAY_DESTINATION"] == 2;
  for _, tUnit in ipairs(tDestCluster) do
    tInfo = VUHDO_RAID[tUnit];
    if (tInfo ~= nil and tInfo.health / tInfo.healthmax <= tHealthLimit) then
			if (tIsRaid or tInfo.group == tSrcInfo.group) then -- all raid members or in same group
      	tinsert(anArray, tUnit);
      end
    end
  end

  return anArray;
end



--
local tInfo, tCluster, tNumLow;
local tAllButtons, tButton, tInfo;
function VUHDO_updateAllClusterIcons(aUnit)
	tAllButtons = VUHDO_getUnitButtons(aUnit);
	tInfo = VUHDO_RAID[aUnit];
	if (tAllButtons == nil or tInfo == nil) then
		return;
	end

  tNumLow = #VUHDO_getDestCluster(aUnit, VUHDO_ICON_CLUSTER);
	for _, tButton in pairs(tAllButtons) do
    VUHDO_customizeClusterIcons(tButton, tNumLow, tInfo);
	end
end



--
local tUnit;
local tAllButtons, tButton;
function VUHDO_removeAllClusterHighlights()
  for _, tUnit in pairs(VUHDO_HIGLIGHT_CLUSTER) do
    tAllButtons = VUHDO_getUnitButtons(tUnit);
    if (tAllButtons ~= nil) then
      for _, tButton in pairs(tAllButtons) do
        VUHDO_getClusterBorderFrame(tButton):Hide();
      end
    end
  end

  table.wipe(VUHDO_HIGLIGHT_CLUSTER);
end
local VUHDO_removeAllClusterHighlights = VUHDO_removeAllClusterHighlights;



--
local tUnit, tAllButtons, tButton;
local tClusterBorder;
function VUHDO_highlightClusterFor(aUnit)
	VUHDO_CLUSTER_UNIT = aUnit;
  if (#VUHDO_HIGLIGHT_CLUSTER ~= 0) then
    VUHDO_removeAllClusterHighlights();
  end

  VUHDO_getDestCluster(aUnit, VUHDO_HIGLIGHT_CLUSTER);

  if (#VUHDO_HIGLIGHT_CLUSTER < sClusterConfig["THRESH_FAIR"]) then
    tColor = nil;
  else
	  tColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["CLUSTER_BORDER"];
	end

  for _, tUnit in pairs(VUHDO_HIGLIGHT_CLUSTER) do
    tAllButtons = VUHDO_getUnitButtons(tUnit);
    if (tAllButtons ~= nil) then
      for _, tButton in pairs(tAllButtons) do
        tClusterBorder = VUHDO_getClusterBorderFrame(tButton);
        if (tColor == nil) then
          tClusterBorder:Hide();
        else
          tClusterBorder:SetBackdropBorderColor(tColor.R, tColor.G, tColor.B, tColor.O);
          tClusterBorder:Show();
        end
      end
    end
  end

end



--
function VUHDO_updateClusterHighlights()
	if (VUHDO_CLUSTER_UNIT ~= nil) then
		VUHDO_removeAllClusterHighlights();
		VUHDO_highlightClusterFor(VUHDO_CLUSTER_UNIT);
	end
end



--
function VUHDO_resetClusterUnit()
  VUHDO_CLUSTER_UNIT = nil;
end
