
VUHDO_FORCE_RESET = false;


-- BURST CACHE ---------------------------------------------------

local VUHDO_getHealthBar;
local VUHDO_getBarText;
local VUHDO_getIncHealOnUnit;
local VUHDO_getDiffColor;
local VUHDO_isPanelVisible;
local VUHDO_getUnitHealthPercent;
local VUHDO_getUnitButtons;
local VUHDO_updateManaBars;
local VUHDO_updateTargetBars;
local VUHDO_updateAllHoTs;
local VUHDO_removeAllHots;
local VUHDO_getUnitHealthPercent;
local VUHDO_updatePlayerTargetFrame;
local VUHDO_getDebuffColor;
local VUHDO_getPanelButtons;

local VUHDO_PANEL_SETUP;
local VUHDO_BUTTON_CACHE;
local VUHDO_RAID;
local VUHDO_CONFIG;
local VUHDO_BAR_COLOR;
local VUHDO_THREAT_CFG;
local VUHDO_USER_CLASS_COLORS;
local VUHDO_UNIT_BUTTONS;
local VUHDO_IN_RAID_TARGET_BUTTONS;
local VUHDO_RAID_NAMES;
--local VUHDO_EMERGENCIES;

local abs = abs;
local floor = floor;
local strlen = strlen;
local strsub = strsub;
local strfind = strfind;
local GetRaidTargetIndex = GetRaidTargetIndex;
local tostring = tostring;

local sGoodR, sGoodG, sGoodB;
local sFairR, sFairG, sFairB;
local sLowR, sLowG, sLowB;

function VUHDO_customHealthInitBurst()
  -- variables
	VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];
	VUHDO_BUTTON_CACHE = VUHDO_GLOBAL["VUHDO_BUTTON_CACHE"];
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_CONFIG = VUHDO_GLOBAL["VUHDO_CONFIG"];
	VUHDO_USER_CLASS_COLORS = VUHDO_GLOBAL["VUHDO_USER_CLASS_COLORS"];
	VUHDO_UNIT_BUTTONS = VUHDO_GLOBAL["VUHDO_UNIT_BUTTONS"];
--	VUHDO_EMERGENCIES = VUHDO_GLOBAL["VUHDO_EMERGENCIES"];
 	VUHDO_BAR_COLOR = VUHDO_PANEL_SETUP["BAR_COLORS"];
 	VUHDO_THREAT_CFG = VUHDO_CONFIG["THREAT"];
 	VUHDO_RAID_NAMES = VUHDO_GLOBAL["VUHDO_RAID_NAMES"];
 	VUHDO_IN_RAID_TARGET_BUTTONS = VUHDO_GLOBAL["VUHDO_IN_RAID_TARGET_BUTTONS"];

	sGoodR, sGoodG, sGoodB
		= VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["GOOD"].R,
			VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["GOOD"].G,
			VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["GOOD"].B;

	sFairR, sFairG, sFairB
		= VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["FAIR"].R,
		  VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["FAIR"].G,
		  VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["FAIR"].B;

	sLowR, sLowG, sLowB
		= VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["LOW"].R,
		  VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["LOW"].G,
		  VUHDO_PANEL_SETUP["BAR_COLORS"]["LIFE_LEFT"]["LOW"].B;

 	-- functions
	VUHDO_getHealthBar = VUHDO_GLOBAL["VUHDO_getHealthBar"];
	VUHDO_getBarText = VUHDO_GLOBAL["VUHDO_getBarText"];
	VUHDO_getIncHealOnUnit = VUHDO_GLOBAL["VUHDO_getIncHealOnUnit"];
	VUHDO_getDiffColor = VUHDO_GLOBAL["VUHDO_getDiffColor"];
	VUHDO_isPanelVisible = VUHDO_GLOBAL["VUHDO_isPanelVisible"];
	VUHDO_getUnitHealthPercent = VUHDO_GLOBAL["VUHDO_getUnitHealthPercent"];
	VUHDO_getUnitButtons = VUHDO_GLOBAL["VUHDO_getUnitButtons"];
	VUHDO_updateManaBars = VUHDO_GLOBAL["VUHDO_updateManaBars"];
	VUHDO_updateTargetBars = VUHDO_GLOBAL["VUHDO_updateTargetBars"];
	VUHDO_removeAllHots = VUHDO_GLOBAL["VUHDO_removeAllHots"];
	VUHDO_updateAllHoTs = VUHDO_GLOBAL["VUHDO_updateAllHoTs"];
	VUHDO_getUnitHealthPercent = VUHDO_GLOBAL["VUHDO_getUnitHealthPercent"];
	VUHDO_updatePlayerTargetFrame = VUHDO_GLOBAL["VUHDO_updatePlayerTargetFrame"];
	VUHDO_getDebuffColor = VUHDO_GLOBAL["VUHDO_getDebuffColor"];
	VUHDO_getPanelButtons = VUHDO_GLOBAL["VUHDO_getPanelButtons"];
end

----------------------------------------------------



local tIncColor = { ["useBackground"] = true };


--
local function VUHDO_getUnitHealthModiPercent(anInfo, aModifier)
	if (anInfo.healthmax == 0) then
		return 0;
	else
		return 100 * (anInfo.health + aModifier) / anInfo.healthmax;
	end
end



--
local tOpacity;
local function VUHDO_setStatusBarColor(aBar, aColor)
	if (aColor.useOpacity) then
		tOpacity = aColor.O;
	else
		tOpacity = nil;
	end

	if (aColor.useBackground) then
		aBar:SetStatusBarColor(aColor.R, aColor.G, aColor.B, tOpacity);
	elseif (tOpacity ~= nil) then
		aBar:SetAlpha(tOpacity);
	end
end



--
local tFactor;
local tR1, tG1, tB1;
local tR2, tG2, tB2;
local tModi, tInvModi;
local tColor = {
	["useBackground"] = true,
	["useOpacity"] = true,
};
local function VUHDO_getLifeLeftColor(aPercent)
	tFactor = (aPercent * 0.01) ^ 1.7;

	tModi, tInvModi = tFactor * 2, 0;
	if( tFactor > 0.5 ) then
		tR1, tG1, tB1 = sGoodR, sGoodG, sGoodB;
		tR2, tG2, tB2 = sFairR, sFairG, sFairB;
		tModi = tModi - 1;
	else
		tR1, tG1, tB1	= sFairR, sFairG, sFairB;
		tR2, tG2, tB2 = sLowR, sLowG, sLowB;
	end

	tInvModi = 1 - tModi;
	tColor.R = tR2 * tInvModi + tR1 * tModi;
	tColor.G = tG2 * tInvModi + tG1 * tModi;
	tColor.B = tB2 * tInvModi + tB1 * tModi;
	return tColor;
end



--
local function VUHDO_isBeingResurrected(aUnit)
	return VUHDO_RESSING_NAMES[VUHDO_RAID[aUnit].name] ~= nil;
end



--
local function VUHDO_getKiloText(aNumber, aSetup)
	if (abs(aNumber) < 100 or aSetup["LIFE_TEXT"].verbose) then
		return aNumber;
	end

  return floor(aNumber / 100) / 10 .. "k";
end



--
local tOverheal;
local tRatio;
local tIsOverhealText;
local tScale;
local tAllButtons;
local tHealthPlusInc;
local tIncBar;
local tButton;
local tAmountInc;
local tInfo;
local tOverhealSetup;
local function VUHDO_updateIncHeal(aUnit)
	tInfo = VUHDO_RAID[aUnit];
	tAllButtons = VUHDO_getUnitButtons(aUnit);

	if (tInfo == nil or tAllButtons == nil) then
		return;
	end

	tAmountInc = VUHDO_getIncHealOnUnit(tInfo.name);
	tOverheal = tAmountInc - tInfo.healthmax + tInfo.health;
	tRatio = tOverheal / tInfo.healthmax;
	if (tAmountInc > 0 and tInfo.connected and not tInfo.dead) then
		tHealthPlusInc = VUHDO_getUnitHealthModiPercent(tInfo, tAmountInc);
		if (tHealthPlusInc > 100) then
			tHealthPlusInc = 100;
		end
	else
		tHealthPlusInc = 0;
	end

	if (tAmountInc > 0) then
		tIncColor.R = -1;

  	for _, tButton in pairs(tAllButtons) do
    	tIncBar = VUHDO_getHealthBar(tButton, 6);

  		tIncBar:SetValue(tHealthPlusInc);
   		if (tIncColor.R == -1) then
   			tIncColor.R, tIncColor.G, tIncColor.B = VUHDO_getHealthBar(tButton, 1):GetStatusBarColor();
   			tIncColor = VUHDO_getDiffColor(tIncColor, VUHDO_PANEL_SETUP["BAR_COLORS"]["INCOMING"]);
   		end

    	VUHDO_setStatusBarColor(tIncBar, tIncColor);
    	tOverhealSetup = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[tButton:GetName()]]["OVERHEAL_TEXT"];
			tIsOverhealText = tOverhealSetup.show;
			tScale = tOverhealSetup.scale;

    	if (tIsOverhealText) then
  	  	if (tOverheal > 0) then
    			if (tRatio < 1) then
    				VUHDO_getOverhealPanel(VUHDO_getHealthBar(tButton, 1)):SetScale((0.5 + tRatio) * tScale);
    			else
	    			VUHDO_getOverhealPanel(VUHDO_getHealthBar(tButton, 1)):SetScale(1.5 * tScale);
  	  		end

					VUHDO_getOverhealText(VUHDO_getHealthBar(tButton, 1)):SetText("+" .. floor(tOverheal / 100) / 10 .. "k");
				else
					VUHDO_getOverhealText(VUHDO_getHealthBar(tButton, 1)):SetText("");
				end
  		end

  	end

	else
		for _, tButton in pairs(tAllButtons) do
			VUHDO_getHealthBar(tButton, 6):SetValue(0);
			if (tIsOverhealText) then
				VUHDO_getOverhealText(VUHDO_getHealthBar(tButton, 1)):SetText("");
			end
		end
	end

end



--
local function VUHDO_bgCol2Factor(aColor, aFactor)
	aColor.R, aColor.G, aColor.B = aColor.R * aFactor, aColor.G * aFactor, aColor.B * aFactor;
end



--
local tCopy = { };
local function VUHDO_copyColor(aColor)
	tCopy.R, tCopy.G, tCopy.B, tCopy.O = aColor.R, aColor.G, aColor.B, aColor.O;
	tCopy.TR, tCopy.TG, tCopy.TB, tCopy.TO = aColor.TR, aColor.TG, aColor.TB, aColor.TO;
	tCopy.useBackground, tCopy.useText, tCopy.useOpacity = aColor.useBackground, aColor.useText, aColor.useOpacity;
	return tCopy;
end



--
local tCopy2;
local tCopies = { };
local tIndex = 0;
local function VUHDO_copyColor2(aColor)
	tIndex = tIndex + 1;
	if (tIndex > 40) then
		tIndex = 1;
	end
	if (tCopies[tIndex] == nil) then
		tCopies[tIndex] = { };
	end

	tCopy2 = tCopies[tIndex];
	tCopy2.R, tCopy2.G, tCopy2.B, tCopy2.O = aColor.R, aColor.G, aColor.B, aColor.O;
	tCopy2.TR, tCopy2.TG, tCopy2.TB, tCopy2.TO = aColor.TR, aColor.TG, aColor.TB, aColor.TO;
	tCopy2.useBackground, tCopy2.useText, tCopy2.useOpacity = aColor.useBackground, aColor.useText, aColor.useOpacity;
	return tCopy2;
end



--
local tCopy3 = { };
local function VUHDO_copyColor3(aColor)
	tCopy3.R, tCopy3.G, tCopy3.B, tCopy3.O = aColor.R, aColor.G, aColor.B, aColor.O;
	tCopy3.TR, tCopy3.TG, tCopy3.TB, tCopy3.TO = aColor.TR, aColor.TG, aColor.TB, aColor.TO;
	tCopy3.useBackground, tCopy3.useText, tCopy3.useOpacity = aColor.useBackground, aColor.useText, aColor.useOpacity;
	return tCopy3;
end



--
local tSummand;
local function VUHDO_brightenColor(aColor, aFactor)
	tSummand = aFactor - 1;
	aColor.R, aColor.G, aColor.B = aColor.R + tSummand, aColor.G + tSummand, aColor.B + tSummand;
	return aColor;
end



--
local tEmergColor;
local tFactor;
local tUnit;
local tIndex;
local function VUHDO_getEmergencyColor(anInfo)

  if (not VUHDO_FORCE_RESET) then
  	tIndex = VUHDO_EMERGENCIES[anInfo.unit];

  	if (tIndex ~= nil) then
  		tFactor = 1 / tIndex;
  		tEmergColor = VUHDO_copyColor3(VUHDO_PANEL_SETUP["BAR_COLORS"]["EMERGENCY"]);
  		tEmergColor.R, tEmergColor.G, tEmergColor.B = tEmergColor.R * tFactor, tEmergColor.G * tFactor, tEmergColor.B * tFactor;
  		return tEmergColor;
  	end
  end

	return VUHDO_copyColor3(VUHDO_PANEL_SETUP["BAR_COLORS"]["NO_EMERGENCY"]);
end



--
local tDestHealth;
local tLifeAmount;

VUHDO_CUSTOM_INFO = { };
local VUHDO_CUSTOM_INFO = VUHDO_CUSTOM_INFO;



--
local tBtnUnit;
local tBtnName;
local tUnit;
local function VUHDO_getDisplayUnit(aButton)
	tBtnUnit = aButton:GetAttribute("unit");
	tBtnName = VUHDO_RAID_NAMES[tBtnUnit];
	if (tBtnName ~= nil and tBtnUnit ~= "focus") then
		tUnit = tBtnName;
	else
		tUnit = tBtnUnit;
	end

	if (strfind(tUnit, "target", 1, true)) then
		if (VUHDO_CUSTOM_INFO["fixResolveId"] == nil) then
			return tUnit, VUHDO_CUSTOM_INFO;
		else
			return VUHDO_CUSTOM_INFO["fixResolveId"], VUHDO_RAID[VUHDO_CUSTOM_INFO["fixResolveId"]];
		end
	else
		if (VUHDO_RAID[tUnit] ~= nil and VUHDO_RAID[tUnit].isVehicle) then
			tUnit = VUHDO_RAID[tUnit].petUnit;
		end
		return tUnit, VUHDO_RAID[tUnit];
	end
end



--
local tMissLife;
local tIsName, tIsLife, tIsLifeInName;
local tTextString;
local tHealthBar;
local tSetup;
local tLifeConfig;
local tAmountInc;
local tOwnerInfo;
local tMaxChars;
local tCharName;
local tLifeString;
local tUnit, tInfo;
local tIsShowLife;
local tIsHideIrrel;
function VUHDO_customizeText(aButton, aMode, anIsTarget)
	tUnit, tInfo = VUHDO_getDisplayUnit(aButton);

 	tHealthBar = VUHDO_getHealthBar(aButton, 1);

	if (tInfo == nil) then
		if ("focus" == tUnit) then
			VUHDO_getBarText(tHealthBar):SetText(VUHDO_I18N_NO_FOCUS);
		else
			VUHDO_getBarText(tHealthBar):SetText(VUHDO_I18N_NOT_AVAILABLE);
		end
		VUHDO_getLifeText(tHealthBar):SetText("");
		return;
	end

  tSetup = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[aButton:GetName()]];
  tLifeConfig = tSetup["LIFE_TEXT"];

	tIsHideIrrel = tLifeConfig.hideIrrelevant and VUHDO_getUnitHealthPercent(tInfo) >= VUHDO_CONFIG["EMERGENCY_TRIGGER"];
	tIsShowLife = tLifeConfig.show and not tIsHideIrrel;

	tIsLifeInName = tLifeConfig.show and
		(VUHDO_LT_POS_RIGHT == tLifeConfig.position
		or VUHDO_LT_POS_LEFT == tLifeConfig.position);

	tIsName = aMode ~= VUHDO_UPDATE_HEALTH or tIsLifeInName;
	tIsLife = aMode ~= VUHDO_UPDATE_AGGRO or tIsLifeInName;

	-- Basic name text
	if (tIsName) then
  	tMaxChars = tSetup["PANEL_COLOR"]["TEXT"].maxChars;
  	if (tMaxChars > 0 and strlen(tInfo.name) > tMaxChars) then
  		tCharName = strsub(tInfo.name, 1, tMaxChars);
  	else
  		tCharName = tInfo.name;
  	end

  	tOwnerInfo = VUHDO_RAID[tInfo.ownerUnit];
  	if (tSetup["ID_TEXT"].showName) then
  		if (tSetup["ID_TEXT"].showClass and not tInfo.isPet) then
  			tTextString = tInfo.className .. ": ";
  		else
  			tTextString = "";
  		end

  		if (tOwnerInfo == nil or not tSetup["ID_TEXT"].showPetOwners) then
  			tTextString = tTextString .. tCharName;
  		else
  			tTextString = tTextString .. tOwnerInfo.name .. ": " .. tCharName;
  		end
  	else
  		if (tSetup["ID_TEXT"].showClass and not tInfo.isPet) then
  			tTextString = tInfo.className;
  		else
  			tTextString = "";
  		end
  	end

  	-- Add player flags
  	if (tSetup["ID_TEXT"].showTags) then
    	if (not tInfo.connected) then
    		tTextString = "d/c-" .. tTextString;
    	elseif (tInfo.dead) then
    		if (UnitIsGhost(tUnit)) then
    			tTextString = "|cffff0000ghost|r-" .. tTextString;
    		else
    			tTextString = "rip-" .. tTextString;
    		end
    	else
    		if ("focus" == tUnit) then
   				tTextString = "|cffff0000foc|r-" .. tTextString;
   			elseif (tInfo.afk) then
   				tTextString = "afk-" .. tTextString;
   			elseif(tOwnerInfo ~= nil and tOwnerInfo.isVehicle) then
   				tTextString = "|cffff0000pet|r-" .. tTextString;
   			end
    	end
  	end
	end

	-- Life Text
	if (tIsLife and tIsShowLife) then
		tAmountInc = VUHDO_getIncHealOnUnit(tInfo.name);

		if (VUHDO_CONFIG["SHOW_TEXT_OVERHEAL"]) then
			tLifeAmount = tInfo.health + tAmountInc;
		else
			tLifeAmount = tInfo.health;
		end

		if (VUHDO_LT_MODE_PERCENT == tLifeConfig.mode or anIsTarget) then
			tLifeString = floor(VUHDO_getUnitHealthModiPercent(tInfo, tLifeAmount - tInfo.health)) .. "%";
		elseif (VUHDO_LT_MODE_MISSING == tLifeConfig.mode) then
			tMissLife = tLifeAmount - tInfo.healthmax;
			if (tMissLife < -10) then
				tLifeString =  VUHDO_getKiloText(tMissLife, tSetup);
			else
				tLifeString = "";
			end
		else -- VUHDO_LT_MODE_LEFT
			tLifeString = VUHDO_getKiloText(tLifeAmount, tSetup) .. " / " .. VUHDO_getKiloText(tInfo.healthmax, tSetup);
		end

		if (not tIsLifeInName) then
			VUHDO_getLifeText(tHealthBar):SetText(tLifeString);
		elseif (not tIsHideIrrel) then
			if (VUHDO_LT_POS_LEFT == tLifeConfig.position) then
				tTextString = tLifeString .. " " .. tTextString;
			else
				tTextString = tTextString .. " " .. tLifeString;
			end
		end
	elseif (tIsLife and tIsHideIrrel) then
		VUHDO_getLifeText(tHealthBar):SetText("");
	end

  -- Aggro Text
  if (tIsName) then
	  if (tInfo.aggro and VUHDO_THREAT_CFG["AGGRO_DETECT"] and VUHDO_THREAT_CFG["AGGRO_USE_TEXT"]) then
			tTextString =
			   "|cffff2020" .. VUHDO_THREAT_CFG["AGGRO_TEXT_LEFT"] .. "|r"
				.. tTextString
				.. "|cffff2020" .. VUHDO_THREAT_CFG["AGGRO_TEXT_RIGHT"] .. "|r";
		end

		VUHDO_getBarText(tHealthBar):SetText(tTextString);
	end
end

local VUHDO_customizeText = VUHDO_customizeText;



--
local tInfo;
local tValue;
local tScaling;
function VUHDO_customizeBarSize(aButton)
	_, tInfo = VUHDO_getDisplayUnit(aButton);

	if (tInfo == nil) then
 		VUHDO_getHealthBar(aButton, 1):SetValue(100);
 		VUHDO_getHealthBar(aButton, 3):SetValue(100);
		VUHDO_getHealthBar(aButton, 8):SetValue(100);
		VUHDO_getHealthBar(aButton, 2):SetValue(0);
	elseif (not tInfo.connected or tInfo.dead) then
 		VUHDO_getHealthBar(aButton, 1):SetValue(100);
 		VUHDO_getHealthBar(aButton, 3):SetValue(100);
		VUHDO_getHealthBar(aButton, 8):SetValue(100);
		VUHDO_getHealthBar(aButton, 6):SetValue(0);
		VUHDO_getHealthBar(aButton, 2):SetValue(0);
	else
		tScaling = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[aButton:GetName()]]["SCALING"];
	 	if (tScaling.invertGrowth) then
 			tValue = 100 - VUHDO_getUnitHealthPercent(tInfo);
 		else
 			tValue = VUHDO_getUnitHealthPercent(tInfo);
 		end
 		VUHDO_getHealthBar(aButton, 1):SetValue(tValue);
		VUHDO_getHealthBar(aButton, 8):SetValue(tValue);
 	end
end

local VUHDO_customizeBarSize = VUHDO_customizeBarSize;



--
local tIsIrrelevant;
local tTextColor;
local tHealthPerc;
local tHealthBar;
local tBarColor;
local tAmountInc;
local tUnit, tInfo;
local tFlashBar;
local tSetup;
local tScaling;
local tPanelColors;
local tColorBar;
local tIsSwapped;
local tIcon;
local tIsRaidIconColor;
local function VUHDO_customizeBarColor(aButton, aHadMajorLoss)
 	tHealthBar = VUHDO_getHealthBar(aButton, 1);
	tColorBar = VUHDO_getHealthBar(aButton, 1);
	tUnit, tInfo = VUHDO_getDisplayUnit(aButton);

	if (tInfo == nil) then
 		tBarColor = VUHDO_BAR_COLOR["OFFLINE"];
		VUHDO_setStatusBarColor(tColorBar, tBarColor);
		VUHDO_getBarText(tHealthBar):SetTextColor(tBarColor.TR, tBarColor.TG, tBarColor.TB, tBarColor.TO);
		return;
	end

	tSetup = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[aButton:GetName()]];

	-- Bar colors
	if (not tInfo.connected) then
		tBarColor = VUHDO_copyColor(VUHDO_BAR_COLOR["OFFLINE"]);
	elseif (tInfo.dead) then
		tBarColor = VUHDO_copyColor(VUHDO_BAR_COLOR["DEAD"]);

		if (VUHDO_isBeingResurrected(tUnit)) then
			tBarColor.TR, tBarColor.TG, tBarColor.TB, tBarColor.TO = 0.4, 1, 0.4, 1;
		elseif (not tInfo.range) then
			tBarColor.O = tBarColor.O * VUHDO_BAR_COLOR["OUTRANGED"].O;
			tBarColor.TO = tBarColor.TO * VUHDO_BAR_COLOR["OUTRANGED"].TO;
		end
	else
	  tPanelColors = tSetup["PANEL_COLOR"];

		-- Basic Bar Color
		tHealthPerc = VUHDO_getUnitHealthPercent(tInfo);
		tIsIrrelevant = tHealthPerc > VUHDO_CONFIG["EMERGENCY_TRIGGER"];
		tIcon = tInfo.raidIcon;
		tIsRaidIconColor = VUHDO_BAR_COLOR["RAID_ICONS"].enable and tIcon ~= nil
			and (not VUHDO_BAR_COLOR["RAID_ICONS"].filterOnly or VUHDO_PANEL_SETUP["RAID_ICON_FILTER"][tIcon]);
		tIcon = tostring(tIcon);

		if (VUHDO_MODE_NEUTRAL == VUHDO_CONFIG["MODE"]) then
			if (tIsRaidIconColor and VUHDO_BAR_COLOR["RAID_ICONS"][tIcon].useBackground) then
				tBarColor = VUHDO_copyColor(VUHDO_BAR_COLOR["RAID_ICONS"][tIcon]);
			elseif (tPanelColors["BARS"].mode == 1) then
				tBarColor = VUHDO_USER_CLASS_COLORS[tInfo.classId];
				if (tBarColor == nil) then
					tBarColor = VUHDO_getLifeLeftColor(tHealthPerc);
					tBarColor.O = tPanelColors["BARS"].O;
				else
					tBarColor = VUHDO_copyColor(tBarColor);
				end
			elseif (tPanelColors["BARS"].mode == 2) then
				tBarColor = VUHDO_copyColor(tPanelColors["BARS"]);
			else
				tBarColor = VUHDO_getLifeLeftColor(tHealthPerc);
				tBarColor.O = tPanelColors["BARS"].O;
			end
		else
			tBarColor = VUHDO_getEmergencyColor(tInfo);
		end

		-- Overheal
		tAmountInc = VUHDO_getIncHealOnUnit(tInfo.name);
		tDestHealth = tInfo.health + tAmountInc;
		if (VUHDO_CONFIG["SHOW_OVERHEAL"] and tInfo.healthmax > 0 and tDestHealth > tInfo.healthmax) then
			tBarColor = VUHDO_brightenColor(tBarColor, tDestHealth / tInfo.healthmax);
		end

		tTextColor = nil;
		if (tIsRaidIconColor and VUHDO_BAR_COLOR["RAID_ICONS"][tIcon].useText) then
			tTextColor = VUHDO_BAR_COLOR["RAID_ICONS"][tIcon];
		elseif (tPanelColors.classColorsName) then
			tTextColor = VUHDO_USER_CLASS_COLORS[tInfo.classId];
		end
		-- Pets may have no class color
		if (tTextColor == nil) then
			tTextColor = tPanelColors["TEXT"];
		end

		tBarColor.TR, tBarColor.TG, tBarColor.TB, tBarColor.TO
			= tTextColor.TR, tTextColor.TG, tTextColor.TB, tTextColor.TO;

		if (tIsIrrelevant) then
			tBarColor = VUHDO_getDiffColor(tBarColor, VUHDO_BAR_COLOR["IRRELEVANT"]);
		end

		-- Debuff/Range?
		if (tInfo.debuff ~= VUHDO_DEBUFF_TYPE_NONE or tInfo.charmed) then
 			tBarColor = VUHDO_getDiffColor(tBarColor, VUHDO_getDebuffColor(tInfo));
			if (tPanelColors.isBrightnessToHealth) then
				VUHDO_bgCol2Factor(tBarColor, tPanelColors.barBackBrightness * 0.01);
			end

			if (not tInfo.range) then
				tBarColor.O = tBarColor.O * VUHDO_BAR_COLOR["OUTRANGED"].O;
				tBarColor.TO = tBarColor.TO * VUHDO_BAR_COLOR["OUTRANGED"].TO;
			end
		elseif (not tInfo.range) then
			tBarColor = VUHDO_getDiffColor(tBarColor, VUHDO_BAR_COLOR["OUTRANGED"]);
		end
	end

	-- Health Bar Color
	VUHDO_setStatusBarColor(tColorBar, tBarColor);
	VUHDO_getBarText(tHealthBar):SetTextColor(tBarColor.TR, tBarColor.TG, tBarColor.TB, tBarColor.TO);

	-- Life Text Color
	VUHDO_getLifeText(tHealthBar):SetTextColor(tBarColor.TR, tBarColor.TG, tBarColor.TB, tBarColor.TO);

	-- Major health loss indicator
	if (aHadMajorLoss ~= nil) then
		tScaling = tSetup["SCALING"];
		if (tScaling.isDamFlash and tScaling.damFlashFactor >= aHadMajorLoss) then
			tFlashBar = VUHDO_GLOBAL[aButton:GetName() .. "BgBarIcBarHlBarFlBar"];
			UIFrameFlash(tFlashBar, 0.05, 0.3, 0.45, false, 0.1, 0);
		end
	end
end



--
local tTargetFrame;
local tAggroColor;
local tUnit, tInfo;
local function VUHDO_customizeAggroBar(aButton)
  if (VUHDO_THREAT_CFG["AGGRO_DETECT"]) then
		tUnit, tInfo = VUHDO_getDisplayUnit(aButton);

		if (tInfo == nil) then
			return;
		end

  	if (VUHDO_THREAT_CFG["AGGRO_USE_LINE"]) then
  		if (tInfo.aggro) then
  			VUHDO_getHealthBar(aButton, 4):SetValue(100);
  		else
  			VUHDO_getHealthBar(aButton, 4):SetValue(0);
  		end
		end

  	if (VUHDO_THREAT_CFG["AGGRO_USE_FRAME"]) then
  		tTargetFrame = VUHDO_getPlayerTargetFrame(aButton);
  		if (tInfo.aggro) then
				tAggroColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["AGGRO"];
				tTargetFrame:SetBackdropBorderColor(tAggroColor.R, tAggroColor.G,	tAggroColor.B, tAggroColor.O);
				tTargetFrame:Show();
  		else
				VUHDO_updatePlayerTargetFrame(tTargetFrame, tUnit);
  		end
  	end
	end
end



--
local tDebuffCol;
local tBackgroundColor;
local tInfo;
local tPanelColors;
function VUHDO_customizeBackgroundBar(aButton)
	_, tInfo = VUHDO_getDisplayUnit(aButton);

	if (tInfo == nil) then
		VUHDO_getHealthBar(aButton, 3):SetStatusBarColor(0, 0, 0, 0);
		return;
	end

  tPanelColors = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[aButton:GetName()]]["PANEL_COLOR"];
	tBackgroundColor = VUHDO_copyColor2(tPanelColors["TEXT"]);

	if (tInfo.debuff ~= VUHDO_DEBUFF_TYPE_NONE or tInfo.charmed) then
  	tDebuffCol = VUHDO_getDebuffColor(tInfo);
  	if (tDebuffCol.useBackground) then
  		tBackgroundColor = tDebuffCol;
  		if (not tPanelColors.isBrightnessToHealth) then
  			VUHDO_bgCol2Factor(tBackgroundColor, tPanelColors.barBackBrightness * 0.01);
  		end
  	end
	elseif (tPanelColors.classColorsBack and VUHDO_USER_CLASS_COLORS[tInfo.classId] ~= nil) then
		tBackgroundColor = VUHDO_copyColor2(VUHDO_USER_CLASS_COLORS[tInfo.classId]);
		VUHDO_bgCol2Factor(tBackgroundColor, tPanelColors.barBackBrightness * 0.01);
	end

	if (tBackgroundColor ~= nil and tBackgroundColor.useBackground) then
		if (not tInfo.range and tBackgroundColor.O ~= nil) then
			tBackgroundColor.O = tBackgroundColor.O * VUHDO_PANEL_SETUP["BAR_COLORS"]["OUTRANGED"].O;
		end

		VUHDO_getHealthBar(aButton, 3):SetStatusBarColor(tBackgroundColor.R, tBackgroundColor.G, tBackgroundColor.B, tBackgroundColor.O);
	end
end
local VUHDO_customizeBackgroundBar = VUHDO_customizeBackgroundBar;



--
local tSetup;
local tTexture;
local tIcon;
local tUnit;
function VUHDO_customizeHealButton(aButton)
	VUHDO_customizeBarColor(aButton);
	VUHDO_customizeBarSize(aButton);
	VUHDO_customizeText(aButton, VUHDO_UPDATE_ALL, false);
	VUHDO_customizeAggroBar(aButton)
	VUHDO_customizeBackgroundBar(aButton);

  tSetup = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[aButton:GetName()]];
	tUnit, _ = VUHDO_getDisplayUnit(aButton);

	-- Raid icon
	if (tSetup["RAID_ICON"].show and tUnit ~= nil) then
  	tTexture = VUHDO_getBarRoleIcon(aButton, 50);
  	tIcon = GetRaidTargetIndex(tUnit);
  	if (tIcon ~= nil and VUHDO_PANEL_SETUP["RAID_ICON_FILTER"][tIcon]) then
  		VUHDO_setRaidTargetIconTexture(tTexture, tIcon);
  		tTexture:Show();
  	else
  		tTexture:Hide();
  	end
	end
end

local VUHDO_customizeHealButton = VUHDO_customizeHealButton;




--
local tInfo, tPrefix, tCnt, tAlpha;
local function VUHDO_customizeDebuffIconsRange(aButton)
	_, tInfo = VUHDO_getDisplayUnit(aButton);

  if (tInfo ~= nil) then
    if (tInfo.range) then
      tAlpha = 1;
    else
      tAlpha = VUHDO_BAR_COLOR["OUTRANGED"].O;
    end

  	tPrefix = VUHDO_getHealthBar(aButton, 1):GetName() .. "Ic4";
  	for tCnt = 0, 4 do
  		VUHDO_GLOBAL[tPrefix .. tCnt]:SetAlpha(tAlpha);
  	end
  end
end



---
local tInfo;
local tAllButtons;
local tButton;
function VUHDO_updateHealthBarsFor(aUnit, anUpdateMode)
  tAllButtons = VUHDO_getUnitButtons(aUnit);
	tInfo = VUHDO_RAID[aUnit];
	if (tInfo == nil or tAllButtons == nil) then
		return;
	end

	-- Targtets und targets-of-target, die im Raid sind
	if (VUHDO_UPDATE_HEALTH == anUpdateMode) then
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_HEALTH, false);
			VUHDO_customizeBarSize(tButton);
			VUHDO_customizeBarColor(tButton, tInfo["lifeLossPerc"]);
			VUHDO_customizeBackgroundBar(tButton); -- attempt
			tInfo["lifeLossPerc"] = nil;
		end
		VUHDO_updateIncHeal(aUnit);
	elseif (VUHDO_UPDATE_INC == anUpdateMode) then
		-- [text], bar color, incoming
		if (VUHDO_CONFIG["SHOW_TEXT_OVERHEAL"]) then
			for _, tButton in pairs(tAllButtons) do
				VUHDO_customizeText(tButton, VUHDO_UPDATE_HEALTH, false);
				VUHDO_customizeBarColor(tButton);
			end
		else
			for _, tButton in pairs(tAllButtons) do
				VUHDO_customizeBarColor(tButton);
			end
		end
		VUHDO_updateIncHeal(aUnit);

	elseif (VUHDO_UPDATE_DEBUFF == anUpdateMode) then
		-- bar color/Background
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeBarColor(tButton);
			VUHDO_customizeBackgroundBar(tButton);
		end

	elseif (VUHDO_UPDATE_AGGRO == anUpdateMode) then
		-- Text, aggro bar
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_AGGRO, false);
			VUHDO_customizeAggroBar(tButton);
		end

	elseif (VUHDO_UPDATE_RANGE == anUpdateMode) then
		-- bar color background bar
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeBarColor(tButton);
			VUHDO_customizeBackgroundBar(tButton);
			VUHDO_customizeDebuffIconsRange(tButton);
		end

	elseif (VUHDO_UPDATE_HEALTH_MAX == anUpdateMode) then
		-- text, bar size, bar color, incoming
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_HEALTH, false);
			VUHDO_customizeBarSize(tButton);
			VUHDO_customizeBarColor(tButton);
		end
		VUHDO_updateIncHeal(aUnit);

	elseif (VUHDO_UPDATE_AFK == anUpdateMode) then
		-- text
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_AGGRO, false);
		end
	elseif (VUHDO_UPDATE_ALIVE == anUpdateMode) then
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_ALL, false);
			VUHDO_customizeBarSize(tButton);
			VUHDO_customizeBarColor(tButton);
			VUHDO_updateIncHeal(aUnit);
		end
	elseif (VUHDO_UPDATE_EMERGENCY == anUpdateMode) then
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeBarColor(tButton);
		end
	else --VUHDO_UPDATE_ALL
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeHealButton(tButton);
		end

		VUHDO_updateIncHeal(aUnit);
	end

	-- Not supported by target bars?
	if (VUHDO_UPDATE_INC == anUpdateMode
		or VUHDO_UPDATE_DEBUFF == anUpdateMode
		or VUHDO_UPDATE_AGGRO == anUpdateMode
		or VUHDO_UPDATE_RANGE == anUpdateMode
		or VUHDO_UPDATE_AFK == anUpdateMode
		or VUHDO_UPDATE_EMERGENCY == anUpdateMode) then
		return;
	end

  tAllButtons = VUHDO_IN_RAID_TARGET_BUTTONS[tInfo.name];
	if (tAllButtons == nil) then
		return;
	end

	VUHDO_CUSTOM_INFO["fixResolveId"] = aUnit;

	if (VUHDO_UPDATE_HEALTH == anUpdateMode) then
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_HEALTH, true);
			VUHDO_customizeBarSize(tButton);
		end

	elseif (VUHDO_UPDATE_HEALTH_MAX == anUpdateMode) then
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_HEALTH, true);
			VUHDO_customizeBarSize(tButton);
		end

	elseif (VUHDO_UPDATE_ALIVE == anUpdateMode) then
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_ALL, true);
			VUHDO_customizeBarSize(tButton);
		end
	else --VUHDO_UPDATE_ALL
		for _, tButton in pairs(tAllButtons) do
			VUHDO_customizeText(tButton, VUHDO_UPDATE_ALL, true);
			VUHDO_customizeBarSize(tButton);
		end
	end
end



--
local VUHDO_getHealButton = VUHDO_getHealButton;
local tButton;
local tUnit;
local tPanelButtons;
function VUHDO_updateAllPanelBars(aPanelNum)

	tPanelButtons = VUHDO_getPanelButtons(aPanelNum);
	for _, tButton in ipairs(tPanelButtons) do
		if (tButton:GetAttribute("unit") == nil) then
			break;
		end
		VUHDO_customizeHealButton(tButton);
	end

	for tUnit, _ in pairs(VUHDO_RAID) do
		VUHDO_updateIncHeal(tUnit);
		VUHDO_updateManaBars(tUnit, 3);
		VUHDO_updateTargetBars(tUnit);
	end
end
local VUHDO_updateAllPanelBars = VUHDO_updateAllPanelBars;



--
local tCnt;
VUHDO_REMOVE_HOTS = true;
function VUHDO_updateAllRaidBars()
	for tCnt = 1, VUHDO_MAX_PANELS do
		if (VUHDO_isPanelVisible(tCnt)) then
			VUHDO_updateAllPanelBars(tCnt);
		end
	end

	if (VUHDO_REMOVE_HOTS) then
		VUHDO_removeAllHots();
		VUHDO_updateAllHoTs();
	else
		VUHDO_REMOVE_HOTS = true;
	end
end
