
local tIcon;
local tTimer;
local tCounter;
local tIndex;
local tDuration;
local tPanelNum;

local tMaxAlpha;
local sIsFade;

local sWarnDuration;
local sIsWarnColor;
local tTimerRadio;

local sIsSwiftmend;
local sHotSetup;

local sBuffs2Hots = { };

local VUHDO_KNOWS_SWIFTMEND = false;

local VUHDO_MY_HOTS = { };
local VUHDO_OTHER_HOTS = { };
local VUHDO_MY_AND_OTHERS_HOTS = { };
local VUHDO_ACTIVE_HOTS = { };
local VUHDO_ACTIVE_HOTS_OTHERS = { };

-- BURST CACHE ---------------------------------------------------


local floor = floor;
local strlen = strlen;
local table = table;
local UnitBuff = UnitBuff;
local GetSpellCooldown = GetSpellCooldown;
local UnitIsUnit = UnitIsUnit;
local GetTime = GetTime;
local strfind = strfind;

local VUHDO_GLOBAL = getfenv();

local VUHDO_getHealthBar;
local VUHDO_getUnitButtons;
local VUHDO_getBarRoleIcon;
local VUHDO_updateAllClusterIcons;

local VUHDO_PANEL_SETUP;
local VUHDO_BUTTON_CACHE;
local VUHDO_CAST_ICON_DIFF;
local VUHDO_HEALING_HOTS;
local VUHDO_SPELLS;
local VUHDO_RAID;

function VUHDO_customHotsInitBurst()
	-- variables
	VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];
	VUHDO_BUTTON_CACHE = VUHDO_GLOBAL["VUHDO_BUTTON_CACHE"];
	VUHDO_CAST_ICON_DIFF = VUHDO_GLOBAL["VUHDO_CAST_ICON_DIFF"];
	VUHDO_HEALING_HOTS = VUHDO_GLOBAL["VUHDO_HEALING_HOTS"];
	VUHDO_SPELLS = VUHDO_GLOBAL["VUHDO_SPELLS"];
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_ACTIVE_HOTS = VUHDO_GLOBAL["VUHDO_ACTIVE_HOTS"];
	VUHDO_ACTIVE_HOTS_OTHERS = VUHDO_GLOBAL["VUHDO_ACTIVE_HOTS_OTHERS"];
	-- functions
	VUHDO_getHealthBar = VUHDO_GLOBAL["VUHDO_getHealthBar"];
	VUHDO_getUnitButtons = VUHDO_GLOBAL["VUHDO_getUnitButtons"];
	VUHDO_getBarRoleIcon = VUHDO_GLOBAL["VUHDO_getBarRoleIcon"];
	VUHDO_updateAllClusterIcons = VUHDO_GLOBAL["VUHDO_updateAllClusterIcons"];
end

----------------------------------------------------



--
function VUHDO_setKnowsSwiftmend(aKnowsSwiftmend)
	VUHDO_KNOWS_SWIFTMEND = aKnowsSwiftmend;
end



--
local tCopy = { };
local function VUHDO_copyColor(aColor)
	tCopy.R, tCopy.G, tCopy.B, tCopy.O = aColor.R, aColor.G, aColor.B, aColor.O;
	tCopy.TR, tCopy.TG, tCopy.TB, tCopy.TO = aColor.TR, aColor.TG, aColor.TB, aColor.TO;
	tCopy.useBackground, tCopy.useText, tCopy.useOpacity = aColor.useBackground, aColor.useText, aColor.useOpacity;
	return tCopy;
end



--
local function VUHDO_customizeHotBar(aButton, aRest, anIndex, aDuration)
	if (aDuration == nil or aRest == nil) then
		VUHDO_getHealthBar(aButton, anIndex + 3):SetValue(0);
	else
		VUHDO_getHealthBar(aButton, anIndex + 3):SetValue(100 * aRest / aDuration);
	end
end



--
local tHotName;
local tPrefix;
local tDuration2;
local tIsMatch;
local tHotSlots;
local tSlotCfg;
local tChargeTexture;
local function VUHDO_customizeHotIcons(aButton, aHotName, aRest, aTimes, anIcon, aDuration, aMode, aShieldCharges)
	tPanelNum = VUHDO_BUTTON_CACHE[aButton:GetName()];
	tHotSlots = VUHDO_PANEL_SETUP[tPanelNum]["HOTS"]["SLOTS"];

	for tIndex, tHotName in pairs(tHotSlots) do
		if (strfind(strupper(aHotName), strupper(tHotName), 1, true)) then

			tSlotCfg = VUHDO_PANEL_SETUP[tPanelNum]["HOTS"]["SLOTCFG"]["" .. tIndex];

			tIsMatch =
				aMode == 0
					or (aMode == 1 and tSlotCfg["mine"] and not tSlotCfg["others"])
					or (aMode == 2 and not tSlotCfg["mine"] and tSlotCfg["others"])
					or (aMode == 3 and tSlotCfg["mine"] and tSlotCfg["others"]);

			if (tIsMatch) then
				if (tIndex >= 6 and tIndex <= 8) then
					VUHDO_customizeHotBar(aButton, aRest, tIndex, aDuration);
				else
					tPrefix = VUHDO_getHealthBar(aButton, 1):GetName() .. "Ic" .. tIndex;
					tIcon = VUHDO_GLOBAL[tPrefix .. "I"];
					tTimer = VUHDO_GLOBAL[tPrefix .. "T"];
					tCounter = VUHDO_GLOBAL[tPrefix .. "C"];
  				tChargeTexture = VUHDO_GLOBAL[tPrefix .. "A"];

					if (anIcon ~= nil and sHotSetup.iconRadioValue == 1) then
						tIcon:SetTexture(anIcon);
					end

					tHotCfg = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT" .. tIndex];
					tTimerRadio = tHotCfg.countdownMode;
					tIsFullDuration = tHotCfg.isFullDuration;

					if (aRest == nil) then
						tIcon:SetAlpha(0);
						tTimer:SetText("");
						tCounter:SetText("");
						tChargeTexture:Hide();
					else
						if (aRest == 999) then
							if (aTimes > 0) then
								tIcon:SetAlpha(tMaxAlpha);
								tCounter:SetText(aTimes);
							else
								tIcon:SetAlpha(0);
								tCounter:SetText("");
							end

							tTimer:SetText("");

						elseif (aRest >= 0) then
							if (aRest < 10 and sIsFade) then
								tIcon:SetAlpha(tMaxAlpha * aRest / 10);
							else
								tIcon:SetAlpha(tMaxAlpha);
							end

							if (aRest < 10 or tIsFullDuration) then
								if (tTimerRadio == 2 and aRest < sWarnDuration) then
									tDuration = "" .. floor(aRest * 10) / 10;
									if (strlen(tDuration) < 3) then
										tDuration = tDuration .. ".0";
									end
								else
									tDuration = floor(aRest);
								end
							else
								tDuration = "";
							end

							tTimer:SetText(tDuration);
							tDuration2 = aRest / 5;

							if (tDuration2 > 5) then
								tTimer:SetTextColor(1, 1, 1, 1);
							else
								tTimer:SetTextColor(1, tDuration2, tDuration2, 1);
							end

							if (aTimes ~= nil and aTimes >= 2) then
								tCounter:SetText(aTimes);
							end
						else
							tTimer:SetText("");
							tIcon:SetAlpha(tMaxAlpha);
							tCounter:SetText("");
						end

						if (aTimes > 4) then
							aTimes = 4;
						end

						if (sHotSetup.iconRadioValue ~= 1) then
							if (sIsWarnColor and aRest < sWarnDuration) then
								tHotColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"]["WARNING"];
							else
								tHotColor = VUHDO_copyColor(VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT" .. tIndex]);

								if (aTimes > 1) then
									if (VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"].useColorBack) then
										tChargeColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT_CHARGE_" .. aTimes];
										tHotColor.R, tHotColor.G, tHotColor.B  = tChargeColor.R, tChargeColor.G, tChargeColor.B;
									end
								end
							end
							tIcon:SetVertexColor(tHotColor.R, tHotColor.G, tHotColor.B);
						end


            if (aShieldCharges > 0) then
							tHotColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT" .. tIndex];
							tChargeTexture:SetTexture("Interface\\AddOns\\VuhDo\\Images\\shield_stacks" .. aShieldCharges);
							tChargeTexture:SetVertexColor(tHotColor.R, tHotColor.G, tHotColor.B, tHotColor.O);
							tChargeTexture:Show();
						end

					end
				end
			end
		end
	end
end



--
local tChargeTexture;
local tIsChargeShown;
local tHotColor;
local tChargeColor;
local tIsFullDuration;
local tHotCfg;
local tHotName;
local tPrefix;
local tHotSlots;
local tSlotCfg;
local function VUHDO_customizeHotSquares(aButton, aHotName, aRest, aTimes, anIcon, aDuration, aMode, aShieldCharges)
	tPanelNum = VUHDO_BUTTON_CACHE[aButton:GetName()];
	tHotSlots = VUHDO_PANEL_SETUP[tPanelNum]["HOTS"]["SLOTS"];

	for tIndex, tHotName in pairs(tHotSlots) do
		if (strfind(strupper(aHotName), strupper(tHotName), 1, true)) then
			tSlotCfg = VUHDO_PANEL_SETUP[tPanelNum]["HOTS"]["SLOTCFG"]["" .. tIndex];

			tIsMatch =
				aMode == 0
					or (aMode == 1 and tSlotCfg["mine"] and not tSlotCfg["others"])
					or (aMode == 2 and not tSlotCfg["mine"] and tSlotCfg["others"])
					or (aMode == 3 and tSlotCfg["mine"] and tSlotCfg["others"]);

			if (tIsMatch) then
				tIsChargeShown = (sHotSetup.stacksRadioValue == 3) and aTimes ~= nil and aTimes > 0;

				if (tIndex >= 6 and tIndex <= 8) then
					VUHDO_customizeHotBar(aButton, aRest, tIndex, aDuration);
				else
					if (aTimes == nil) then
						aTimes = 0;
					end
					tPrefix = VUHDO_getHealthBar(aButton, 1):GetName() .. "Ic" .. tIndex;
					tIcon = VUHDO_GLOBAL[tPrefix .. "I"];
					tTimer = VUHDO_GLOBAL[tPrefix .. "T"];
					tChargeTexture = VUHDO_GLOBAL[tPrefix .. "A"];
					if (anIcon ~= nil and sHotSetup.iconRadioValue == 1) then
						tIcon:SetTexture(anIcon);
					end

					tHotCfg = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT" .. tIndex];
					tTimerRadio = tHotCfg.countdownMode;
					tMaxAlpha = tHotCfg.O;
					tIsFullDuration = tHotCfg.isFullDuration;
					if (aRest == nil) then
						tIcon:SetAlpha(0);
						tTimer:SetText("");
						tChargeTexture:Hide();
					else
						if (aRest == 999) then
							if (aTimes > 0) then
								tIcon:SetAlpha(tMaxAlpha);
							else
								tIcon:SetAlpha(0);
							end

							tTimer:SetText("");

						elseif (aRest >= 0) then

							if (aRest < 10 or tIsFullDuration) then
								if (tTimerRadio == 2 and aRest < sWarnDuration) then
									tDuration = "" .. floor(aRest * 10) / 10;
									if (strlen(tDuration) < 3) then
										tDuration = tDuration .. ".0";
									end
								else
									tDuration = floor(aRest);
								end

								tTimer:SetText(tDuration);
							else
								if (tMaxAlpha > 0 or tIsChargeShown) then
									tTimer:SetText("");
								else
									tTimer:SetText("X");
								end
							end

							if (aRest < 10 and sIsFade) then
								tIcon:SetAlpha(tMaxAlpha * aRest / 10);
							else
								tIcon:SetAlpha(tMaxAlpha);
							end
						else
							tIcon:SetAlpha(tMaxAlpha);
							tTimer:SetText("");
						end

						--@TESTING
						--aTimes = floor(aRest / 3.5);
						if (aTimes > 4) then
							aTimes = 4;
						end
						if (sIsWarnColor and aRest < sWarnDuration) then
							tHotColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"]["WARNING"];
						else
							tHotColor = VUHDO_copyColor(VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT" .. tIndex]);

							if (aTimes > 1) then
								tChargeColor = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOT_CHARGE_" .. aTimes];
								if (VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"].useColorBack) then
									tHotColor.R, tHotColor.G, tHotColor.B = tChargeColor.R, tChargeColor.G, tChargeColor.B;
								end

								if (VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"].useColorText) then
									tHotColor.TR, tHotColor.TG, tHotColor.TB = tChargeColor.TR, tChargeColor.TG, tChargeColor.TB;
								end
							end
						end

						if (sHotSetup.iconRadioValue ~= 1) then
							tIcon:SetVertexColor(tHotColor.R, tHotColor.G, tHotColor.B);
						end

						tTimer:SetTextColor(tHotColor.TR, tHotColor.TG, tHotColor.TB, tHotColor.TO);

						if (tIsChargeShown) then
							tChargeTexture:SetTexture("Interface\\AddOns\\VuhDo\\Images\\hot_stacks" .. aTimes);
							tChargeTexture:SetVertexColor(tHotColor.R, tHotColor.G, tHotColor.B, tHotColor.O);
							tChargeTexture:Show();
						elseif (aShieldCharges > 0) then
							tChargeTexture:SetTexture("Interface\\AddOns\\VuhDo\\Images\\shield_stacks" .. aShieldCharges);
							tChargeTexture:SetVertexColor(tHotColor.R + 0.15, tHotColor.G + 0.15, tHotColor.B + 0.15, tHotColor.O);
							tChargeTexture:Show();
						else
							tChargeTexture:Hide();
						end
					end
				end
			end
		end
	end

end



--
local tAllButtons;
local tButton;
local tHotCols;
local tShieldCharges;
local function VUHDO_updateHotIcons(aUnit, aHotName, aRest, aTimes, anIcon, aDuration, aMode)
	if (VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"].useSquare) then
		tMaxAlpha = 1;
	else
		tMaxAlpha = 0;
	end

	tHotCols = VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"];
	sIsFade = tHotCols.isFadeOut;
	sWarnDuration = tHotCols["WARNING"].lowSecs;
	sIsWarnColor = tHotCols["WARNING"].enabled;
	if (aMode ~= 2) then
		tShieldCharges = VUHDO_getShieldLeftCount(aUnit, aHotName);
	else
		tShieldCharges = 0;
	end

	tAllButtons = VUHDO_getUnitButtons(aUnit);
	if (tAllButtons == nil) then
		return;
	end

	for _, tButton in pairs(tAllButtons) do
		sHotSetup = VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[tButton:GetName()]]["HOTS"];
		if (sHotSetup.stacksRadioValue == 2) then -- Stacks: Text
			VUHDO_customizeHotIcons(tButton, aHotName, aRest, aTimes, anIcon, aDuration, aMode, tShieldCharges);
		else -- Stacks: Off, Triangles
			VUHDO_customizeHotSquares(tButton, aHotName, aRest, aTimes, anIcon, aDuration, aMode, tShieldCharges);
		end
	end
end



--
local tCnt;
local tPrefix;
local tHbPrefix;
function VUHDO_removeHots(aUnit)
	tAllButtons = VUHDO_getUnitButtons(aUnit);
	if (tAllButtons == nil) then
		return;
	end

	for _, tButton in pairs(tAllButtons) do
		tHbPrefix = VUHDO_getHealthBar(tButton, 1):GetName() .. "Ic";
		for tCnt = 1, 5 do
			tPrefix = tHbPrefix .. tCnt;
			VUHDO_GLOBAL[tPrefix  .. "I"]:SetAlpha(0);
			VUHDO_GLOBAL[tPrefix  .. "T"]:SetText("");
			VUHDO_GLOBAL[tPrefix  .. "A"]:Hide();
			VUHDO_GLOBAL[tPrefix  .. "C"]:SetText("");
		end

		for tCnt = 9, 11 do
			VUHDO_getHealthBar(tButton, tCnt):SetValue(0);
		end

		VUHDO_getBarRoleIcon(tButton, 51):Hide();
	end
end
local VUHDO_removeHots = VUHDO_removeHots;



--
local tCount;
local tHotInfo;
local function VUHDO_snapshotHot(aHotName, aRest, aStacks, anIcon, anIsMine, aDuration, aUnit)
	if (not VUHDO_ACTIVE_HOTS[aHotName]) then
		return;
	end

	aStacks = aStacks or 0;
	if (aStacks == 0) then
		tCount = 1;
	else
		tCount = aStacks;
	end

	if (anIsMine) then
		if (VUHDO_MY_HOTS[aUnit][aHotName] == nil) then
			VUHDO_MY_HOTS[aUnit][aHotName] = { };
		end
		tHotInfo = VUHDO_MY_HOTS[aUnit][aHotName];
		tHotInfo[1], tHotInfo[2], tHotInfo[3], tHotInfo[4] = aRest, aStacks, anIcon, aDuration;
	elseif (VUHDO_ACTIVE_HOTS_OTHERS[aHotName]) then
		if (VUHDO_OTHER_HOTS[aUnit][aHotName] == nil) then
			VUHDO_OTHER_HOTS[aUnit][aHotName] = { };
		end
		tHotInfo = VUHDO_OTHER_HOTS[aUnit][aHotName];

		if (tHotInfo[1] == nil) then
			tHotInfo[1], tHotInfo[2], tHotInfo[3], tHotInfo[4] = aRest, aStacks, anIcon, aDuration;
		else
			if (aRest > tHotInfo[1]) then
				tHotInfo[1] = aRest;
			end

			tHotInfo[2] = tHotInfo[2] + tCount;
		end
	end

	if (VUHDO_MY_AND_OTHERS_HOTS[aUnit][aHotName] == nil) then
		VUHDO_MY_AND_OTHERS_HOTS[aUnit][aHotName] = { };
	end

	tHotInfo = VUHDO_MY_AND_OTHERS_HOTS[aUnit][aHotName];
	if (tHotInfo[1] == nil) then
		tHotInfo[1], tHotInfo[2], tHotInfo[3], tHotInfo[4] = aRest, aStacks, anIcon, aDuration;
	else
		if (anIsMine or aRest > tHotInfo[1]) then
			tHotInfo[1] = aRest;
		end

		tHotInfo[2] = tHotInfo[2] + tCount;
	end
end



local VUHDO_IGNORE_HOT_IDS = {
  [67358] = true, -- "Rejuvenating" proc has same name in russian and spanish as rejuvenation
}



--
local tInfo;
local tBuffIcon, tStacks, tDuration, tRest;
local function VUHDO_updateAllDispellableIcons(aUnit)
	tInfo = VUHDO_RAID[aUnit];
	if (tInfo == nil) then
		return;
	end

  tBuffIcon = nil;
  tRest = nil;
	if (tInfo.debuff ~= nil and strlen(tInfo.debuff) > 0) then
	  _, _, tBuffIcon, tStacks, _, tDuration, tRest, _, _, _, _ = UnitDebuff(aUnit, tInfo.debuff);
	end

  if (tRest ~= nil) then
  	tRest = tRest - GetTime();
  end

	VUHDO_updateHotIcons(aUnit, "DISPELLABLE", tRest, tStacks, tBuffIcon, tDuration, 0);
end



--
local tHotCmpName;
local tOtherHotCnt;
local tIconFound;
local tOtherIcon;
local tBuffIcon;
local tRest;
local tStacks;
local tCnt;
local tCaster;
local tBuffName;
local tStart, tEnabled;
local tSmDuration;
local tDiffIcon;
local tHotFromBuff;
local tIsMine;
local sDuration;
local tHotInfo, tIndex;
local tSpellId, tDebuffOffset;
local function VUHDO_updateHots(aUnit, anInfo, aNow)
	if (anInfo.isVehicle) then
		VUHDO_removeHots(aUnit);
		aUnit = anInfo.petUnit;
	end

	if (VUHDO_MY_HOTS[aUnit] == nil) then
		VUHDO_MY_HOTS[aUnit] = { };
	end

	if (VUHDO_OTHER_HOTS[aUnit] == nil) then
		VUHDO_OTHER_HOTS[aUnit] = { };
	end

	if (VUHDO_MY_AND_OTHERS_HOTS[aUnit] == nil) then
		VUHDO_MY_AND_OTHERS_HOTS[aUnit] = { };
	end

	for tIndex, tHotInfo in pairs(VUHDO_MY_HOTS[aUnit]) do
		tHotInfo[1] = nil; -- Rest == nil => Icon lschen
	end

	for tIndex, tHotInfo in pairs(VUHDO_OTHER_HOTS[aUnit]) do
		tHotInfo[1] = nil;
	end

	for tIndex, tHotInfo in pairs(VUHDO_MY_AND_OTHERS_HOTS[aUnit]) do
		tHotInfo[1] = nil;
	end

	sIsSwiftmend = false;
	tOtherIcon = nil;

	tOtherHotCnt = 0;
	tDebuffOffset = nil;
	for tCnt = 1, 255 do
	  if (tDebuffOffset == nil) then
		  tBuffName, _, tBuffIcon, tStacks, _, sDuration, tRest, tCaster, _, _, tSpellId = UnitBuff(aUnit, tCnt);
  		if (tBuffIcon == nil) then
  			tDebuffOffset = tCnt - 1;
  		end
  	end

	  if (tDebuffOffset ~= nil) then
		  tBuffName, _, tBuffIcon, tStacks, _, sDuration, tRest, tCaster, _, _, tSpellId = UnitDebuff(aUnit, tCnt - tDebuffOffset, false);
  		if (tBuffIcon == nil) then
  			break;
  		end
		end

		if (VUHDO_KNOWS_SWIFTMEND and not sIsSwiftmend) then
			if (VUHDO_SPELL_ID_REGROWTH == tBuffName or VUHDO_SPELL_ID_REJUVENATION == tBuffName) then
				tStart, tSmDuration, tEnabled = GetSpellCooldown(VUHDO_SPELLS[VUHDO_SPELL_ID_SWIFTMEND].id, BOOKTYPE_SPELL);
				if (tEnabled ~= 0 and (tStart == nil or tSmDuration == nil or tStart <= 0 or tSmDuration <= 1.6)) then
					sIsSwiftmend = true;
				end
			end
		end

		if (tRest ~= nil and tCaster ~= nil) then
			tIsMine = UnitIsUnit("player", tCaster);
			tHotFromBuff = sBuffs2Hots[tBuffName .. tBuffIcon];
			if (tHotFromBuff == "" or (tSpellId ~= nil and VUHDO_IGNORE_HOT_IDS[tSpellId])) then -- non hot buff
			elseif(tHotFromBuff ~= nil) then -- Hot buff cached
				tRest = tRest - aNow;
				if (tRest > 0) then
					VUHDO_snapshotHot(tHotFromBuff, tRest, tStacks, tBuffIcon, tIsMine, sDuration, aUnit);
				end
			else -- not yet scanned
				sBuffs2Hots[tBuffName .. tBuffIcon] = "";
				for tHotCmpName, _ in pairs(VUHDO_ACTIVE_HOTS) do
					tDiffIcon = VUHDO_CAST_ICON_DIFF[tHotCmpName];

					if (tDiffIcon == tBuffIcon
					or (tDiffIcon == nil and tBuffName == tHotCmpName)
					or (VUHDO_SPELLS[tHotCmpName] ~= nil and tBuffIcon == VUHDO_SPELLS[tHotCmpName].icon)) then
						tRest = tRest - aNow;
						if (tRest > 0) then
							VUHDO_snapshotHot(tHotCmpName, tRest, tStacks, tBuffIcon, tIsMine, sDuration, aUnit);
						end
						sBuffs2Hots[tBuffName .. tBuffIcon] = tHotCmpName;
						break;
					end
				end
			end

			if (not tIsMine and VUHDO_HEALING_HOTS[tBuffName] and not VUHDO_ACTIVE_HOTS_OTHERS[tBuffName]) then
				tOtherHotCnt = tOtherHotCnt + 1;
				tOtherIcon = tBuffIcon;
			end
		end
	end
	-- Own
	for tHotCmpName, tHotInfo in pairs(VUHDO_MY_HOTS[aUnit]) do
		VUHDO_updateHotIcons(aUnit, tHotCmpName, tHotInfo[1], tHotInfo[2], tHotInfo[3], tHotInfo[4], 1);
		if (tHotInfo[1] == nil) then
			table.wipe(tHotInfo);
			VUHDO_MY_HOTS[aUnit][tHotCmpName] = nil;
		end
	end
	-- Others
	for tHotCmpName, tHotInfo in pairs(VUHDO_OTHER_HOTS[aUnit]) do
		VUHDO_updateHotIcons(aUnit, tHotCmpName, tHotInfo[1], tHotInfo[2], tHotInfo[3], tHotInfo[4], 2);
		if (tHotInfo[1] == nil) then
			table.wipe(tHotInfo);
			VUHDO_OTHER_HOTS[aUnit][tHotCmpName] = nil;
		end
	end
	-- Own+Others
	for tHotCmpName, tHotInfo in pairs(VUHDO_MY_AND_OTHERS_HOTS[aUnit]) do
		VUHDO_updateHotIcons(aUnit, tHotCmpName, tHotInfo[1], tHotInfo[2], tHotInfo[3], tHotInfo[4], 3);
		if (tHotInfo[1] == nil) then
			table.wipe(tHotInfo);
			VUHDO_MY_AND_OTHERS_HOTS[aUnit][tHotCmpName] = nil;
		end
	end

	-- Other players' HoTs
	if (VUHDO_ACTIVE_HOTS["OTHER"]) then
		VUHDO_updateHotIcons(aUnit, "OTHER", 999, tOtherHotCnt, tOtherIcon, nil, 0);
	end

	-- Clusters
	if (VUHDO_ACTIVE_HOTS["CLUSTER"]) then
		VUHDO_updateAllClusterIcons(aUnit);
	end

	-- Dispellable Debuffs
	if (VUHDO_ACTIVE_HOTS["DISPELLABLE"]) then
		VUHDO_updateAllDispellableIcons(aUnit);
	end

	if (VUHDO_KNOWS_SWIFTMEND) then
		if (sIsSwiftmend) then
			tAllButtons = VUHDO_getUnitButtons(aUnit);
			if (tAllButtons == nil) then
				return;
			end
			for _, tButton in pairs(tAllButtons) do
				if (VUHDO_PANEL_SETUP[VUHDO_BUTTON_CACHE[tButton:GetName()]]["HOTS"].showSwiftmend) then
					VUHDO_getBarRoleIcon(tButton, 51):Show();
				else
					VUHDO_getBarRoleIcon(tButton, 51):Hide();
				end
			end
		else
			tAllButtons = VUHDO_getUnitButtons(aUnit);
			if (tAllButtons == nil) then
				return;
			end
			for _, tButton in pairs(tAllButtons) do
				VUHDO_getBarRoleIcon(tButton, 51):Hide();
			end
		end
	end
end



local VUHDO_HOTS_SUSPENDED = false;

function VUHDO_suspendHoTs(aFlag)
	VUHDO_HOTS_SUSPENDED = aFlag;
end


--
local tUnit, tInfo, tNow;
function VUHDO_updateAllHoTs()
	if (VUHDO_HOTS_SUSPENDED) then
		return;
	end

	tNow = GetTime();
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		VUHDO_updateHots(tUnit, tInfo, tNow);
	end
  if (VUHDO_CONFIG["CLUSTER"]["IS_HOVER"]) then
		VUHDO_updateClusterHighlights();
	end
end



--
local tCnt, tCnt2, tCnt3;
local tButton;
local tPrefix, tHbPrefix;
function VUHDO_removeAllHots()
	for tCnt = 1, VUHDO_MAX_PANELS do
		if (VUHDO_isPanelVisible(tCnt)) then

			for tCnt2 = 1, VUHDO_MAX_BUTTONS_PANEL do
				tButton = VUHDO_getHealButton(tCnt2, tCnt);
				--if (tButton == nil or tButton.target == nil) then
				if (tButton == nil) then
					break;
				end

				tHbPrefix = VUHDO_getHealthBar(tButton, 1):GetName() .. "Ic";
				for tCnt3 = 1, 5 do
					tPrefix = tHbPrefix .. tCnt3;
					VUHDO_GLOBAL[tPrefix  .. "I"]:SetAlpha(0);
					VUHDO_GLOBAL[tPrefix  .. "T"]:SetText("");
					VUHDO_GLOBAL[tPrefix  .. "A"]:Hide();
					VUHDO_GLOBAL[tPrefix  .. "C"]:SetText("");
				end

				for tCnt3 = 9, 11 do
					VUHDO_getHealthBar(tButton, tCnt3):SetValue(0);
				end

				if (tButton.target ~= nil) then
					VUHDO_updatePlayerTargetFrame(VUHDO_getPlayerTargetFrame(tButton), tButton.target);
				end
				VUHDO_getBarRoleIcon(tButton, 51):Hide();
				VUHDO_getClusterBorderFrame(tButton):Hide();
			end
		end
	end

	VUHDO_updatePlayerTarget();
end



--
function VUHDO_resetHotBuffCache()
	table.wipe(sBuffs2Hots);
end
