

-- BURST CACHE ---------------------------------------------------


local VUHDO_RAID;
local VUHDO_POWER_TYPE_COLORS;
local VUHDO_BUTTON_CACHE;
local VUHDO_PANEL_SETUP;
local VUHDO_UNIT_BUTTONS;
local VUHDO_IN_RAID_TARGET_BUTTONS;

local UnitPowerType = UnitPowerType;
local UnitMana = UnitMana;
local UnitManaMax = UnitManaMax;

local VUHDO_getHealthBar;
local VUHDO_getUnitButtons;
local VUHDO_isConfigDemoUsers;
function VUHDO_customManaInitBurst()
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_POWER_TYPE_COLORS = VUHDO_GLOBAL["VUHDO_POWER_TYPE_COLORS"];
	VUHDO_BUTTON_CACHE = VUHDO_GLOBAL["VUHDO_BUTTON_CACHE"];
	VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];
	VUHDO_UNIT_BUTTONS = VUHDO_GLOBAL["VUHDO_UNIT_BUTTONS"];
	VUHDO_IN_RAID_TARGET_BUTTONS = VUHDO_GLOBAL["VUHDO_IN_RAID_TARGET_BUTTONS"];

	VUHDO_getHealthBar = VUHDO_GLOBAL["VUHDO_getHealthBar"];
	VUHDO_getUnitButtons = VUHDO_GLOBAL["VUHDO_getUnitButtons"];
	VUHDO_isConfigDemoUsers = VUHDO_GLOBAL["VUHDO_isConfigDemoUsers"];
end

----------------------------------------------------

local sOpacity;


--
local tPanelNum;
local tManaBar;
function VUHDO_customizeManaBar(aButton, aColor, anInfo)
	tPanelNum = VUHDO_BUTTON_CACHE[aButton:GetName()];
	if (VUHDO_PANEL_SETUP[tPanelNum]["SCALING"].showManaBars
		and (anInfo["powertype"] == 0 or VUHDO_PANEL_SETUP[tPanelNum]["SCALING"].showRageBars) and anInfo.connected) then

		tManaBar = VUHDO_getHealthBar(aButton, 2);
		-- Some addons, i suspect libQuickHealth return 1 mana-max instead of zero
		if (anInfo.powermax < 2) then
			tManaBar:SetValue(0);
		else
			tManaBar:SetValue(100 * anInfo.power / anInfo.powermax);
		end

		if (aColor ~= nil) then
			if (not anInfo.range) then
				tManaBar:SetStatusBarColor(aColor.R, aColor.G, aColor.B, aColor.O * sOpacity);
			else
				tManaBar:SetStatusBarColor(aColor.R, aColor.G, aColor.B, aColor.O);
			end
		end
	else
		VUHDO_getHealthBar(aButton, 2):SetValue(0);
	end
end
local VUHDO_customizeManaBar = VUHDO_customizeManaBar;



--
local tAllButtons;
local tInfo;
local tColor;
local tButton;
local tPowerType;
function VUHDO_updateManaBars(aUnit, aChange)
	tAllButtons = VUHDO_getUnitButtons(aUnit);
	tInfo = VUHDO_RAID[aUnit];
	if (tAllButtons == nil or tInfo == nil) then
		return;
	end

	if (tInfo.isVehicle) then
		if (tInfo.petUnit == nil) then
			return;
		end
		
		aUnit = tInfo.petUnit;
	end

	if (not VUHDO_isConfigDemoUsers()) then
		if (aChange == 1) then
			tInfo["power"] = UnitMana(aUnit);
		elseif (aChange == 2) then
			tInfo["powermax"] = UnitManaMax(aUnit);
		elseif (aChange == 3) then
			tPowerType = UnitPowerType(aUnit);
			tInfo["powertype"] = tonumber(tPowerType);
			tInfo["powermax"] = UnitManaMax(aUnit);
			tInfo["power"] = UnitMana(aUnit);
		else
			-- range
		end
	end

	tColor = VUHDO_POWER_TYPE_COLORS[tInfo.powertype]; -- when not connected

	sOpacity = VUHDO_PANEL_SETUP["BAR_COLORS"]["OUTRANGED"].O
	for _, tButton in pairs(tAllButtons) do
		VUHDO_customizeManaBar(tButton, tColor, tInfo);
	end

	-- Targets und targets-of-target, die im Raid sind
  tAllButtons = VUHDO_IN_RAID_TARGET_BUTTONS[tInfo.name];
	if (tAllButtons == nil) then
		return;
	end
	for _, tButton in pairs(tAllButtons) do
		VUHDO_customizeManaBar(tButton, tColor, tInfo);
	end
end
