local VUHDO_CUSTOM_DEBUFF_LIST = { };
local VUHDO_UNIT_CUSTOM_DEBUFFS = { };
local VUHDO_LAST_UNIT_DEBUFFS = { };

VUHDO_DEBUFF_BLACKLIST = {
	[GetSpellInfo(69127)] = true, -- Chill of the Throne (stndiger debuff)
	[GetSpellInfo(57724)] = true, -- Sated
	[GetSpellInfo(71328)] = true  -- Dungeon Cooldown
}


local VUHDO_NEXT_SOUND_TIME = 0;

-- BURST CACHE ---------------------------------------------------

local VUHDO_CONFIG;
local VUHDO_RAID;
local VUHDO_PANEL_SETUP;

local VUHDO_isInFight;
local VUHDO_DEBUFF_BLACKLIST = { };

local UnitDebuff = UnitDebuff;
local UnitBuff = UnitBuff;
local table = table;

function VUHDO_debuffsInitBurst()
	VUHDO_CONFIG = VUHDO_GLOBAL["VUHDO_CONFIG"];
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];
	VUHDO_DEBUFF_BLACKLIST = VUHDO_GLOBAL["VUHDO_DEBUFF_BLACKLIST"];

	VUHDO_isInFight = VUHDO_GLOBAL["VUHDO_isInFight"];
end

----------------------------------------------------


local tCnt;
local tIsRmOnly;
local tName, tIcon, tType;
local tChosen;
local tDebuff;
local tAbility;
local tDebuffType;



--
local tUnit, tInfo;
function VUHDO_updateAllCustomDebuffs(anIsEnableAnim)
	table.wipe(VUHDO_UNIT_CUSTOM_DEBUFFS);
	VUHDO_MAY_DEBUFF_ANIM = false;
	for tUnit, tInfo in pairs(VUHDO_RAID) do
		VUHDO_removeAllDebuffIcons(tUnit);
		tInfo.debuff, tInfo.debuffName = VUHDO_determineDebuff(tUnit, tInfo.class);
	end
	VUHDO_MAY_DEBUFF_ANIM = anIsEnableAnim;
end



--
local tCopies = { }, tCopy;
local tIndex = 0;
local function VUHDO_copyColorRevolving(aColor)
	tIndex = tIndex + 1;
	if (tIndex > 40) then
		tIndex = 1;
	end

	if (tCopies[tIndex] == nil) then
		tCopies[tIndex] = { };
	end

	tCopy = tCopies[tIndex];
	tCopy.R, tCopy.G, tCopy.B, tCopy.O = aColor.R, aColor.G, aColor.B, aColor.O;
	tCopy.TR, tCopy.TG, tCopy.TB, tCopy.TO = aColor.TR, aColor.TG, aColor.TB, aColor.TO;
	tCopy.useBackground, tCopy.useText, tCopy.useOpacity = aColor.useBackground, aColor.useText, aColor.useOpacity;
	return tCopy;
end



--
local tSourceColor;
local tDebuffSettings;
local tCustomColor;
local tEmpty = { };
function VUHDO_getDebuffColor(anInfo)

	if (anInfo.charmed) then
		return VUHDO_copyColorRevolving(VUHDO_PANEL_SETUP["BAR_COLORS"]["CHARMED"]);
	elseif (anInfo.mibucateg == nil and (anInfo.debuff == VUHDO_DEBUFF_TYPE_NONE or anInfo.debuff == nil)) then
	  return VUHDO_copyColorRevolving(tEmpty);
	end

	tCustomColor = VUHDO_copyColorRevolving(tEmpty);
	tDebuffSettings = VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][anInfo.debuffName];

	if (anInfo.debuff ~= nil and anInfo.debuff ~= VUHDO_DEBUFF_TYPE_CUSTOM and VUHDO_PANEL_SETUP["BAR_COLORS"]["DEBUFF" .. anInfo.debuff] ~= nil) then
		return VUHDO_copyColorRevolving(VUHDO_PANEL_SETUP["BAR_COLORS"]["DEBUFF" .. anInfo.debuff]);
	elseif (anInfo.debuff == VUHDO_DEBUFF_TYPE_CUSTOM and tDebuffSettings ~= nil and tDebuffSettings.isColor) then
		tSourceColor = tDebuffSettings.color;

		if (VUHDO_PANEL_SETUP.BAR_COLORS.DEBUFF6.useBackground) then
			tCustomColor.useBackground = true;
			tCustomColor.R, tCustomColor.G, tCustomColor.B, tCustomColor.O
				= tSourceColor.R, tSourceColor.G, tSourceColor.B, tSourceColor.O;
		end

		if (VUHDO_PANEL_SETUP.BAR_COLORS.DEBUFF6.useText) then
			tCustomColor.useText = true;
			tCustomColor.TR, tCustomColor.TG, tCustomColor.TB, tCustomColor.TO
				= tSourceColor.TR, tSourceColor.TG, tSourceColor.TB, tSourceColor.TO;
		end
		return tCustomColor;
	end

  if (anInfo.mibucateg == nil or VUHDO_BUFF_SETTINGS[anInfo.mibucateg] == nil) then
    return tCustomColor;
  end

	tSourceColor = VUHDO_BUFF_SETTINGS[anInfo.mibucateg].missingColor;
	if (VUHDO_BUFF_SETTINGS["CONFIG"]["BAR_COLORS_TEXT"]) then
		tCustomColor.useText = true;
		tCustomColor.TR, tCustomColor.TG, tCustomColor.TB, tCustomColor.TO
			= tSourceColor.TR, tSourceColor.TG, tSourceColor.TB, tSourceColor.TO;
	end

	if (VUHDO_BUFF_SETTINGS["CONFIG"]["BAR_COLORS_BACKGROUND"]) then
		tCustomColor.useBackground = true;
		tCustomColor.R, tCustomColor.G, tCustomColor.B, tCustomColor.O
			= tSourceColor.R, tSourceColor.G, tSourceColor.B, tSourceColor.O;
	end

	return tCustomColor;
end



--
local function VUHDO_isDebuffRelevant(aDebuffName, aClass)
	if (VUHDO_IGNORE_DEBUFFS_BY_CLASS[aClass][aDebuffName]) then
		return false;
	end

	if (VUHDO_CONFIG["DETECT_DEBUFFS_IGNORE_NO_HARM"] and VUHDO_IGNORE_DEBUFFS_NO_HARM[aDebuffName]) then
		return false;
	end

	if (VUHDO_CONFIG["DETECT_DEBUFFS_IGNORE_MOVEMENT"] and VUHDO_IGNORE_DEBUFFS_MOVEMENT[aDebuffName]) then
		return false;
	end

	if (VUHDO_CONFIG["DETECT_DEBUFFS_IGNORE_DURATION"] and VUHDO_IGNORE_DEBUFFS_DURATION[aDebuffName]) then
		return false;
	end

	return true;
end



--
local tDebuffInfo;
local function VUHDO_isCustomDebuff(aName)
	tDebuffInfo = VUHDO_CUSTOM_DEBUFF_LIST[aName];
	if (tDebuffInfo ~= nil) then
		return tDebuffInfo[1], tDebuffInfo[2];
	else
		return false, false;
	end
end



local VUHDO_CUSTOM_BUFF_BLACKLIST = {
	[GetSpellInfo(67847)] = true -- Expose Weakness ist ein Boss-Debuff und gleichzeitig ein Jger-Buff
}



--
local tDebuffInfo;
local function VUHDO_isCustomBuff(aName)
	tDebuffInfo = VUHDO_CUSTOM_DEBUFF_LIST[aName];
	if (tDebuffInfo ~= nil and VUHDO_CUSTOM_BUFF_BLACKLIST[aName] == nil) then
		return tDebuffInfo[1], tDebuffInfo[2];
	else
		return false, false;
	end
end



--
local tSetColor, tSetIcon;
local tIconsSet = { };
local tExpiry, tStacks;
local tDebuffInfo;
local tHasPlayed;
local tInfo;
local tDebuffName, tSoundDebuff;
local tSound;
local tIsStandardDebuff;
function VUHDO_determineDebuff(aUnit, aClassName)
	if (not VUHDO_CONFIG["DETECT_DEBUFFS"] or aClassName == nil) then
		return VUHDO_DEBUFF_TYPE_NONE, "";
	end

	if (VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit] == nil) then
		VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit] = { };
	end

	tIsRmOnly = VUHDO_CONFIG["DETECT_DEBUFFS_REMOVABLE_ONLY"];

	tInfo = VUHDO_RAID[aUnit];
	if (tInfo == nil) then
		return VUHDO_DEBUFF_TYPE_NONE, "";
	end

	if (tInfo.missbuff ~= nil
		and (not VUHDO_isInFight() or VUHDO_BUFF_SETTINGS["CONFIG"]["BAR_COLORS_IN_FIGHT"])) then
		tChosen = VUHDO_DEBUFF_TYPE_MISSING_BUFF;
	else
		tChosen = VUHDO_DEBUFF_TYPE_NONE;
	end
	tDebuffName = "";
	tSoundDebuff = nil;
	tCnt = 1;
	tIsStandardDebuff = false;

	table.wipe(tIconsSet);
	while (true) do
		tName, _, tIcon, tStacks, tType, _, tExpiry = UnitDebuff(aUnit, tCnt, false);

		if (tIcon == nil or tName == nil) then
			break;
		end

		tSetColor, tSetIcon = VUHDO_isCustomDebuff(tName);
		if (tSetColor) then
			tChosen = VUHDO_DEBUFF_TYPE_CUSTOM;
			tDebuffName = tName;
			tSoundDebuff = tName;
		end

		if (tStacks == nil) then
			tStacks = 0;
		end

		if (tSetIcon) then
			tIconsSet[tName] = { tIcon, tExpiry, tStacks };
			tSoundDebuff = tName;
		end

		if (tChosen ~= VUHDO_DEBUFF_TYPE_CUSTOM) then
  		tDebuff = VUHDO_DEBUFF_TYPES[tType];
			tAbility = VUHDO_DEBUFF_ABILITIES[VUHDO_PLAYER_CLASS][tDebuff];
			if (not tIsRmOnly or tAbility ~= nil) then
				if (VUHDO_isDebuffRelevant(tName, aClassName)) then

					if (tAbility ~= nil or tChosen == VUHDO_DEBUFF_TYPE_NONE
						or (tChosen == VUHDO_DEBUFF_TYPE_DISEASE and tDebuff == VUHDO_DEBUFF_TYPE_MAGIC)) then
						tChosen = tDebuff;
					end

					if (VUHDO_PANEL_SETUP["BAR_COLORS"].useDebuffIcon and not VUHDO_DEBUFF_BLACKLIST[tName]) then
						tIconsSet[tName] = { tIcon, tExpiry, tStacks };
						tIsStandardDebuff = true;
					end
				end
			end
		end

		tCnt = tCnt + 1;
	end

	tCnt = 1;
	while (true) do
		tName, _, tIcon, tStacks, _, _, tExpiry = UnitBuff(aUnit, tCnt, false);

		if (tIcon == nil) then
			break;
		end

		tSetColor, tSetIcon = VUHDO_isCustomBuff(tName);
		if (tSetColor) then
			tChosen = VUHDO_DEBUFF_TYPE_CUSTOM;
			tDebuffName = tName;
			tSoundDebuff = tName;
		end

		if (tStacks == nil) then
			tStacks = 0;
		end

		if (tSetIcon) then
			tIconsSet[tName] = { tIcon, tExpiry, tStacks };
			tSoundDebuff = tName;
		end

		tCnt = tCnt + 1;
	end

	tHasPlayed = false;
	-- Gained new custom debuff?
	for tName, tDebuffInfo in pairs(tIconsSet) do
		if (VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] == nil) then
			VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] = { tDebuffInfo[2], tDebuffInfo[3] };
			VUHDO_addDebuffIcon(aUnit, tDebuffInfo[1], tName, tDebuffInfo[2], tDebuffInfo[3]);
			if (not VUHDO_IS_CONFIG and VUHDO_MAY_DEBUFF_ANIM) then
				if (tSoundDebuff ~= nil and VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tSoundDebuff] ~= nil) then
					tSound = VUHDO_CONFIG["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tSoundDebuff].SOUND;
					if (tSound ~= nil
						and strlen(tSound) > 0
						and tSound ~= "Interface\\Quiet.mp3"
						and GetTime() > VUHDO_NEXT_SOUND_TIME) then

						PlaySoundFile(tSound);
						tHasPlayed = true;
						VUHDO_NEXT_SOUND_TIME = GetTime() + 2;
					end
				elseif (VUHDO_CONFIG["CUSTOM_DEBUFF"].SOUND ~= nil
					and tSound ~= "Interface\\Quiet.mp3"
					and GetTime() > VUHDO_NEXT_SOUND_TIME
					and tSoundDebuff ~= nil) then

					PlaySoundFile(VUHDO_CONFIG["CUSTOM_DEBUFF"].SOUND);
					tHasPlayed = true;
					VUHDO_NEXT_SOUND_TIME = GetTime() + 2;
				end

			end
		-- update number of stacks?
		elseif(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName][1] ~= tDebuffInfo[2]
			or VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName][2] ~= tDebuffInfo[3]) then
			table.wipe(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName]);
			VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] = { tDebuffInfo[2], tDebuffInfo[3] };
			VUHDO_updateDebuffIcon(aUnit, tDebuffInfo[1], tName, tDebuffInfo[2], tDebuffInfo[3]);
		end
	end

	-- Lost old custom debuff?
	for tName, _ in pairs(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit]) do
		if (tIconsSet[tName] == nil) then
			table.wipe(VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName]);
			VUHDO_UNIT_CUSTOM_DEBUFFS[aUnit][tName] = nil;
			VUHDO_removeDebuffIcon(aUnit, tName);
		end
	end

	-- Play Sound?
	if (VUHDO_CONFIG["SOUND_DEBUFF"] ~= nil
		and (tChosen ~= VUHDO_DEBUFF_TYPE_NONE or tIsStandardDebuff)
		and tChosen ~= VUHDO_DEBUFF_TYPE_MISSING_BUFF
		and tChosen ~= VUHDO_DEBUFF_TYPE_CUSTOM
		and not tHasPlayed) then
		if (VUHDO_LAST_UNIT_DEBUFFS[aUnit] ~= tChosen
			and tInfo.range
			and VUHDO_CONFIG["SOUND_DEBUFF"] ~= nil
			and VUHDO_CONFIG["SOUND_DEBUFF"] ~= "Interface\\Quiet.mp3"
			and GetTime() > VUHDO_NEXT_SOUND_TIME) then

			PlaySoundFile(VUHDO_CONFIG["SOUND_DEBUFF"]);
			VUHDO_NEXT_SOUND_TIME = GetTime() + 2;
		end
	end

	if (tInfo.range) then
		VUHDO_LAST_UNIT_DEBUFFS[aUnit] = tChosen;
	end

	return tChosen, tDebuffName;
end



-- Remove debuffing abilities individually not known to the player
local tDebuffName;
local tClass;
function VUHDO_initDebuffs()
	table.wipe(VUHDO_DEBUFF_ABILITIES);
	VUHDO_DEBUFF_ABILITIES = VUHDO_deepCopyTable(VUHDO_INIT_DEBUFF_ABILITIES);
	_, tClass = UnitClass("player");

	for tDebuffType, tAbility in pairs(VUHDO_DEBUFF_ABILITIES[tClass] or { }) do
		if (not VUHDO_isSpellKnown(tAbility)) then
			VUHDO_DEBUFF_ABILITIES[VUHDO_PLAYER_CLASS][tDebuffType] = nil;
		end
	end

	table.wipe(VUHDO_CUSTOM_DEBUFF_LIST);

	for _, tDebuffName in pairs(VUHDO_GLOBAL["VUHDO_CONFIG"]["CUSTOM_DEBUFF"]["STORED"]) do
		VUHDO_CUSTOM_DEBUFF_LIST[tDebuffName] = {
			VUHDO_GLOBAL["VUHDO_CONFIG"]["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tDebuffName].isColor,
			VUHDO_GLOBAL["VUHDO_CONFIG"]["CUSTOM_DEBUFF"]["STORED_SETTINGS"][tDebuffName].isIcon
		};
	end
end
