local VUHDO_DEBUFF_ANIMATION = 0;

local VUHDO_EVENT_COUNT = 0;
local VUHDO_LAST_TIME_NO_EVENT = GetTime();

-- BURST CACHE ---------------------------------------------------

local VUHDO_RAID;
local VUHDO_PANEL_SETUP;

local VUHDO_parseAddonMessage;
local VUHDO_spellcastStop;
local VUHDO_spellcastFailed;
local VUHDO_spellcastSucceeded;
local VUHDO_spellcastSent;
local VUHDO_parseCombatLogEvent;
local VUHDO_updateAllOutRaidTargetButtons;
local VUHDO_updateAllRaidTargetIndices;


local VUHDO_updateHealth;
local VUHDO_updateManaBars;
local VUHDO_updateTargetBars;
local VUHDO_updateAllRaidBars;
local VUHDO_updateHealthBarsFor;
local VUHDO_updateThreatPerc;
local VUHDO_updateAllHoTs;
local VUHDO_updateAllDebuffIcons;
local VUHDO_updateAllClusters;
local VUHDO_clearObsoleteInc;

local GetTime = GetTime;
local UnitIsUnit = UnitIsUnit;
local CheckInteractDistance = CheckInteractDistance;
local UnitInRange = UnitInRange;
local IsSpellInRange = IsSpellInRange;
local UnitDetailedThreatSituation = UnitDetailedThreatSituation;
local UnitIsCharmed = UnitIsCharmed;
local UnitCanAttack = UnitCanAttack;
local UnitName = UnitName;
local UnitIsEnemy = UnitIsEnemy;
local GetSpellCooldown = GetSpellCooldown;

local VuhDoGcdStatusBar;

local function VUHDO_eventHandlerInitBurst()
	VUHDO_RAID = VUHDO_GLOBAL["VUHDO_RAID"];
	VUHDO_PANEL_SETUP = VUHDO_GLOBAL["VUHDO_PANEL_SETUP"];

	VUHDO_updateHealth = VUHDO_GLOBAL["VUHDO_updateHealth"];
	VUHDO_updateManaBars = VUHDO_GLOBAL["VUHDO_updateManaBars"];
	VUHDO_updateTargetBars = VUHDO_GLOBAL["VUHDO_updateTargetBars"];
	VUHDO_updateAllRaidBars = VUHDO_GLOBAL["VUHDO_updateAllRaidBars"];
	VUHDO_updateAllOutRaidTargetButtons = VUHDO_GLOBAL["VUHDO_updateAllOutRaidTargetButtons"];
	VUHDO_parseAddonMessage = VUHDO_GLOBAL["VUHDO_parseAddonMessage"];
	VUHDO_spellcastStop = VUHDO_GLOBAL["VUHDO_spellcastStop"];
	VUHDO_spellcastFailed = VUHDO_GLOBAL["VUHDO_spellcastFailed"];
	VUHDO_spellcastSucceeded = VUHDO_GLOBAL["VUHDO_spellcastSucceeded"];
	VUHDO_spellcastSent = VUHDO_GLOBAL["VUHDO_spellcastSent"];
	VUHDO_parseCombatLogEvent = VUHDO_GLOBAL["VUHDO_parseCombatLogEvent"];
	VUHDO_updateHealthBarsFor = VUHDO_GLOBAL["VUHDO_updateHealthBarsFor"];
	VUHDO_updateThreatPerc = VUHDO_GLOBAL["VUHDO_updateThreatPerc"];
	VUHDO_updateAllHoTs = VUHDO_GLOBAL["VUHDO_updateAllHoTs"];
	VUHDO_updateAllDebuffIcons = VUHDO_GLOBAL["VUHDO_updateAllDebuffIcons"];
	VUHDO_clearObsoleteInc = VUHDO_GLOBAL["VUHDO_clearObsoleteInc"];
	VUHDO_updateAllRaidTargetIndices = VUHDO_GLOBAL["VUHDO_updateAllRaidTargetIndices"];
	VUHDO_updateAllClusters = VUHDO_GLOBAL["VUHDO_updateAllClusters"];
	VuhDoGcdStatusBar = VUHDO_GLOBAL["VuhDoGcdStatusBar"];
end

----------------------------------------------------

local VUHDO_VARIABLES_LOADED = false;

local VUHDO_UPDATE_RANGE_TIMER;
local VUHDO_REFRESH_DRAG_DELAY = 0.05;
local VUHDO_REFRESH_DRAG_TIMER = VUHDO_REFRESH_DRAG_DELAY;
local VUHDO_CUSTOMIZE_TIMER = 0;
local VUHDO_IS_RELOAD_BUFFS = false;
local VUHDO_LOST_CONTROL = false;
local VUHDO_RELOAD_AFTER_BATTLE = false;
local VUHDO_RELOAD_UI_TIMER = 0;
local VUHDO_RELOAD_PANEL_TIMER = 0;
local VUHDO_RELOAD_PANEL_NUM = nil;
local VUHDO_RELOAD_LAG_DELAY = 3.1;
local VUHDO_RELOAD_LAG_TIMER = VUHDO_RELOAD_LAG_DELAY * 2;
local VUHDO_UPDATE_CLUSTERS_TIMER = 0;

local VUHDO_REFRESH_INSPECT_DELAY = 2.1;
local VUHDO_REFRESH_INSPECT_TIMER = VUHDO_REFRESH_INSPECT_DELAY;


local VUHDO_REFRESH_TOOLTIP_DELAY = 2.3;
local VUHDO_REFRESH_TOOLTIP_TIMER = VUHDO_REFRESH_TOOLTIP_DELAY;

local VUHDO_UPDATE_AGGRO_TIMER;

local VUHDO_UPDATE_CHARMED_DELAY = 0.2;
local VUHDO_UPDATE_CHARMED_TIMER = VUHDO_UPDATE_CHARMED_DELAY;

local VUHDO_UPDATE_HOTS_DELAY = 0.25;
local VUHDO_UPDATE_HOTS_TIMER = VUHDO_UPDATE_HOTS_DELAY;

local VUHDO_REFRESH_TARGETS_DELAY = 0.5;
local VUHDO_REFRESH_TARGETS_TIMER = VUHDO_REFRESH_TARGETS_DELAY;
local VUHDO_GCD_UPDATE = false;


local tUnit, tInfo;


VUHDO_CONFIG = nil;
VUHDO_PANEL_SETUP = nil;
VUHDO_SPELL_ASSIGNMENTS = nil;
VUHDO_SPELLS_KEYBOARD = nil;
VUHDO_SPELL_CONFIG = nil;

VUHDO_IS_RELOADING = false;
VUHDO_FONTS = { };
VUHDO_STATUS_BARS = { };
VUHDO_SOUNDS = { };
VUHDO_BORDERS = { };
VUHDO_LAST_AUTO_ARRANG = nil;

local VUHDO_RELOAD_RAID_DELAY = 1.8; -- Seconds to wait before reloading raid after "PARTY_MEMBERS_CHANGED" etc.
local VUHDO_RELOAD_RAID_DELAY_QUICK = 0.3; -- Seconds to wait before reloading raid quickly after raid changed in fight etc.
local VUHDO_RELOAD_RAID_TIMER = 0;

VUHDO_MAINTANK_NAMES = { };
VUHDO_RESSING_NAMES = { };
local VUHDO_FIRST_RELOAD_UI = false;

VUHDO_FONT_EMBLEM = "Interface\\AddOns\\VuhDo\\Fonts\\Emblem.ttf";

VUHDO_LibSharedMedia = LibStub("LibSharedMedia-3.0");

VUHDO_LibSharedMedia:Register("font", "Arial Black", "Interface\\AddOns\\VuhDo\\Fonts\\ariblk.ttf");
VUHDO_LibSharedMedia:Register("font", "Emblem",	VUHDO_FONT_EMBLEM);

VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Rhombs", "Interface\\AddOns\\VuhDo\\Images\\bar1.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Twirls", "Interface\\AddOns\\VuhDo\\Images\\bar2.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Pipe, dark", "Interface\\AddOns\\VuhDo\\Images\\bar3.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Concave, dark", "Interface\\AddOns\\VuhDo\\Images\\bar4.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Pipe, light", "Interface\\AddOns\\VuhDo\\Images\\bar5.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Flat", "Interface\\AddOns\\VuhDo\\Images\\bar6.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Concave, light", "Interface\\AddOns\\VuhDo\\Images\\bar7.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Convex", "Interface\\AddOns\\VuhDo\\Images\\bar8.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Textile", "Interface\\AddOns\\VuhDo\\Images\\bar9.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Mirrorfinish", "Interface\\AddOns\\VuhDo\\Images\\bar10.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Diagonals", "Interface\\AddOns\\VuhDo\\Images\\bar11.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Zebra", "Interface\\AddOns\\VuhDo\\Images\\bar12.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Marble", "Interface\\AddOns\\VuhDo\\Images\\bar13.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Modern Art", "Interface\\AddOns\\VuhDo\\Images\\bar14.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Polished Wood", "Interface\\AddOns\\VuhDo\\Images\\bar15.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Plain", "Interface\\AddOns\\VuhDo\\Images\\bar16.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Minimalist", "Interface\\AddOns\\VuhDo\\Images\\bar17.tga");
VUHDO_LibSharedMedia:Register("statusbar", "VuhDo - Aluminium", "Interface\\AddOns\\VuhDo\\Images\\bar18.tga");

VUHDO_LibSharedMedia:Register("sound", "Tribal Bass Drum", "Sound\\Doodad\\BellTollTribal.wav");
VUHDO_LibSharedMedia:Register("sound", "Thorns", "Sound\\Spells\\Thorns.wav	");
VUHDO_LibSharedMedia:Register("sound", "Elf Bell Toll", "Sound\\Doodad\\BellTollNightElf.wav");


LoadAddOn("FuBarPlugin-3.0");



--
function VUHDO_isVariablesLoaded()
	return VUHDO_VARIABLES_LOADED;
end



--
function VUHDO_setTooltipDelay(aSecs)
	VUHDO_REFRESH_TOOLTIP_DELAY = aSecs;
end



--
function VUHDO_OnLoad(anInstance)
	anInstance:RegisterEvent("VARIABLES_LOADED");
	anInstance:RegisterEvent("PLAYER_ENTERING_WORLD");
	anInstance:RegisterEvent("UNIT_HEALTH");
	anInstance:RegisterEvent("UNIT_MAXHEALTH");
	anInstance:RegisterEvent("UNIT_AURA");
	anInstance:RegisterEvent("UNIT_TARGET");

	anInstance:RegisterEvent("PLAYER_REGEN_ENABLED");
	--anInstance:RegisterEvent("PLAYER_REGEN_DISABLED");

	anInstance:RegisterEvent("RAID_ROSTER_UPDATE");
	anInstance:RegisterEvent("PARTY_MEMBERS_CHANGED");
	anInstance:RegisterEvent("UNIT_PET");
	anInstance:RegisterEvent("UNIT_ENTERED_VEHICLE");
	anInstance:RegisterEvent("UNIT_EXITED_VEHICLE");
	anInstance:RegisterEvent("UNIT_EXITING_VEHICLE");
	anInstance:RegisterEvent("CHAT_MSG_ADDON");
	anInstance:RegisterEvent("RAID_TARGET_UPDATE");
	anInstance:RegisterEvent("LEARNED_SPELL_IN_TAB");
	anInstance:RegisterEvent("PLAYER_FLAGS_CHANGED");

	anInstance:RegisterEvent("UNIT_DISPLAYPOWER");

	anInstance:RegisterEvent("UNIT_MAXMANA");
	anInstance:RegisterEvent("UNIT_MAXENERGY");
	anInstance:RegisterEvent("UNIT_MAXRAGE");
	anInstance:RegisterEvent("UNIT_MAXRUNIC_POWER");

	anInstance:RegisterEvent("UNIT_MANA");
	anInstance:RegisterEvent("UNIT_ENERGY");
	anInstance:RegisterEvent("UNIT_RAGE");
	anInstance:RegisterEvent("UNIT_RUNIC_POWER");

	anInstance:RegisterEvent("UNIT_SPELLCAST_STOP");
	anInstance:RegisterEvent("UNIT_SPELLCAST_FAILED");
	anInstance:RegisterEvent("UNIT_SPELLCAST_SENT");
	anInstance:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	anInstance:RegisterEvent("PARTY_MEMBER_ENABLE");
	anInstance:RegisterEvent("PARTY_MEMBER_DISABLE");
	anInstance:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	anInstance:RegisterEvent("UNIT_THREAT_SITUATION_UPDATE");
	anInstance:RegisterEvent("UPDATE_BINDINGS");
	anInstance:RegisterEvent("PLAYER_TARGET_CHANGED");
	anInstance:RegisterEvent("PLAYER_FOCUS_CHANGED");

	anInstance:RegisterEvent("READY_CHECK");
	anInstance:RegisterEvent("READY_CHECK_CONFIRM");
	anInstance:RegisterEvent("READY_CHECK_FINISHED");
	anInstance:RegisterEvent("CVAR_UPDATE");
	anInstance:RegisterEvent("INSPECT_TALENT_READY");

	anInstance:RegisterEvent("MODIFIER_STATE_CHANGED");

	SLASH_VUHDO1 = "/vuhdo";
	SLASH_VUHDO2 = "/vd";
	SlashCmdList["VUHDO"] = function(aMessage)
		VUHDO_slashCmd(aMessage);
	end

	VUHDO_Msg("VuhDo |cffffe566['vu:du:]|r v".. VUHDO_VERSION .. ". by Iza(ak)@Gilneas, dedicated to Vuh (use /vd)");
end



--
function VUHDO_initBuffs()
	VUHDO_initBuffsFromSpellBook();
	VUHDO_reloadBuffPanel();
	VUHDO_resetHotBuffCache();
end



-- That's a bad hack... but I don't care :)
local function VUHDO_initFuBar()
	if (LibStub:GetLibrary("LibFuBarPlugin-3.0", true)
		and IsAddOnLoaded("FuBar")
		and not IsAddOnLoaded("FuBar2Broker")) then

		local tLibFuBarPlugin = LibStub:GetLibrary("LibFuBarPlugin-3.0");
		LibStub("AceAddon-3.0"):EmbedLibrary(VuhDo, "LibFuBarPlugin-3.0");
		VuhDo:SetFuBarOption("tooltipType", "GameTooltip");
		VuhDo:SetFuBarOption("hasNoColor", true);
		VuhDo:SetFuBarOption("cannotDetachTooltip", true);
		VuhDo:SetFuBarOption("hideWithoutStandby", true);
		VuhDo:SetFuBarOption("iconPath", [[Interface\AddOns\VuhDo\Images\VuhDo]]);
		VuhDo:SetFuBarOption("hasIcon", true);
		VuhDo:SetFuBarOption("defaultPosition", "RIGHT");
		VuhDo:SetFuBarOption("tooltipHiddenWhenEmpty", true);
		VuhDo:SetFuBarOption("configType", "None");
		VuhDo.title = "VuhDo";
		VuhDo.name = "VuhDo";
		tLibFuBarPlugin:OnEmbedInitialize(VuhDo, VuhDo);
		function VuhDo:OnUpdateFuBarTooltip()
			GameTooltip:AddLine("VuhDo");
			GameTooltip:AddLine("|cffffff00Left Click|r to show options menu");
			GameTooltip:AddLine("|cffffff00Right Click|r to show popup menu");
		end
		VuhDo:Show();
		function VuhDo:OnFuBarClick(aButton)
			if ("LeftButton" == aButton) then
				VUHDO_slashCmd("opt");
			elseif ("RightButton" == aButton) then
				ToggleDropDownMenu(1, nil, VuhDoMinimapDropDown, VuhDo:GetFrame():GetName(), 0, -5);
			end
		end
	end
end



--
function VUHDO_initTooltipTimer()
	VUHDO_REFRESH_TOOLTIP_TIMER = VUHDO_REFRESH_TOOLTIP_DELAY;
end



--
local function VUHDO_initSharedMedia()
	local tIndex, tValue;

	-- fonts
	local tFonts = VUHDO_LibSharedMedia:List('font');
	for tIndex, tValue in ipairs(tFonts) do
		if (tIndex > VUHDO_COMBO_MAX_ENTRIES) then
			break;
		end

		VUHDO_FONTS[tIndex] = { VUHDO_LibSharedMedia:Fetch('font', tValue), tValue };
	end

	-- status bars
	local tBars = VUHDO_LibSharedMedia:List('statusbar');
	for tIndex, tValue in ipairs(tBars) do
		if (tIndex > VUHDO_COMBO_MAX_ENTRIES) then
			break;
		end
		VUHDO_STATUS_BARS[tIndex] = { tValue, tValue };
	end

	-- sounds
	local tSounds = VUHDO_LibSharedMedia:List('sound');
	for tIndex, tValue in ipairs(tSounds) do
		if (tIndex > VUHDO_COMBO_MAX_ENTRIES) then
			break;
		end

		VUHDO_SOUNDS[tIndex] = { VUHDO_LibSharedMedia:Fetch('sound', tValue), tValue };
	end

	-- borders
	local tBorders = VUHDO_LibSharedMedia:List('border');
	for tIndex, tValue in ipairs(tBorders) do
		if (tIndex > VUHDO_COMBO_MAX_ENTRIES) then
			break;
		end
		VUHDO_BORDERS[tIndex] = { VUHDO_LibSharedMedia:Fetch('border', tValue), tValue };
	end
end



--
-- 3 = Tanking, all others less 100%
-- 2 = Tanking, others > 100%
-- 1 = Not Tanking, more than 100%
-- 0 = Not Tanking, less than 100%
local tInfo;
local function VUHDO_updateThreat(aUnit)
	if (not VUHDO_VARIABLES_LOADED
	or (not VUHDO_CONFIG["THREAT"]["THREAT_DETECT"] and not VUHDO_CONFIG["THREAT"]["IS_TANK_MODE"])
	 or VUHDO_RAID == nil) then
		return;
	end

	tInfo = VUHDO_RAID[aUnit];
	if (tInfo ~= nil) then
		tInfo.threat = UnitThreatSituation(aUnit);

		if (VUHDO_CONFIG["THREAT"]["THREAT_USE_SYMBOL"]) then
			VUHDO_updateThreatSymbols(aUnit);
		end
	end
end



--
function VUHDO_initAllBurstCaches()
	VUHDO_toolboxInitBurst();
	VUHDO_vuhdoInitBurst();
	VUHDO_macroFactoryInitBurst();
	VUHDO_keySetupInitBurst();
	VUHDO_combatLogInitBurst();
	VUHDO_eventHandlerInitBurst();
	VUHDO_customHealthInitBurst();
	VUHDO_customManaInitBurst();
	VUHDO_customTargetInitBurst();
	VUHDO_customClustersInitBurst();
	VUHDO_panelRefreshInitBurst();
	VUHDO_sizeCalculatorInitBurst();
	VUHDO_customHotsInitBurst();
	VUHDO_customDebuffIconsInitBurst();
	VUHDO_debuffsInitBurst();
	VUHDO_healCommAdapterInitBurst();
	VUHDO_buffWatchInitBurst();
	VUHDO_clusterBuilderInitBurst();
end



--
function VUHDO_setLhcEnabled()
	local tHealComm = LibStub("LibHealComm-4.0");
	if (VUHDO_CONFIG["SHOW_INCOMING"] or VUHDO_CONFIG["SHOW_OWN_INCOMING"]) then
		tHealComm.RegisterCallback(VuhDoHealComms, "HealComm_HealStarted");
		tHealComm.RegisterCallback(VuhDoHealComms, "HealComm_HealUpdated", "HealComm_HealStarted");
		tHealComm.RegisterCallback(VuhDoHealComms, "HealComm_HealDelayed", "HealComm_HealStarted");
		tHealComm.RegisterCallback(VuhDoHealComms, "HealComm_HealStopped");
	else
		tHealComm.UnregisterCallback(VuhDoHealComms, "HealComm_HealStarted");
		tHealComm.UnregisterCallback(VuhDoHealComms, "HealComm_HealUpdated", "HealComm_HealStarted");
		tHealComm.UnregisterCallback(VuhDoHealComms, "HealComm_HealDelayed", "HealComm_HealStarted");
		tHealComm.UnregisterCallback(VuhDoHealComms, "HealComm_HealStopped");
	end
end



--
function VUHDO_setShieldCommEnabled()
	local tShieldLeft = LibStub("LibShieldLeft-1.0");
	if (VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"]["showShieldAbsorb"]) then
		tShieldLeft.RegisterCallback(VuhDoShieldComms, "ShieldLeft_NewShield");
		tShieldLeft.RegisterCallback(VuhDoShieldComms, "ShieldLeft_RefreshShield");
		tShieldLeft.RegisterCallback(VuhDoShieldComms, "ShieldLeft_RemoveShield");
		tShieldLeft.RegisterCallback(VuhDoShieldComms, "ShieldLeft_UpdateShield");
	else
		tShieldLeft.UnregisterCallback(VuhDoShieldComms, "ShieldLeft_NewShield");
		tShieldLeft.UnregisterCallback(VuhDoShieldComms, "ShieldLeft_RefreshShield");
		tShieldLeft.UnregisterCallback(VuhDoShieldComms, "ShieldLeft_RemoveShield");
		tShieldLeft.UnregisterCallback(VuhDoShieldComms, "ShieldLeft_UpdateShield");
		VUHDO_resetShieldsLeft();
	end
	tShieldLeft:SetAegisTolerance(VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"]["factorDivineAegis"]);
end



--
local function VUHDO_initOptions()
	if (VuhDoNewOptionsTabbedFrame ~= nil) then
		VUHDO_initHotComboModels();
		VUHDO_initHotBarComboModels();
		VUHDO_initDebuffIgnoreComboModel();
	end
end



--
local tUnit;
function VUHDO_OnEvent(anInstance, anEvent, anArg1, anArg2, anArg3, anArg4, _, anArg6, _, _, anArg9, anArg10, _, anArg12)

	VUHDO_EVENT_COUNT = VUHDO_EVENT_COUNT + 1;

	if ("COMBAT_LOG_EVENT_UNFILTERED" == anEvent) then
		if (VUHDO_VARIABLES_LOADED) then
			VUHDO_parseCombatLogEvent(anArg2, anArg6, anArg9, anArg10, anArg12);
		end
	elseif ("UNIT_HEALTH" == anEvent) then
		if (VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateHealth(anArg1, VUHDO_UPDATE_HEALTH);
		end
	elseif ("UNIT_AURA" == anEvent) then
		if (VUHDO_RAID ~= nil and VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateHealth(anArg1, VUHDO_UPDATE_DEBUFF);
		end
	elseif ("UNIT_THREAT_SITUATION_UPDATE" == anEvent) then
		VUHDO_updateThreat(anArg1);
	elseif ("UNIT_MANA" == anEvent
		or "UNIT_ENERGY" == anEvent
		or "UNIT_RAGE" == anEvent
		or "UNIT_RUNIC_POWER" == anEvent) then
		if (VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateManaBars(anArg1, 1);
		end
	elseif ("UNIT_MAXHEALTH" == anEvent) then
		if (VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateHealth(anArg1, VUHDO_UPDATE_HEALTH_MAX);
		end
	elseif ("UNIT_TARGET" == anEvent) then
		VUHDO_updateTargetBars(anArg1);
	elseif ("UNIT_DISPLAYPOWER" == anEvent) then
		if (VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateManaBars(anArg1, 3);
		end
	elseif ("UNIT_MAXMANA" == anEvent
		or "UNIT_MAXENERGY" == anEvent
		or "UNIT_MAXRAGE" == anEvent
		or "UNIT_MAXRUNIC_POWER" == anEvent) then
		if (VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateManaBars(anArg1, 2);
		end

	elseif ("UNIT_PET" == anEvent
		or "UNIT_ENTERED_VEHICLE" == anEvent
		or "UNIT_EXITED_VEHICLE" == anEvent
		or "UNIT_EXITING_VEHICLE" == anEvent ) then
		VUHDO_REMOVE_HOTS = false;
		VUHDO_normalRaidReload();
	elseif ("RAID_TARGET_UPDATE" == anEvent) then
		VUHDO_CUSTOMIZE_TIMER = 0.1;
	elseif ("PLAYER_REGEN_ENABLED" == anEvent) then
		if (not VUHDO_isReloadPending()) then
			VUHDO_quickRaidReload();
		end
	elseif ("UNIT_SPELLCAST_STOP" == anEvent) then
		if (VUHDO_VARIABLES_LOADED) then
			VUHDO_spellcastStop(anArg1);
		end
	elseif ("UNIT_SPELLCAST_FAILED" == anEvent) then
		if (VUHDO_VARIABLES_LOADED) then
			VUHDO_spellcastFailed(anArg1);
		end
	elseif ("UNIT_SPELLCAST_SUCCEEDED" == anEvent) then
		if (VUHDO_VARIABLES_LOADED) then
			VUHDO_spellcastSucceeded(anArg1, anArg2);
		end
	elseif ("UNIT_SPELLCAST_SENT" == anEvent) then
		if (VUHDO_VARIABLES_LOADED) then
			VUHDO_spellcastSent(anArg1, anArg2, anArg3, anArg4);
		end
	elseif ("PARTY_MEMBERS_CHANGED" == anEvent
			 or "RAID_ROSTER_UPDATE" == anEvent) then
		if (VUHDO_FIRST_RELOAD_UI) then
			VUHDO_normalRaidReload(true);
		end
	elseif ("PLAYER_FOCUS_CHANGED" == anEvent) then
		VUHDO_quickRaidReload();
	elseif ("PARTY_MEMBER_ENABLE" == anEvent
			 or "PARTY_MEMBER_DISABLE" == anEvent) then
		VUHDO_CUSTOMIZE_TIMER = 0.2;
	elseif ("PLAYER_FLAGS_CHANGED" == anEvent) then
		if (VUHDO_RAID[anArg1] ~= nil) then
			VUHDO_updateHealth(anArg1, VUHDO_UPDATE_AFK);
		end
	elseif ("PLAYER_ENTERING_WORLD" == anEvent) then
		VUHDO_initFromSpellbook();
		VUHDO_initBuffs();
		VUHDO_initDebuffs();
		VUHDO_initSharedMedia();
		VUHDO_initFuBar();
		VUHDO_initHideBlizzFrames();
		if (not VUHDO_isInFight()) then
			VUHDO_initKeyboardMacros();
		end
		VUHDO_timeReloadUI(3);
	elseif ("LEARNED_SPELL_IN_TAB" == anEvent) then
		VUHDO_initFromSpellbook();
		VUHDO_initBuffs();
		VUHDO_initDebuffs();

	elseif ("VARIABLES_LOADED" == anEvent) then

		VUHDO_initFastCache();
		VUHDO_loadVariables();
		VUHDO_initAllBurstCaches();
		VUHDO_VARIABLES_LOADED = true;

		VUHDO_initPanelModels();
		VUHDO_initFromSpellbook();
		VUHDO_initBuffs();
		VUHDO_initDebuffs();
		VUHDO_clearUndefinedModelEntries();
		VUHDO_reloadUI();

		VUHDO_getAutoArrangement();
		VUHDO_setLhcEnabled();
		VUHDO_setShieldCommEnabled();
	elseif ("UPDATE_BINDINGS" == anEvent) then
		if (not VUHDO_isInFight() and VUHDO_VARIABLES_LOADED) then
			VUHDO_initKeyboardMacros();
		end
	elseif ("PLAYER_TARGET_CHANGED" == anEvent) then
		VUHDO_updatePlayerTarget();
	elseif ("CHAT_MSG_ADDON" == anEvent) then
		VUHDO_parseAddonMessage(anArg1, anArg2, anArg3, anArg4);
	elseif ("READY_CHECK" == anEvent) then
		local tRank, _ = VUHDO_getPlayerRank();
		if (tRank >= 1) then
			VUHDO_readyStartCheck(anArg1, anArg2);
		end
	elseif ("READY_CHECK_CONFIRM" == anEvent) then
		local tRank, _ = VUHDO_getPlayerRank();
		if (tRank >= 1) then
			VUHDO_readyCheckConfirm(anArg1, anArg2);
		end
	elseif ("READY_CHECK_FINISHED" == anEvent) then
		local tRank, _ = VUHDO_getPlayerRank();
		if (tRank >= 1) then
			VUHDO_readyCheckEnds();
		end
	elseif("CVAR_UPDATE" == anEvent) then
		VUHDO_IS_SFX_ENABLED = tonumber(GetCVar("Sound_EnableSFX")) == 1;
		if (VUHDO_VARIABLES_LOADED) then
			VUHDO_refreshUI();
		end
	elseif("INSPECT_TALENT_READY" == anEvent) then
		VUHDO_inspectLockRole();
	elseif("MODIFIER_STATE_CHANGED" == anEvent) then
		if (VuhDoTooltip:IsShown()) then
			VUHDO_updateTooltip();
		end
	else
		VUHDO_Msg("Error: Unexpected event: " .. anEvent, 1, 0.4, 0.4);
	end

	VUHDO_EVENT_COUNT = VUHDO_EVENT_COUNT - 1;

	if (VUHDO_EVENT_COUNT < 0) then
		VUHDO_EVENT_COUNT = 0;
	end

	if (VUHDO_EVENT_COUNT == 0) then
		VUHDO_LAST_TIME_NO_EVENT = GetTime();
	end
end



--
function VUHDO_slashCmd(aCommand)
	local tParsedTexts = VUHDO_textParse(aCommand);
	local tCommandWord = strlower(tParsedTexts[1]);

	if (strfind(tCommandWord, "opt")) then
		if (VuhDoNewOptionsTabbedFrame ~= nil) then
			if (VUHDO_isInFight() and not VuhDoNewOptionsTabbedFrame:IsShown()) then
				VUHDO_Msg("Unable to open options screen while you are in-fight.", 1, 0.4, 0.4);
			else
				VUHDO_toggleMenu(VuhDoNewOptionsTabbedFrame);
			end
		else
			VUHDO_Msg(VUHDO_I18N_OPTIONS_NOT_LOADED, 1, 0.4, 0.4);
		end
	elseif (tCommandWord == "load" and tParsedTexts[2] ~= nil) then
		local tTokens = VUHDO_splitString(tParsedTexts[2], ",");
		if (#tTokens >= 3 and strlen(strtrim(tTokens[3])) > 0) then
			local tName = strtrim(tTokens[3]);
			if (VUHDO_SPELL_LAYOUTS[tName] ~= nil) then
				VUHDO_activateLayout(tName);
			else
				VUHDO_Msg(VUHDO_I18N_SPELL_LAYOUT_NOT_EXIST_1 .. tName .. VUHDO_I18N_SPELL_LAYOUT_NOT_EXIST_2, 1, 0.4, 0.4);
			end
		end
		if (#tTokens >= 2 and strlen(strtrim(tTokens[2])) > 0) then
			VUHDO_applyArrange(nil, strtrim(tTokens[2]));
		end
		if (#tTokens >= 1 and strlen(strtrim(tTokens[1])) > 0) then
			VUHDO_applySkin(nil, strtrim(tTokens[1]));
		end
	elseif (strfind(tCommandWord, "res")) then
		local tPanelNum;
		for tPanelNum = 1, VUHDO_MAX_PANELS do
			VUHDO_PANEL_SETUP[tPanelNum]["POSITION"] = nil;
		end
		VUHDO_BUFF_SETTINGS["CONFIG"]["POSITION"] = {
			["x"] = 100,
			["y"] = -100,
			["point"] = "TOPLEFT",
			["relativePoint"] = "TOPLEFT",
		};
		VUHDO_loadDefaultPanelSetup();
		VUHDO_reloadUI();
		VUHDO_Msg(VUHDO_I18N_PANELS_RESET);

	elseif (tCommandWord == "lock") then
		VUHDO_CONFIG["LOCK_PANELS"] = not VUHDO_CONFIG["LOCK_PANELS"];
		local tMessage = VUHDO_I18N_LOCK_PANELS_PRE;
		if (VUHDO_CONFIG["LOCK_PANELS"]) then
			tMessage = tMessage .. VUHDO_I18N_LOCK_PANELS_LOCKED;
		else
			tMessage = tMessage .. VUHDO_I18N_LOCK_PANELS_UNLOCKED;
		end
		VUHDO_Msg(tMessage);

	elseif (tCommandWord == "show") then
		VUHDO_CONFIG["SHOW_PANELS"] = true;
		VUHDO_redrawAllPanels();
		VUHDO_Msg(VUHDO_I18N_PANELS_SHOWN);

	elseif (tCommandWord == "hide") then
		VUHDO_CONFIG["SHOW_PANELS"] = false;
		VUHDO_redrawAllPanels();
		VUHDO_Msg(VUHDO_I18N_PANELS_HIDDEN);

	elseif (tCommandWord == "toggle") then
		VUHDO_CONFIG["SHOW_PANELS"] = not VUHDO_CONFIG["SHOW_PANELS"];
		if (VUHDO_CONFIG["SHOW_PANELS"]) then
			VUHDO_Msg(VUHDO_I18N_PANELS_SHOWN);
		else
			VUHDO_Msg(VUHDO_I18N_PANELS_HIDDEN);
		end
		VUHDO_redrawAllPanels();

	elseif (strfind(tCommandWord, "cast") or strfind(tCommandWord, "mt")) then
		VUHDO_ctraBroadCastMaintanks();
		VUHDO_Msg(VUHDO_I18N_MTS_BROADCASTED);

	elseif (tCommandWord == "pron") then
		SetCVar("scriptProfile", "1");
		ReloadUI();
	elseif (tCommandWord == "proff") then
		SetCVar("scriptProfile", "0");
		ReloadUI();
--	elseif (strfind(tCommandWord, "fupro")) then
--		local tData, tFName;
--		table.wipe(FunctionProfiler_Settings["watched"]);
--		for tFName, tData in pairs(VUHDO_GLOBAL) do
--			if (strsub(tFName, 1, 5) == "VUHDO") then
--				if (type(tData) == "function") then
--					table.insert(FunctionProfiler_Settings["watched"], tFName);
--				end
--			elseif(strsub(tFName, 1, 4) == "t") then
--				VUHDO_Msg("Emerging local variable " .. tFName);
--			end
--		end
--	elseif (strfind(tCommandWord, "chkvars")) then
--		for tFName, tData in pairs(VUHDO_GLOBAL) do
--			if(strsub(tFName, 1, 1) == "t") then
--				VUHDO_Msg("Emerging local variable " .. tFName);
--			end
--		end

	elseif (strfind(tCommandWord, "mm")
		or strfind(tCommandWord, "map")) then

		VUHDO_CONFIG["SHOW_MINIMAP"] = not VUHDO_CONFIG["SHOW_MINIMAP"];
		VUHDO_initShowMinimap();
		local tMessage = VUHDO_I18N_MM_ICON;
		if (VUHDO_CONFIG["SHOW_MINIMAP"]) then
			tMessage = tMessage .. VUHDO_I18N_CHAT_SHOWN;
		else
			tMessage = tMessage .. VUHDO_I18N_CHAT_HIDDEN;
		end

		VUHDO_Msg(tMessage);
	elseif (tCommandWord == "ui") then
		--VUHDO_reloadRaidMembers();
		--VUHDO_updateAllRaidBars();
		VUHDO_reloadUI();
	elseif (strfind(tCommandWord, "role")) then
		VUHDO_Msg("Player roles have been reset.");
		VUHDO_resetTalentScan();
		VUHDO_reloadUI();
	elseif (strfind(tCommandWord, "cluster")) then
		VUHDO_Msg("Map dimensions for cluster builder have been reset.");
		table.wipe(VUHDO_STORED_ZONES);
	elseif (tCommandWord == "aegis") then
		if (tParsedTexts[2] ~= nil and tonumber(tParsedTexts[2]) ~= nil and tonumber(tParsedTexts[2]) >= 0.1 and tonumber(tParsedTexts[2]) <= 2) then
			VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"]["factorDivineAegis"] = tonumber(tParsedTexts[2]);
			VUHDO_setShieldCommEnabled();
			VUHDO_Msg("Divine Aegis sensivity has been set to " .. tonumber(tParsedTexts[2]));
		else
			VUHDO_Msg("Usage: /vd aegis x. Where x is 0.1 to 2 (default: 1.2, current: " .. VUHDO_PANEL_SETUP["BAR_COLORS"]["HOTS"]["factorDivineAegis"] .. ")");
		end
	elseif (strfind(tCommandWord, "debug")) then
		VUHDO_DEBUG_AUTO_ARRANG = tonumber(tParsedTexts[2]);
--	elseif (strfind(tCommandWord, "test")) then
--		VUHDO_initProfiler();
--		local tI;
--		for tI = 1, 100 do
--			VUHDO_reloadUI();
--		end
--		VUHDO_seeProfiler();
	elseif (aCommand == "?"
		or strfind(tCommandWord, "help")
		or aCommand == "") then
		local tLines = VUHDO_splitString(VUHDO_I18N_COMMAND_LIST, "");
		local tCurLine;
		for _, tCurLine in ipairs(tLines) do
			VUHDO_MsgC(tCurLine);
		end
	else
		VUHDO_Msg(VUHDO_I18N_BAD_COMMAND, 1, 0.4, 0.4);
	end
end



--
function VUHDO_initTimersByConfig()
	if (not VUHDO_CONFIG["THREAT"]["AGGRO_DETECT"]) then
		VUHDO_UPDATE_AGGRO_TIMER = -1;
	else
		VUHDO_UPDATE_AGGRO_TIMER = 1;
	end

	if (not VUHDO_CONFIG["RANGE_CHECK"]) then
		VUHDO_UPDATE_RANGE_TIMER = -1;
	else
		VUHDO_UPDATE_RANGE_TIMER = 1;
	end

	if (not VUHDO_CONFIG["CLUSTER"]["ENABLE"]) then
		VUHDO_UPDATE_CLUSTERS_TIMER = -1;
	else
		VUHDO_UPDATE_CLUSTERS_TIMER = 1;
	end

end



--
local tName, tExistIndex;
local function VUHDO_loadDefaultProfiles()
	if (VUHDO_CONFIG == nil) then
		return;
	end
	tName = VUHDO_CONFIG["CURRENT_SKIN"];
	if (tName ~= nil and tName ~= "") then

		tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_SKINS);
		if (tExistIndex ~= nil) then
			VUHDO_loadFromSkin(VUHDO_PANEL_SKIN_MODEL_SKIN, VUHDO_SKINS[tExistIndex]["DATA"])
		end
	end

	tName = VUHDO_CONFIG["CURRENT_ARRANGEMENT"];
	if (tName ~= nil and tName ~= "") then

		tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_ARRANGEMENTS);
		if (tExistIndex ~= nil) then
			VUHDO_loadFromSkin(VUHDO_PANEL_SKIN_MODEL_SETUP, VUHDO_ARRANGEMENTS[tExistIndex]["DATA"]);
		end
	end
end



--
function VUHDO_loadVariables()
	_, VUHDO_PLAYER_CLASS = UnitClass("player");
	VUHDO_PLAYER_NAME = UnitName("player");

	VUHDO_loadDefaultProfiles();
	VUHDO_loadSpellArray();
	VUHDO_loadDefaultPanelSetup();
	VUHDO_initBuffSettings();
	VUHDO_loadDefaultConfig();
	VUHDO_initMinimap();
	VUHDO_initTimersByConfig();

	VUHDO_lnfPatchFont(VuhDoOptionsTooltipText, "Text");
end



--
local tOldAggro = { };
local tOldThreat = { };
local tTarget;
local tAggroUnit;
local tIsDetectAggro;
local tThreatPerc;
local tIsThreat, tIsHealerMode;

local function VUHDO_updateAllAggro()
	tIsThreat = VUHDO_CONFIG["THREAT"]["THREAT_USE_BAR"] and VUHDO_CONFIG["THREAT"]["THREAT_DETECT"];
	tIsHealerMode = not VUHDO_CONFIG["THREAT"]["IS_TANK_MODE"];

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		tOldAggro[tUnit] = tInfo.aggro;
		tOldThreat[tUnit] = tInfo.threatPerc;
		tInfo.aggro = false;
		tInfo.threatPerc = 0;
	end

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if (tInfo.connected and not tInfo.dead) then
			if (tInfo.threat ~= nil and tInfo.threat >= 2) then
				tInfo.aggro = true;
			end
			tTarget = tInfo.targetUnit;
			if (UnitIsEnemy(tUnit, tTarget)) then
				if (tIsThreat) then
					_, _, tThreatPerc = UnitDetailedThreatSituation(tUnit, tTarget);
					tInfo.threatPerc = tThreatPerc or 0;
				end

				tAggroUnit = VUHDO_RAID_NAMES[UnitName(tTarget .. "target")];

				if (tAggroUnit ~= nil) then
					if (tIsThreat) then
						_, _, tThreatPerc = UnitDetailedThreatSituation(tAggroUnit, tTarget);
						VUHDO_RAID[tAggroUnit].threatPerc = tThreatPerc or 0;
					end

					if (tIsHealerMode) then
						VUHDO_RAID[tAggroUnit].aggro = true;
					end
				end
			end
		else
			tInfo.aggro = false;
		end
	end

	for tUnit, tInfo in pairs(VUHDO_RAID) do
		if (tInfo.aggro ~= tOldAggro[tUnit]) then
			VUHDO_updateHealthBarsFor(tUnit, VUHDO_UPDATE_AGGRO);
		end

		if (tInfo.threatPerc ~= tOldThreat[tUnit]) then
			VUHDO_updateThreatPerc(tUnit);
		end
	end
end



--
function VUHDO_normalRaidReload(anIsReloadBuffs)
	if (VUHDO_isConfigPanelShowing()) then
		return;
	end
	VUHDO_RELOAD_RAID_TIMER = VUHDO_RELOAD_RAID_DELAY;
	if (anIsReloadBuffs ~= nil) then
		VUHDO_IS_RELOAD_BUFFS = true;
	end
end



--
function VUHDO_quickRaidReload()
	VUHDO_RELOAD_RAID_TIMER = VUHDO_RELOAD_RAID_DELAY_QUICK;
end



--
function VUHDO_isReloadPending()
	return VUHDO_RELOAD_RAID_TIMER > 0
		or VUHDO_RELOAD_UI_TIMER > 0
		or VUHDO_IS_RELOADING;
end



--
function VUHDO_timeReloadUI(someSecs)
	VUHDO_RELOAD_UI_TIMER = someSecs;
end



--
function VUHDO_timeRedrawPanel(aPanelNum, someSecs)
	VUHDO_RELOAD_PANEL_NUM = aPanelNum;
	VUHDO_RELOAD_PANEL_TIMER = someSecs;
end



--
function VUHDO_setDebuffAnimation(aTimeSecs)
	VUHDO_DEBUFF_ANIMATION = aTimeSecs;
end



--
function VUHDO_initGcd()
	VUHDO_GCD_UPDATE = true;
end


--
local tNow;
local tInRange;
local tSpellName;
local tTimeDelta = 0;
local tAutoArrangement;
local tUnit, tInfo;
local tGcdStart, tGcdDuration, tRemain;
local tIsHotDebuffCheckToggle = false;
function VUHDO_OnUpdate(anInstance, aTimeDelta)
	-- Update custom debuff animation with every tick
	if (VUHDO_DEBUFF_ANIMATION > 0) then
		-- Custom debuff icon animation
		VUHDO_updateAllDebuffIcons();
		VUHDO_DEBUFF_ANIMATION = VUHDO_DEBUFF_ANIMATION - aTimeDelta;
	end

	-- In all other cases every second tick should be sufficient
	if (tTimeDelta == 0) then
		tTimeDelta = aTimeDelta;
		return;
	else
		aTimeDelta = aTimeDelta + tTimeDelta;
		tTimeDelta = 0;
	end

	tNow = GetTime();

	if (VUHDO_EVENT_COUNT > 0) then
		if (VUHDO_LAST_TIME_NO_EVENT + 3 < tNow) then
			VUHDO_LAST_TIME_NO_EVENT = tNow;
			VUHDO_EVENT_COUNT = 0;
		end

		return;
	end

	-- Update GCD-Bar
	if (VUHDO_GCD_UPDATE and VUHDO_GCD_SPELLS[VUHDO_PLAYER_CLASS] ~= nil) then
		tGcdStart, tGcdDuration, _ = GetSpellCooldown(VUHDO_GCD_SPELLS[VUHDO_PLAYER_CLASS]);
		if (tGcdDuration == 0 or tGcdDuration == nil) then
			VuhDoGcdStatusBar:SetValue(0);
			VUHDO_GCD_UPDATE = false;
		else
			VuhDoGcdStatusBar:SetValue(100 * (tGcdDuration-(tNow-tGcdStart)) / tGcdDuration);
		end
	end

	-- reload UI?
	if (VUHDO_RELOAD_UI_TIMER > 0) then
		VUHDO_RELOAD_UI_TIMER = VUHDO_RELOAD_UI_TIMER - aTimeDelta;
		if (VUHDO_RELOAD_UI_TIMER <= 0) then
			if (VUHDO_IS_RELOADING or VUHDO_isInFight()) then
				VUHDO_RELOAD_UI_TIMER = VUHDO_RELOAD_RAID_DELAY_QUICK;
			else
				VUHDO_reloadUI();
				VUHDO_initOptions();
				VUHDO_FIRST_RELOAD_UI = true;
			end
		end
	end

	-- redraw single panel?
	if (VUHDO_RELOAD_PANEL_TIMER > 0) then
		VUHDO_RELOAD_PANEL_TIMER = VUHDO_RELOAD_PANEL_TIMER - aTimeDelta;
		if (VUHDO_RELOAD_PANEL_TIMER <= 0) then
			if (VUHDO_IS_RELOADING or VUHDO_isInFight()) then
				VUHDO_RELOAD_PANEL_TIMER = VUHDO_RELOAD_RAID_DELAY_QUICK;
			else
				VUHDO_PROHIBIT_REPOS = true;
				VUHDO_redrawPanel(VUHDO_RELOAD_PANEL_NUM);
				VUHDO_updateAllPanelBars(VUHDO_RELOAD_PANEL_NUM);
				VUHDO_PROHIBIT_REPOS = false;
			end
		end
	end

	if (not VUHDO_VARIABLES_LOADED) then
		return;
	end

	if (VUHDO_RELOAD_AFTER_BATTLE and not VUHDO_isInFight()) then
		VUHDO_RELOAD_AFTER_BATTLE = false;

		if (VUHDO_RELOAD_RAID_TIMER <= 0) then
			VUHDO_quickRaidReload();
			if (VUHDO_IS_RELOAD_BUFFS) then
				VUHDO_reloadBuffPanel();
				VUHDO_IS_RELOAD_BUFFS = false;
			end
		end
	end

	-- Reload raid roster?
	if (VUHDO_RELOAD_RAID_TIMER > 0) then
		VUHDO_RELOAD_RAID_TIMER = VUHDO_RELOAD_RAID_TIMER - aTimeDelta;
		if (VUHDO_RELOAD_RAID_TIMER <= 0 and not VUHDO_isConfigPanelShowing()) then

			if (VUHDO_IS_RELOADING) then
				VUHDO_quickRaidReload();
			else
				VUHDO_rebuildTargets();

				if (VUHDO_isInFight()) then
					VUHDO_RELOAD_AFTER_BATTLE = true;

					VUHDO_IS_RELOADING = true;
					VUHDO_reloadRaidMembers();
					VUHDO_IS_RELOADING = false;

					VUHDO_updateAllRaidBars();
				else
					VUHDO_refreshUI();
					if (VUHDO_IS_RELOAD_BUFFS) then
						VUHDO_reloadBuffPanel();
						VUHDO_IS_RELOAD_BUFFS = false;
					end
				end
			end
		end
	end

	-- refresh HoTs?
	if (VUHDO_UPDATE_HOTS_TIMER > 0) then
		VUHDO_UPDATE_HOTS_TIMER = VUHDO_UPDATE_HOTS_TIMER - aTimeDelta;
		if (VUHDO_UPDATE_HOTS_TIMER <= 0) then

			if (tIsHotDebuffCheckToggle) then
				VUHDO_updateAllHoTs();
			elseif (VUHDO_DEBUFF_ANIMATION <= 0) then
				VUHDO_updateAllDebuffIcons();
			end

			-- Reload after player gained control
			if (not tIsHotDebuffCheckToggle and not HasFullControl()) then
				VUHDO_LOST_CONTROL = true;
			else
				if (VUHDO_LOST_CONTROL) then
					if (VUHDO_RELOAD_RAID_TIMER <= 0) then
						VUHDO_CUSTOMIZE_TIMER = VUHDO_RELOAD_RAID_DELAY_QUICK;
					end
					VUHDO_LOST_CONTROL = false;
				end
			end
			tIsHotDebuffCheckToggle = not tIsHotDebuffCheckToggle;
			VUHDO_UPDATE_HOTS_TIMER = VUHDO_CONFIG["UPDATE_HOTS_MS"] * 0.0005;
		end
	end

	-- track dragged panel coords
	if (VUHDO_DRAG_PANEL ~= nil) then
		VUHDO_REFRESH_DRAG_TIMER = VUHDO_REFRESH_DRAG_TIMER - aTimeDelta;
		if (VUHDO_REFRESH_DRAG_TIMER <= 0) then
			VUHDO_REFRESH_DRAG_TIMER = VUHDO_REFRESH_DRAG_DELAY;
			VUHDO_refreshDragTarget(VUHDO_DRAG_PANEL);
		end
	end

	-- Set Button colors without repositioning
	if (VUHDO_CUSTOMIZE_TIMER > 0) then
		VUHDO_CUSTOMIZE_TIMER = VUHDO_CUSTOMIZE_TIMER - aTimeDelta;
		if (VUHDO_CUSTOMIZE_TIMER <= 0) then
			VUHDO_updateAllRaidTargetIndices();
			VUHDO_updateAllRaidBars();
		end
	end

	-- Refresh Tooltip, clear obsolete incoming heals
	if (VUHDO_REFRESH_TOOLTIP_TIMER > 0) then
		VUHDO_REFRESH_TOOLTIP_TIMER = VUHDO_REFRESH_TOOLTIP_TIMER - aTimeDelta;
		if (VUHDO_REFRESH_TOOLTIP_TIMER <= 0) then
			VUHDO_REFRESH_TOOLTIP_TIMER = VUHDO_REFRESH_TOOLTIP_DELAY;
			if (VuhDoTooltip:IsShown()) then
				VUHDO_updateTooltip();
			end

			VUHDO_clearObsoleteInc();
		end
	end

	-- Refresh server lag and automatic profiles
	if (not VUHDO_isInFight() and VUHDO_RELOAD_LAG_TIMER > 0) then
		VUHDO_RELOAD_LAG_TIMER = VUHDO_RELOAD_LAG_TIMER - aTimeDelta;
		if (VUHDO_RELOAD_LAG_TIMER <= 0) then

			if (VUHDO_LAST_AUTO_ARRANG == nil) then
				VUHDO_LAST_AUTO_ARRANG = VUHDO_getAutoArrangement();
			else
				tAutoArrangement, tTrigger = VUHDO_getAutoArrangement();
				if (tAutoArrangement ~= nil and VUHDO_LAST_AUTO_ARRANG ~= tAutoArrangement and not VUHDO_IS_CONFIG) then
					VUHDO_Msg(VUHDO_I18N_AUTO_ARRANG_1 .. tTrigger .. VUHDO_I18N_AUTO_ARRANG_2 .. "|cffffffff" .. tAutoArrangement .. "|r\"");

					if (VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["dirty"]) then
						VUHDO_autoBackupCurrentArrangement();
						VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["dirty"] = false;
					end

					VUHDO_engageArrangement(tAutoArrangement);
					VUHDO_LAST_AUTO_ARRANG = tAutoArrangement;
				end
			end

			VUHDO_RELOAD_LAG_TIMER = VUHDO_RELOAD_LAG_DELAY;
		end
	end

	-- Refresh Buff Watch
	if (VUHDO_REFRESH_BUFFS_TIMER > 0) then
		VUHDO_REFRESH_BUFFS_TIMER = VUHDO_REFRESH_BUFFS_TIMER - aTimeDelta;
		if (VUHDO_REFRESH_BUFFS_TIMER <= 0) then
			VUHDO_updateBuffPanel();
			VUHDO_REFRESH_BUFFS_TIMER = VUHDO_BUFF_SETTINGS["CONFIG"]["REFRESH_SECS"];
		end
	end

	-- Refresh Inspect, check timeout
	if (VUHDO_NEXT_INSPECT_UNIT ~= nil and tNow > VUHDO_NEXT_INSPECT_TIME_OUT) then
		VUHDO_setRoleUndefined(VUHDO_NEXT_INSPECT_UNIT);
		VUHDO_NEXT_INSPECT_UNIT = nil;
	end

	-- Refresh targets not in raid
	if (VUHDO_REFRESH_TARGETS_TIMER > 0) then
		VUHDO_REFRESH_TARGETS_TIMER = VUHDO_REFRESH_TARGETS_TIMER - aTimeDelta;
		if (VUHDO_REFRESH_TARGETS_TIMER <= 0) then
			VUHDO_updateAllOutRaidTargetButtons();
			VUHDO_REFRESH_TARGETS_TIMER = VUHDO_REFRESH_TARGETS_DELAY;
		end
	end

	-----------------------------------------------------------------------------------------

	if (VUHDO_CONFIG_SHOW_RAID) then
		return;
	end

	-- refresh aggro?
	if (VUHDO_UPDATE_AGGRO_TIMER > 0) then
		VUHDO_UPDATE_AGGRO_TIMER = VUHDO_UPDATE_AGGRO_TIMER - aTimeDelta;
		if (VUHDO_UPDATE_AGGRO_TIMER <= 0) then
			VUHDO_updateAllAggro();
			VUHDO_UPDATE_AGGRO_TIMER = VUHDO_CONFIG["THREAT"]["AGGRO_REFRESH_MS"] * 0.001;
		end
	end

	-- refresh range?
	if (VUHDO_UPDATE_RANGE_TIMER > 0) then
		VUHDO_UPDATE_RANGE_TIMER = VUHDO_UPDATE_RANGE_TIMER - aTimeDelta;
		if (VUHDO_UPDATE_RANGE_TIMER <= 0) then
			if (VUHDO_CONFIG.RANGE_PESSIMISTIC) then
				for tUnit, tInfo in pairs(VUHDO_RAID) do
					tInRange = tInfo.connected and (UnitInRange(tUnit) or UnitIsUnit("player", tUnit) or (tUnit == "focus" and CheckInteractDistance(tUnit, 1)));

					if (tInfo.range ~= tInRange) then
						tInfo.range = tInRange;
						VUHDO_updateHealthBarsFor(tUnit, VUHDO_UPDATE_RANGE);
						VUHDO_updateManaBars(tUnit, 4);
					end

					tInfo.charmed = not tInfo.dead and tInfo.range and UnitIsCharmed(tUnit) and UnitCanAttack("player", tUnit);
				end
			else
				for tUnit, tInfo in pairs(VUHDO_RAID) do
					tInRange = tInfo.connected and ((UnitInRange(tUnit) or 1 == IsSpellInRange(VUHDO_CONFIG["RANGE_SPELL"], tUnit))
									 or UnitIsUnit("player", tUnit) or (tUnit == "focus" and CheckInteractDistance(tUnit, 1)));

					if (tInfo.range ~= tInRange) then
						tInfo.range = tInRange;
						VUHDO_updateHealthBarsFor(tUnit, VUHDO_UPDATE_RANGE);
						VUHDO_updateManaBars(tUnit, 4);
					end

					tInfo.charmed = not tInfo.dead and tInfo.range and UnitIsCharmed(tUnit) and UnitCanAttack("player", tUnit);
				end
			end

			VUHDO_UPDATE_RANGE_TIMER = VUHDO_CONFIG.RANGE_CHECK_DELAY * 0.001;
		end
	end

	-- Refresh Inspect, set new unit if no server request pending
	if (VUHDO_REFRESH_INSPECT_TIMER > 0 and VUHDO_NEXT_INSPECT_UNIT == nil and not VUHDO_isInFight()) then
		VUHDO_REFRESH_INSPECT_TIMER = VUHDO_REFRESH_INSPECT_TIMER - aTimeDelta;
		if (VUHDO_REFRESH_INSPECT_TIMER <= 0) then
			VUHDO_tryInspectNext();
			VUHDO_REFRESH_INSPECT_TIMER = VUHDO_REFRESH_INSPECT_DELAY;
		end
	end

	-- Refresh Clusters
	if (VUHDO_UPDATE_CLUSTERS_TIMER > 0) then
		VUHDO_UPDATE_CLUSTERS_TIMER = VUHDO_UPDATE_CLUSTERS_TIMER - aTimeDelta;
		if (VUHDO_UPDATE_CLUSTERS_TIMER <= 0) then
			VUHDO_updateAllClusters();
			VUHDO_UPDATE_CLUSTERS_TIMER = VUHDO_CONFIG["CLUSTER"].REFRESH * 0.001;
		end
	end
end
