local GetNumRaidMembers = GetNumRaidMembers;
local GetNumPartyMembers = GetNumPartyMembers;
local table = table;
local tonumber = tonumber;


VUHDO_SKINS = { };
VUHDO_ARRANGEMENTS = { };

VUHDO_SKIN_TABLE_MODEL = { };
VUHDO_ARRANGEMENTS_TABLE_MODEL = { };

VUHDO_PANEL_SKIN_MODEL_NONE = 0;
VUHDO_PANEL_SKIN_MODEL_SKIN = 1;
VUHDO_PANEL_SKIN_MODEL_SETUP = 2;


VUHDO_CURR_INDEX = nil;
VUHDO_CURR_NAME = nil;
VUHDO_CURR_BUTTON = nil;
VUHDO_CURR_MODEL = nil;

--
local VUHDO_PANEL_SKIN_MODEL = {
	["POSITION"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["MODEL"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["SCALING"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["LIFE_TEXT"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["HOTS"] = VUHDO_PANEL_SKIN_MODEL_NONE,
	["ID_TEXT"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["RAID_ICON"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["OVERHEAL_TEXT"] = VUHDO_PANEL_SKIN_MODEL_SETUP,

	["PANEL_COLOR"] = {
		["barTexture"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["barBackBrightness"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["isBrightnessToHealth"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["BACK"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["BORDER"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["BARS"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["TARGET"] = VUHDO_PANEL_SKIN_MODEL_SKIN,

		["TEXT"] = {
			["TR"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TG"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TB"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TO"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["R"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["G"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["B"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["O"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["useText"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["useBackground"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["useOpacity"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["font"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["textSize"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
			["textSizeLife"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
			["maxChars"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
			["outline"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		},

		["HEADER"] = {
			["R"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["G"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["B"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["O"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TR"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TG"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TB"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["TO"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["useText"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["useBackground"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["barTexture"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
			["textSize"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
			["font"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		},

		["classColorsName"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["classColorsHeader"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["classColorsBackHeader"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	},

	["TOOLTIP"] = {
		["show"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["position"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["inFight"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["showBuffs"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["x"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["y"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["point"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["relativePoint"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["SCALE"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
		["BACKGROUND"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
		["BORDER"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	},
};


--
local VUHDO_PANEL_BUFF_MODEL = {
	["SHOW"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["SHOW_LABEL"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SHOW_EMPTY"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["REFRESH_SECS"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["POSITION"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["SCALE"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["SWATCH_MAX_ROWS"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["PANEL_MAX_BUFFS"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["AT_LEAST_MISSING"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["PANEL_BG_COLOR"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["PANEL_BORDER_COLOR"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_BG_COLOR"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_BORDER_COLOR"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["GROUP_SPELL_VERSION"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["REBUFF_AT_PERCENT"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["REBUFF_MIN_MINUTES"] = VUHDO_PANEL_SKIN_MODEL_SETUP,
	["HIGHLIGHT_COOLDOWN"] = VUHDO_PANEL_SKIN_MODEL_SETUP,

	["SWATCH_COLOR_BUFF_OKAY"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_COLOR_BUFF_LOW"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_COLOR_BUFF_OUT"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_COLOR_BUFF_COOLDOWN"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_COLOR_OUT_RANGE"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
	["SWATCH_EMPTY_GROUP"] = VUHDO_PANEL_SKIN_MODEL_SKIN,
};



--
function VUHDO_initSkinTableModels(aButton)
	local tIndex, tValue;

	table.wipe(VUHDO_SKIN_TABLE_MODEL);
	for tIndex, tValue in ipairs(VUHDO_SKINS) do
		VUHDO_SKIN_TABLE_MODEL[tIndex] = { tValue["NAME"], tValue["NAME"] };
	end

	table.wipe(VUHDO_ARRANGEMENTS_TABLE_MODEL);
	for tIndex, tValue in ipairs(VUHDO_ARRANGEMENTS) do
		VUHDO_ARRANGEMENTS_TABLE_MODEL[tIndex] = { tValue["NAME"], tValue["NAME"] };
	end

	local tCombo = VUHDO_GLOBAL[aButton:GetParent():GetName().. "SelectComboBox"];
	VUHDO_lnfComboBoxInitFromModel(tCombo);
end



--
local function VUHDO_checkCopySkinArray(aSourceArray, aDestArray, aSkinModelArray, aSkinModel, anIsRemove)
	local tKey, tValue;
	if (aDestArray == nil) then
		aDestArray = { };
	end

	for tKey, tValue in pairs(aSkinModelArray) do
		if ("table" == type(tValue)) then
			aDestArray[tKey] = VUHDO_checkCopySkinArray(aSourceArray[tKey], aDestArray[tKey], tValue, aSkinModel, anIsRemove);
		else
			if (tValue == aSkinModel) then
				if ("table" == type(aSourceArray[tKey])) then
					if (anIsRemove) then
						aDestArray[tKey] = VUHDO_deepCopyTable(aSourceArray[tKey]);
					else
						aDestArray[tKey] = VUHDO_deepCopyTableTo(aSourceArray[tKey], aDestArray[tKey]);
					end
				elseif (aSourceArray[tKey] ~= nil or anIsRemove) then
					aDestArray[tKey] = aSourceArray[tKey];
				end
			end
		end
	end

	return aDestArray;
end



--
function VUHDO_loadFromSkin(aSkinModel, aSkinSetup)
	local tCnt;

	for tCnt = 1, VUHDO_MAX_PANELS do
		VUHDO_PANEL_SETUP[tCnt] = VUHDO_checkCopySkinArray(aSkinSetup[tCnt], VUHDO_PANEL_SETUP[tCnt], VUHDO_PANEL_SKIN_MODEL, aSkinModel, false);
		-- also remove groups/panels not existent in saved arrangement
		if (VUHDO_PANEL_SKIN_MODEL_SETUP == aSkinModel) then
			if (aSkinSetup[tCnt]["MODEL"].groups == nil) then
				VUHDO_PANEL_SETUP[tCnt]["MODEL"].groups = nil;
			else
				VUHDO_PANEL_SETUP[tCnt]["MODEL"].groups = VUHDO_deepCopyTable(aSkinSetup[tCnt]["MODEL"].groups);
			end
		end
	end

	VUHDO_BUFF_SETTINGS["CONFIG"] = VUHDO_checkCopySkinArray(aSkinSetup["BUFF_CONFIG"], VUHDO_BUFF_SETTINGS["CONFIG"], VUHDO_PANEL_BUFF_MODEL, aSkinModel, false);

	local tIndex, tValue;
	if (aSkinSetup["BUFF_SETTINGS"] ~= nil) then
		for tIndex, tValue in pairs(aSkinSetup["BUFF_SETTINGS"]) do
			if ("CONFIG" ~= tIndex) then
				if (type(tValue) == "table") then
					VUHDO_BUFF_SETTINGS[tIndex] = VUHDO_deepCopyTable(tValue);
				else
					VUHDO_BUFF_SETTINGS[tIndex] = tValue;
				end
			end
		end
	end
end



--
function VUHDO_saveToSkin(aSkinModel, aSkinSetup)
	local tCnt;

	table.wipe(aSkinSetup);
	for tCnt = 1, VUHDO_MAX_PANELS do
		aSkinSetup[tCnt] = VUHDO_checkCopySkinArray(VUHDO_PANEL_SETUP[tCnt], aSkinSetup[tCnt], VUHDO_PANEL_SKIN_MODEL, aSkinModel, true);
	end

	aSkinSetup["BUFF_CONFIG"] = VUHDO_checkCopySkinArray(VUHDO_BUFF_SETTINGS["CONFIG"], aSkinSetup["BUFF_CONFIG"], VUHDO_PANEL_BUFF_MODEL, aSkinModel, true);

	if (VUHDO_PANEL_SKIN_MODEL_SETUP == aSkinModel) then
		aSkinSetup["BUFF_SETTINGS"] = VUHDO_deepCopyTable(VUHDO_BUFF_SETTINGS);
	end

	return aSkinSetup;
end



--
function VUHDO_getSkinFromName(aName, aSkinArray)
	local tName, tIndex, tValue;
	for tIndex, tValue in pairs(aSkinArray) do
		if (tValue["NAME"] == aName) then
			return tIndex;
		end
	end
	return nil;
end



--
function VUHDO_applySkin(aButton, aName)
	local tName = aName;

	if (tName == nil) then
		local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
		tName = tEditBox:GetText();
	end

	if (tName == nil or strlen(tName) == 0) then
		return;
	end

	local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_SKINS);
	if (tExistIndex == nil) then
		VUHDO_Msg("Error: No skin named \"" .. tName .. "\" exists!", 1, 0.4, 0.4);
		return;
	end

	VUHDO_loadFromSkin(VUHDO_PANEL_SKIN_MODEL_SKIN, VUHDO_SKINS[tExistIndex]["DATA"]);
	VUHDO_loadVariables();
	VUHDO_initPanelModels();
	VUHDO_initDynamicPanelModels();
	VUHDO_reloadUI();
end



------------------------ Arrangement



--
function VUHDO_engageArrangement(aName)
	local tExistIndex = VUHDO_getSkinFromName(aName, VUHDO_ARRANGEMENTS);
	if (tExistIndex == nil) then
		VUHDO_Msg("Error: No arrangement named \"" .. aName .. "\" exists!", 1, 0.4, 0.4);
		return;
	end
	VUHDO_CONFIG["CURRENT_ARRANGEMENT"] = aName;
	VUHDO_loadFromSkin(VUHDO_PANEL_SKIN_MODEL_SETUP, VUHDO_ARRANGEMENTS[tExistIndex]["DATA"]);

	VUHDO_loadVariables();
	VUHDO_initPanelModels();
	VUHDO_initDynamicPanelModels();
	VUHDO_reloadUI();
	VUHDO_resetTooltip();
end



--
function VUHDO_applyArrange(aButton, aName)
	local tName = aName;
	if (tName == nil) then
		local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
		tName = tEditBox:GetText();
	end

	if (tName == nil or strlen(tName) == 0) then
		return;
	end
	VUHDO_engageArrangement(tName);
end



--
function VUHDO_autoBackupCurrentArrangement()
	local tSlot, tSlotName;
	local VUHDO_AUTO_SAVE_SPEC = "Auto save ";

	tSlot = VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["lastAutoSaveSlot"] + 1;

	if (tSlot > 3) then
		tSlot = 1;
	end

	tSlotName = VUHDO_AUTO_SAVE_SPEC .. tSlot;

	local tNewSkin = { ["NAME"] = tSlotName, ["DATA"] = { } };
	tNewSkin["DATA"] = VUHDO_saveToSkin(VUHDO_PANEL_SKIN_MODEL_SETUP, tNewSkin["DATA"]);

	local tExistIndex = VUHDO_getSkinFromName(tSlotName, VUHDO_ARRANGEMENTS);
	if (tExistIndex == nil) then
		table.insert(VUHDO_ARRANGEMENTS, tNewSkin);
	else
		VUHDO_ARRANGEMENTS[tExistIndex] = tNewSkin;
	end

	VUHDO_Msg("You current arrangement has been backed up to \"|cffffffff" .. tSlotName .. "|r\".");
	VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["lastAutoSaveSlot"] = tSlot;
end



--
VUHDO_DEBUG_AUTO_ARRANG = nil;
VUHDO_IS_SHOWN_BY_GROUP = true;
local tNumMembers;
local tCnt, tIndex;
local tAutoArrangsIndices = { "1", "5", "10", "15", "25", "40" };
local VUHDO_ARRANG_CFG;
function VUHDO_getAutoArrangement()
	tNumMembers = 1;

  if (GetNumRaidMembers() > 0) then
  	tNumMembers = GetNumRaidMembers();

  	if (not VUHDO_IS_SHOWN_BY_GROUP and VUHDO_CONFIG["SHOW_PANELS"]) then
  	  VUHDO_IS_SHOWN_BY_GROUP = true;
  	  VUHDO_timeReloadUI(0.1);
  	end
	elseif (GetNumPartyMembers() > 0) then
		tNumMembers = GetNumPartyMembers() + 1;

  	if (not VUHDO_IS_SHOWN_BY_GROUP) then
  	  if (not VUHDO_CONFIG["HIDE_PANELS_PARTY"] and VUHDO_CONFIG["SHOW_PANELS"]) then
    	  VUHDO_IS_SHOWN_BY_GROUP = true;
	  	  VUHDO_timeReloadUI(0.1);
  	  end
  	else
  	  if (VUHDO_CONFIG["HIDE_PANELS_PARTY"]) then
    	  VUHDO_IS_SHOWN_BY_GROUP = false;
	  	  VUHDO_timeReloadUI(0.1);
  	  end
  	end
	else
  	if (not VUHDO_IS_SHOWN_BY_GROUP) then
  	  if (not VUHDO_CONFIG["HIDE_PANELS_SOLO"] and VUHDO_CONFIG["SHOW_PANELS"]) then
    	  VUHDO_IS_SHOWN_BY_GROUP = true;
	  	  VUHDO_timeReloadUI(0.1);
  	  end
  	else
  	  if (VUHDO_CONFIG["HIDE_PANELS_SOLO"]) then
    	  VUHDO_IS_SHOWN_BY_GROUP = false;
	  	  VUHDO_timeReloadUI(0.1);
  	  end
  	end
	end

	if (VUHDO_DEBUG_AUTO_ARRANG ~= nil) then
		tNumMembers = VUHDO_DEBUG_AUTO_ARRANG;
	end

	if (tNumMembers == 1) then
		table.wipe(VUHDO_MAINTANK_NAMES);
	end

	VUHDO_ARRANG_CFG = VUHDO_CONFIG["AUTO_ARRANGEMENTS"];
	for _, tIndex in pairs (tAutoArrangsIndices) do
		if (VUHDO_ARRANG_CFG[tIndex] ~= nil and tNumMembers <= tonumber(tIndex)) then
			return VUHDO_ARRANG_CFG[tIndex], tNumMembers;
		end
	end

	return nil, nil;
end
