VUHDO_PANEL_UNITS = { {}, {}, {}, {}, {}, {}, {}, {}, {}, {} };
local VUHDO_PANEL_UNITS = VUHDO_PANEL_UNITS;

VUHDO_UNIT_BUTTONS = {};
local VUHDO_UNIT_BUTTONS = VUHDO_UNIT_BUTTONS;

local table = table;
local tinsert = tinsert;



--
local tIdAll = { VUHDO_ID_ALL };
local tEmpty = { };
function VUHDO_getDynamicModelArray(aPanelNum)
	if (VUHDO_ORDERING_STRICT == VUHDO_PANEL_SETUP[aPanelNum]["MODEL"].ordering) then
		return VUHDO_PANEL_DYN_MODELS[aPanelNum] or tEmpty;
	else
		return tIdAll;
	end
end
local VUHDO_getDynamicModelArray = VUHDO_getDynamicModelArray;



--
function VUHDO_getHeaderText(aModelId)
	if (VUHDO_ID_GROUP_OWN == aModelId) then
		return  VUHDO_HEADER_TEXTS[aModelId] .. " (" .. VUHDO_getUnitGroup(VUHDO_PLAYER_RAID_ID, false) .. ")";
	else
		return VUHDO_HEADER_TEXTS[aModelId];
	end
end



--
local tHeaderText;
local tColor;
function VUHDO_customizeHeader(aHeader, aPanelNum, aModelId)
	tHeaderText = VUHDO_getHeaderTextId(aHeader);
	tHeaderText:SetText(VUHDO_getHeaderText(aModelId));

	if (VUHDO_PANEL_SETUP[aPanelNum]["PANEL_COLOR"].classColorsHeader
		and VUHDO_ID_TYPE_CLASS == VUHDO_getModelType(aModelId)) then
		tColor = VUHDO_getClassColorByModelId(aModelId);
	else
		tColor = VUHDO_PANEL_SETUP[aPanelNum]["PANEL_COLOR"]["HEADER"];
	end
	tHeaderText:SetTextColor(tColor.TR, tColor.TG, tColor.TB, tColor.TO);

	if (VUHDO_PANEL_SETUP[aPanelNum]["PANEL_COLOR"].classColorsBackHeader
		and VUHDO_ID_TYPE_CLASS == VUHDO_getModelType(aModelId)) then
		tColor = VUHDO_getClassColorByModelId(aModelId);
	else
		tColor = VUHDO_PANEL_SETUP[aPanelNum]["PANEL_COLOR"]["HEADER"];
	end
	VUHDO_getHeaderBar(aHeader):SetStatusBarColor(tColor.R, tColor.G, tColor.B, tColor.O);
end



--
function VUHDO_getPanelUnits(aPanelNum)
	return VUHDO_PANEL_UNITS[aPanelNum];
end
local VUHDO_getPanelUnits = VUHDO_getPanelUnits;



--
local tSubTable = { };
local tSubCount;
local tEnd;
local function VUHDO_getSubTable(aTable, anIndex, aCount)
	table.wipe(tSubTable);

	tEnd = anIndex + aCount - 1;
	for tSubCount = anIndex, tEnd do
		if (aTable[tSubCount] ~= nil) then
			tinsert(tSubTable, aTable[tSubCount]);
		else
			break;
		end
	end

	return tSubTable;
end



--
local tOccurrence;
local tDynModel;
local tModelNo;
local tMaxRows;
local tCutOffset;
local function VUHDO_cutSubGroup(anIdentifier, aPanelNum, aModelIndex)
	tDynModel = VUHDO_getDynamicModelArray(aPanelNum);
	tOccurrence = 0;
	for tModelNo = 1, aModelIndex do
		if (tDynModel[tModelNo] == anIdentifier) then
			tOccurrence = tOccurrence + 1;
		end
	end

	tMaxRows = VUHDO_PANEL_SETUP[aPanelNum]["SCALING"].maxRowsWhenLoose;

	tCutOffset = (tOccurrence - 1) * tMaxRows + 1;
	return VUHDO_getSubTable(VUHDO_GROUPS[anIdentifier], tCutOffset, tMaxRows);
end



--
local tEmptyArray = { };
local tGroupArray;
function VUHDO_getGroupMembers(anIdentifier, aPanelNum, aModelIndex)
	if (anIdentifier ~= VUHDO_ID_ALL) then
		if (aModelIndex == nil) then
			tGroupArray = VUHDO_GROUPS[anIdentifier];
		else
			tGroupArray = VUHDO_cutSubGroup(anIdentifier, aPanelNum, aModelIndex);
		end
	else
		tGroupArray = VUHDO_getPanelUnits(aPanelNum);
	end

	if (tGroupArray == nil) then
		return tEmptyArray;
	end

	return tGroupArray;
end
local VUHDO_getGroupMembers = VUHDO_getGroupMembers;



local sPanelNum;
local sIsPlayerFirst;



--
local VUHDO_RAID_SORTERS = {
	[VUHDO_SORT_RAID_UNITID]
		= function(aUnitId, anotherUnitId)
				if (sIsPlayerFirst and UnitIsUnit(aUnitId, "player")) then
					return true;
				elseif (sIsPlayerFirst and UnitIsUnit(anotherUnitId, "player")) then
					return false;
				else
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					return VUHDO_RAID[aUnitId].number < VUHDO_RAID[anotherUnitId].number; -- comparing strings doesn't work
				end
			end,

	[VUHDO_SORT_RAID_NAME]
		= function(aUnitId, anotherUnitId)
				if (sIsPlayerFirst and UnitIsUnit(aUnitId, "player")) then
					return true;
				elseif (sIsPlayerFirst and UnitIsUnit(anotherUnitId, "player")) then
					return false;
				else
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					return VUHDO_RAID[aUnitId].name < VUHDO_RAID[anotherUnitId].name;
				end
			end,

	[VUHDO_SORT_RAID_CLASS]
		= function(aUnitId, anotherUnitId)
				if (sIsPlayerFirst and UnitIsUnit(aUnitId, "player")) then
					return true;
				elseif (sIsPlayerFirst and UnitIsUnit(anotherUnitId, "player")) then
					return false;
				elseif (VUHDO_RAID[aUnitId].class ~= nil and VUHDO_RAID[anotherUnitId].class ~= nil) then
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					return VUHDO_RAID[aUnitId].class .. VUHDO_RAID[aUnitId].name
						> VUHDO_RAID[anotherUnitId].class .. VUHDO_RAID[anotherUnitId].name;
				else
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					return VUHDO_RAID[aUnitId].name < VUHDO_RAID[anotherUnitId].name;
				end
			end,

	[VUHDO_SORT_RAID_MAX_HP]
		= function(aUnitId, anotherUnitId)
				if (sIsPlayerFirst and UnitIsUnit(aUnitId, "player")) then
					return true;
				elseif (sIsPlayerFirst and UnitIsUnit(anotherUnitId, "player")) then
					return false;
				elseif (VUHDO_RAID[aUnitId].sortMaxHp ~= nil and VUHDO_RAID[anotherUnitId].sortMaxHp ~= nil) then
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					return VUHDO_RAID[aUnitId].sortMaxHp > VUHDO_RAID[anotherUnitId].sortMaxHp;
				else
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					return VUHDO_RAID[aUnitId].name < VUHDO_RAID[anotherUnitId].name;
				end
			end,

	[VUHDO_SORT_RAID_MODELS]
		= function(aUnitId, anotherUnitId)
				if (sIsPlayerFirst and UnitIsUnit(aUnitId, "player")) then
					return true;
				elseif (sIsPlayerFirst and UnitIsUnit(anotherUnitId, "player")) then
					return false;
				else
					if (VUHDO_PANEL_SETUP[sPanelNum]["MODEL"].isReverse) then
						aUnitId, anotherUnitId = anotherUnitId, aUnitId;
					end
					tFirstIdx = VUHDO_getPanelUnitFirstModel(sPanelNum, aUnitId);
					tSecondIdx = VUHDO_getPanelUnitFirstModel(sPanelNum, anotherUnitId);
					if (tFirstIdx ~= tSecondIdx) then
						return tFirstIdx < tSecondIdx;
					else
						return VUHDO_RAID[aUnitId].name < VUHDO_RAID[anotherUnitId].name;
					end
				end
			end,
};



--
local tSorted = { };
local tMembers;
local tUnit;
local tNoExists;
function VUHDO_getGroupMembersSorted(anIdentifier, aSortCriterion, aPanelNum, aModelIndex)
	tMembers = VUHDO_getGroupMembers(anIdentifier, aPanelNum, aModelIndex);
	sIsPlayerFirst = VUHDO_PANEL_SETUP[aPanelNum]["SCALING"].isPlayerOnTop

	if (VUHDO_ID_MAINTANKS ~= anIdentifier) then
		table.wipe(tSorted);
		tNoExists = false;
		for _, tUnit in ipairs(tMembers) do
			table.insert(tSorted, tUnit);
			if (VUHDO_RAID[tUnit] == nil) then
				tNoExists = true;
			end
		end
		if (VUHDO_ID_VEHICLES == anIdentifier or tNoExists) then
			table.sort(tSorted,
				function(aUnitId, anotherUnitId)
					if (sIsPlayerFirst and UnitIsUnit(aUnitId, "player")) then
						return true;
					elseif (sIsPlayerFirst and UnitIsUnit(anotherUnitId, "player")) then
						return false;
					else
						return aUnitId < anotherUnitId;
					end
				end
			);
		else
			sPanelNum = aPanelNum;
			table.sort(tSorted, VUHDO_RAID_SORTERS[aSortCriterion]);
		end

	else -- for main tanks keep the order of CTRA/ORA
		table.wipe(tSorted); -- has to be copied!!! conflicts in size calculator otherwise!
		for _, tUnit in ipairs(tMembers) do
			tinsert(tSorted, tUnit)
		end
	end

	return tSorted;
end



--
local tUnit;
local tResUnit;
local tPanelNum, tBtnNum;
function VUHDO_addUnitButton(aHealButton)
	tUnit = aHealButton.target;
	if (tUnit == nil) then
		return;
	end

	if (VUHDO_UNIT_BUTTONS[tUnit] == nil) then
		VUHDO_UNIT_BUTTONS[tUnit] = { };
	end

	VUHDO_UNIT_BUTTONS[tUnit][aHealButton:GetName()] = aHealButton;

	tResUnit = aHealButton.raidid;
	if (tResUnit ~= tUnit) then
		if (VUHDO_UNIT_BUTTONS[tResUnit] == nil) then
			VUHDO_UNIT_BUTTONS[tResUnit] = { };
		end

		VUHDO_UNIT_BUTTONS[tResUnit][aHealButton:GetName()] = aHealButton;
	end
end



