local VUHDO_GLOBAL = getfenv();

-- Fast caches
local VUHDO_ACTION_PANELS = { };
local VUHDO_HEALTH_BAR = { };
local VUHDO_HEAL_BUTTON = { };
local VUHDO_GROUP_ORDER_BARS_LEFT = { };
local VUHDO_GROUP_ORDER_BARS_RIGHT = { };
local VUHDO_BUFF_SWATCHES = { };
local VUHDO_BUFF_PANELS = { };

VUHDO_BUTTON_CACHE = { };
local VUHDO_BUTTON_CACHE = VUHDO_BUTTON_CACHE;


-- Returns the Bar-Object appropriate for given Button-Object
function VUHDO_getBarIcon(aHealthBar, anIconNumber)
  return VUHDO_GLOBAL[aHealthBar:GetName() .. "Ic" .. anIconNumber .. "I"];
end



--
function VUHDO_getBarRoleIcon(aButton, anIconNumber)
  return VUHDO_GLOBAL[aButton:GetName() .. "BgBarIcBarHlBarIc" .. anIconNumber];
end



--
function VUHDO_getTargetBarRoleIcon(aButton, anIconNumber)
  return VUHDO_GLOBAL[aButton:GetName() .. "BgBarHlBarIc" .. anIconNumber];
end



--
function VUHDO_getBarIconTimer(aHealthBar, anIconNumber)
	return VUHDO_GLOBAL[aHealthBar:GetName() .. "Ic" .. anIconNumber .. "T"];
end



--
function VUHDO_getBarIconCounter(aHealthBar, anIconNumber)
	return VUHDO_GLOBAL[aHealthBar:GetName() .. "Ic" .. anIconNumber .. "C"];
end



--
function VUHDO_getBarIconCharge(aHealthBar, anIconNumber)
	return VUHDO_GLOBAL[aHealthBar:GetName() .. "Ic" .. anIconNumber .. "A"];
end



--
function VUHDO_getRaidTargetTexture(aTargetBar)
	return VUHDO_GLOBAL[aTargetBar:GetName() .. "TgTxu"];
end



--
function VUHDO_getRaidTargetTextureFrame(aTargetBar)
	return VUHDO_GLOBAL[aTargetBar:GetName() .. "Tg"];
end



--
function VUHDO_getGroupOrderLabel2(aGroupOrderPanel)
  return VUHDO_GLOBAL[aGroupOrderPanel:GetName() .. "DrgLbl2Lbl"];
end



--
function VUHDO_getPanelNumLabel(aPanel)
  return VUHDO_GLOBAL[aPanel:GetName() .. "GrpLblLbl"];
end



--
function VUHDO_getConfigOrderBarRight(aPanelNum, anOrderNum)
	local tIndex = aPanelNum * 100 + anOrderNum;
	if (VUHDO_GROUP_ORDER_BARS_RIGHT[tIndex] == nil) then
		local tPanel = VUHDO_getOrCreateGroupOrderPanel(aPanelNum, anOrderNum);
		VUHDO_GROUP_ORDER_BARS_RIGHT[tIndex] = VUHDO_GLOBAL[tPanel:GetName() .. "InsTxuR"];
	end

	return VUHDO_GROUP_ORDER_BARS_RIGHT[tIndex];
end



--
function VUHDO_getConfigOrderBarLeft(aPanelNum, anOrderNum)
	local tIndex = aPanelNum * 100 + anOrderNum;
	if (VUHDO_GROUP_ORDER_BARS_LEFT[tIndex] == nil) then
		local tPanel = VUHDO_getOrCreateGroupOrderPanel(aPanelNum, anOrderNum);
		VUHDO_GROUP_ORDER_BARS_LEFT[tIndex] = VUHDO_GLOBAL[tPanel:GetName() .. "InsTxuL"];
	end

	return VUHDO_GROUP_ORDER_BARS_LEFT[tIndex];
end



--
function VUHDO_getGroupOrderPanel(aParentPanelNum, aPanelNum)
	return VUHDO_GLOBAL["VdAc" .. aParentPanelNum .. "GrpOrd" .. aPanelNum];
end



--
function VUHDO_getGroupSelectPanel(aParentPanelNum, aPanelNum)
	return VUHDO_GLOBAL["VdAc" .. aParentPanelNum .. "GrpSel" .. aPanelNum];
end




--
function VUHDO_getOrCreateGroupOrderPanel(aParentPanelNum, aPanelNum)
	local tName = "VdAc" .. aParentPanelNum .. "GrpOrd" .. aPanelNum;
	if (VUHDO_GLOBAL[tName] == nil) then
		CreateFrame("Frame", tName, VUHDO_GLOBAL["VdAc" .. aParentPanelNum], "VuhDoGrpOrdTemplate");
	end

	return VUHDO_GLOBAL[tName];
end



--
function VUHDO_getOrCreateGroupSelectPanel(aParentPanelNum, aPanelNum)
	local tName = "VdAc" .. aParentPanelNum .. "GrpSel" .. aPanelNum;
	if (VUHDO_GLOBAL[tName] == nil) then
		CreateFrame("Frame", tName, VUHDO_GLOBAL["VdAc" .. aParentPanelNum], "VuhDoGrpSelTemplate");
	end

	return VUHDO_GLOBAL[tName];
end



--
function VUHDO_getActionPanel(aPanelNum)
  return VUHDO_ACTION_PANELS[aPanelNum];
end



-- Returns the Bar-Object appropriate for given Button-Object
function VUHDO_getHealthBar(aButton, aBarNumber)
	return VUHDO_HEALTH_BAR[aButton:GetName()][aBarNumber];
end



--
function VUHDO_getHeaderBar(aButton)
  return VUHDO_GLOBAL[aButton:GetName() .. "Bar"];
end



--
function VUHDO_getPlayerTargetFrame(aButton)
  return VUHDO_GLOBAL[VUHDO_HEALTH_BAR[aButton:GetName()][1]:GetName() .. "PlTg"];
end


--
function VUHDO_getPlayerTargetFrameTarget(aButton)
  return VUHDO_GLOBAL[aButton:GetName() .. "TgPlTg"];
end



--
function VUHDO_getPlayerTargetFrameToT(aButton)
  return VUHDO_GLOBAL[aButton:GetName() .. "TotPlTg"];
end




--
function VUHDO_getClusterBorderFrame(aButton)
  return VUHDO_GLOBAL[VUHDO_HEALTH_BAR[aButton:GetName()][1]:GetName() .. "Clu"];
end



--
function VUHDO_getTargetButton(aButton)
	return VUHDO_GLOBAL[aButton:GetName() .. "Tg"];
end



--
function VUHDO_getTotButton(aButton)
	return VUHDO_GLOBAL[aButton:GetName() .. "Tot"];
end



-- Returns the Button Object for given unit number
function VUHDO_getHealButton(aButtonNum, aPanelNum)
	return VUHDO_HEAL_BUTTON[aPanelNum][aButtonNum];
end



--
function VUHDO_getTextPanel(aBar)
	return VUHDO_GLOBAL[aBar:GetName() .. "TxPnl"];
end




--
function VUHDO_getBarText(aBar)
	return VUHDO_GLOBAL[aBar:GetName() .. "TxPnlUnN"];
end



--
function VUHDO_getHeaderTextId(aHeader)
	return VUHDO_GLOBAL[aHeader:GetName() .. "BarUnN"];
end



--
function VUHDO_getLifeText(aBar)
	return VUHDO_GLOBAL[aBar:GetName() .. "TxPnlLife"];
end



--
function VUHDO_getOverhealPanel(aBar)
	return VUHDO_GLOBAL[aBar:GetName() .. "OvhPnl"];
end



--
function VUHDO_getOverhealText(aBar)
	return VUHDO_GLOBAL[aBar:GetName() .. "OvhPnlT"];
end



--
function VUHDO_getHeader(aHeaderNo, aPanelNum)
	return VUHDO_GLOBAL["VdAc" .. aPanelNum .. "Hd" .. aHeaderNo];
end



--
local tButton;
function VUHDO_getOrCreateBuffSwatch(aName, aParent)

	if (VUHDO_BUFF_SWATCHES[aName] == nil) then
		VUHDO_BUFF_SWATCHES[aName] = CreateFrame("Frame", aName, aParent, "VuhDoBuffSwatchPanelTemplate");
		tButton = VUHDO_GLOBAL[aName .. "GlassButton"];

		tButton:SetAttribute("_onleave", [=[
			self:ClearBindings();
		]=]);

		tButton:SetAttribute("_onshow", [=[
			self:ClearBindings();
		]=]);

		tButton:SetAttribute("_onhide", [=[
			self:ClearBindings();
		]=]);
	else
		tButton = VUHDO_GLOBAL[aName .. "GlassButton"];
	end

	if (VUHDO_BUFF_SETTINGS["CONFIG"]["WHEEL_SMART_BUFF"]) then
		tButton:SetAttribute("_onenter", [=[
				self:ClearBindings();
				self:SetBindingClick(0, "MOUSEWHEELUP" , "VuhDoSmartCastGlassButton", "LeftButton");
				self:SetBindingClick(0, "MOUSEWHEELDOWN" , "VuhDoSmartCastGlassButton", "LeftButton");
		]=]);
	else
		tButton:SetAttribute("_onenter", [=[
			self:ClearBindings();
		]=]);
	end

	return VUHDO_BUFF_SWATCHES[aName];
end



--
function VUHDO_getOrCreateBuffPanel(aName)
	if (VUHDO_BUFF_PANELS[aName] == nil) then
		VUHDO_BUFF_PANELS[aName] = CreateFrame("Frame", aName, VuhDoBuffWatchMainFrame, "VuhDoBuffWatchBuffTemplate");
	end

	return VUHDO_BUFF_PANELS[aName];
end



--
function VUHDO_resetAllBuffPanels()
	VUHDO_resetAllBuffSwatches();

	local tPanel;

	for _, tPanel in pairs(VUHDO_BUFF_SWATCHES) do
		tPanel:Hide();
		tPanel:ClearAllPoints();
	end

	for _, tPanel in pairs(VUHDO_BUFF_PANELS) do
		tPanel:Hide();
		tPanel:ClearAllPoints();
	end
end



--
function VUHDO_resetAllBuffSwatches()
	local tSwatch;
	for _, tSwatch in pairs(VUHDO_BUFF_SWATCHES) do
		tSwatch:Hide();
		tSwatch:ClearAllPoints();
	end
end



--
function VUHDO_getAllBuffSwatches()
	return VUHDO_BUFF_SWATCHES;
end



--
function VUHDO_getAggroTexture(aHealthBar)
	return VUHDO_GLOBAL[aHealthBar:GetName() .. "Aggro"];
end



local tButton;
local tButtonName;
local tCnt3;
local tButtonTgName;
local tButtonTotName;
local function VUHDO_fastCacheInitButton(aPanelNum, aButtonNum)

	tButtonName = "VdAc" .. aPanelNum .. "HlU" .. aButtonNum;
	tButtonTgName = tButtonName .. "Tg";
	tButtonTotName = tButtonName .. "Tot";
	tButton = VUHDO_GLOBAL[tButtonName];

	VUHDO_HEALTH_BAR[tButtonName] = { };
	VUHDO_HEALTH_BAR[tButtonTgName] = { };
	VUHDO_HEALTH_BAR[tButtonTotName] = { };
	for tCnt3 = 1, 16 do
		if (tCnt3 == 1) then --Health
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBar"];
		elseif (tCnt3 == 2) then -- Mana
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBarMaBar"];
		elseif (tCnt3 == 3) then -- Background
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBar"];
		elseif (tCnt3 == 4) then -- Aggro
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBarAgBar"];
		elseif (tCnt3 == 5) then -- Target Health
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "TgBgBarHlBar"];
			VUHDO_HEALTH_BAR[tButtonTgName][1] = VUHDO_GLOBAL[tButtonName .. "TgBgBarHlBar"];
		elseif (tCnt3 == 6) then -- Incoming
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBar"];
			VUHDO_HEALTH_BAR[tButtonTgName][tCnt3] = VuhDoDummyStatusBar;
			VUHDO_HEALTH_BAR[tButtonTotName][tCnt3] = VuhDoDummyStatusBar;
		elseif (tCnt3 == 7) then -- Threat
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "ThBar"];
		elseif (tCnt3 == 8) then -- Group Highlight
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBarHiBar"];
			VUHDO_HEALTH_BAR[tButtonTgName][tCnt3] = VuhDoDummyStatusBar;
			VUHDO_HEALTH_BAR[tButtonTotName][tCnt3] = VuhDoDummyStatusBar;
		elseif (tCnt3 == 9) then -- HoT 1
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBarHotBar1"];
		elseif (tCnt3 == 10) then -- HoT 2
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBarHotBar2"];
		elseif (tCnt3 == 11) then -- HoT 3
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "BgBarIcBarHlBarHotBar3"];
		elseif (tCnt3 == 12) then -- Target Background
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "TgBgBar"];
			VUHDO_HEALTH_BAR[tButtonTgName][3] = VUHDO_GLOBAL[tButtonName .. "TgBgBar"];
		elseif (tCnt3 == 13) then -- Target Mana
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "TgBgBarHlBarMaBar"];
			VUHDO_HEALTH_BAR[tButtonTgName][2] = VUHDO_GLOBAL[tButtonName .. "TgBgBarHlBarMaBar"];
		elseif (tCnt3 == 14) then -- Tot Life
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "TotBgBarHlBar"];
			VUHDO_HEALTH_BAR[tButtonTotName][1] = VUHDO_GLOBAL[tButtonName .. "TotBgBarHlBar"];
		elseif (tCnt3 == 16) then -- Tot Mana
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "TotBgBarHlBarMaBar"];
			VUHDO_HEALTH_BAR[tButtonTotName][2] = VUHDO_GLOBAL[tButtonName .. "TotBgBarHlBarMaBar"];
		elseif (tCnt3 == 15) then -- Tot Background
			VUHDO_HEALTH_BAR[tButtonName][tCnt3] = VUHDO_GLOBAL[tButtonName .. "TotBgBar"];
			VUHDO_HEALTH_BAR[tButtonTotName][3] = VUHDO_GLOBAL[tButtonName .. "TotBgBar"];
		end
	end

	VUHDO_HEAL_BUTTON[aPanelNum][aButtonNum] = tButton;
	VUHDO_BUTTON_CACHE[tButtonName] = aPanelNum;
	VUHDO_BUTTON_CACHE[tButtonTgName] = aPanelNum;
	VUHDO_BUTTON_CACHE[tButtonTotName] = aPanelNum;
end



--
local tButtonName;
local tNewButton;
function VUHDO_getOrCreateHealButton(aButtonNum, aPanelNum)
	if (VUHDO_HEAL_BUTTON[aPanelNum][aButtonNum] == nil) then
		tButtonName = "VdAc" .. aPanelNum .. "HlU" .. aButtonNum;
		tNewButton = CreateFrame("Button", tButtonName, VUHDO_GLOBAL["VdAc" .. aPanelNum], "VuhDoButtonSecureTemplate");
		VUHDO_fastCacheInitButton(aPanelNum, aButtonNum);
		VUHDO_initLocalVars(aPanelNum);
		VUHDO_initHealButton(tNewButton, aPanelNum);
		VUHDO_positionHealButton(tNewButton);
--	else
--		VUHDO_fastCacheInitButton(aPanelNum, aButtonNum);
	end

	return VUHDO_HEAL_BUTTON[aPanelNum][aButtonNum];
end



--
function VUHDO_getPanelButtons(aPanelNum)
  return VUHDO_HEAL_BUTTON[aPanelNum];
end



--
local tCnt, tCnt2;
function VUHDO_initFastCache()
	for tCnt = 1, VUHDO_MAX_PANELS do
		VUHDO_ACTION_PANELS[tCnt] = VUHDO_GLOBAL["VdAc" .. tCnt];
	end

	for tCnt = 1, VUHDO_MAX_PANELS do
		VUHDO_HEAL_BUTTON[tCnt] = { };
	end
end
