--
function VUHDO_yesNoDeleteSkinCallback(aDecision)
	if (VUHDO_YES == aDecision) then
		table.wipe(VUHDO_SKINS[VUHDO_CURR_INDEX]);
		tremove(VUHDO_SKINS, VUHDO_CURR_INDEX);
		VUHDO_initSkinTableModels(VUHDO_CURR_BUTTON);
	end
end



--
function VUHDO_deleteSkin(aButton)
	local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
	local tName = tEditBox:GetText();

	if (tName == nil or strlen(tName) == 0) then
		return;
	end

	local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_SKINS);
	if (tExistIndex == nil) then
		VUHDO_Msg("Error: No skin named \"" .. tName .. "\" exists!", 1, 0.4, 0.4);
		return;
	end

	VUHDO_CURR_INDEX = tExistIndex;
	VUHDO_CURR_BUTTON = aButton;
	VuhDoYesNoFrameText:SetText("Really delete skin \"" .. tName .. "\"?");
	VuhDoYesNoFrame:SetAttribute("callback", VUHDO_yesNoDeleteSkinCallback);
	VuhDoYesNoFrame:Show();
end



--
function VUHDO_yesNoOverwriteSkinCallback(aDecision)
	if (VUHDO_YES == aDecision) then
		VUHDO_SKINS[VUHDO_CURR_INDEX] = VUHDO_CURR_MODEL;
		VUHDO_initSkinTableModels(VUHDO_CURR_BUTTON);
	end
end



--
function VUHDO_saveSkin(aButton)
	local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
	local tName = tEditBox:GetText();

	if (tName == nil or strlen(tName) == 0) then
		return;
	end

	local tNewSkin = { ["NAME"] = tName, ["DATA"] = { } };
	tNewSkin["DATA"] = VUHDO_saveToSkin(VUHDO_PANEL_SKIN_MODEL_SKIN, tNewSkin["DATA"]);

	local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_SKINS);
	if (tExistIndex == nil) then
		table.insert(VUHDO_SKINS, tNewSkin);
		VUHDO_initSkinTableModels(aButton);
	else
		VUHDO_CURR_INDEX = tExistIndex;
		VUHDO_CURR_BUTTON = aButton;
		VUHDO_CURR_MODEL = tNewSkin;
		VuhDoYesNoFrameText:SetText("Do you want to overwrite skin \"" .. tName .. "\"?");
		VuhDoYesNoFrame:SetAttribute("callback", VUHDO_yesNoOverwriteSkinCallback);
		VuhDoYesNoFrame:Show();
	end
end



--
function VUHDO_yesNoOverwriteArrangeCallback(aDecision)
	if (VUHDO_YES == aDecision) then
		VUHDO_ARRANGEMENTS[VUHDO_CURR_INDEX] = VUHDO_CURR_MODEL;
		VUHDO_initSkinTableModels(VUHDO_CURR_BUTTON);
	end
end



--
function VUHDO_saveArrange(aButton)
	local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
	local tName = tEditBox:GetText();

	if (tName == nil or strlen(tName) == 0) then
		return;
	end

	local tNewArrange = { ["NAME"] = tName, ["DATA"] = { } };
	tNewArrange["DATA"] = VUHDO_saveToSkin(VUHDO_PANEL_SKIN_MODEL_SETUP, tNewArrange["DATA"]);

	local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_ARRANGEMENTS);
	if (tExistIndex == nil) then
		table.insert(VUHDO_ARRANGEMENTS, tNewArrange);
		VUHDO_initSkinTableModels(aButton);
	else
		VUHDO_CURR_INDEX = tExistIndex;
		VUHDO_CURR_BUTTON = aButton;
		VUHDO_CURR_MODEL = tNewArrange;
		VuhDoYesNoFrameText:SetText("Do you want to overwrite arrangement \"" .. tName .. "\"?");
		VuhDoYesNoFrame:SetAttribute("callback", VUHDO_yesNoOverwriteArrangeCallback);
		VuhDoYesNoFrame:Show();
	end
end



--
local tCnt;
function VUHDO_deleteAutoArrange(tName)
	for tCnt = 1, 40 do
		if (VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["" .. tCnt] == tName) then
			VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["" .. tCnt] = nil;
		end
	end
end



--
function VUHDO_yesNoDeleteArrangeCallback(aDecision)
	if (VUHDO_YES == aDecision) then
		table.wipe(VUHDO_ARRANGEMENTS[VUHDO_CURR_INDEX]);
		tremove(VUHDO_ARRANGEMENTS, VUHDO_CURR_INDEX);
		VUHDO_initSkinTableModels(VUHDO_CURR_BUTTON);
		VUHDO_deleteAutoArrange(VUHDO_CURR_NAME);
	end
end



--
function VUHDO_deleteArrange(aButton)
	local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
	local tName = tEditBox:GetText();

	if (tName == nil or strlen(tName) == 0) then
		return;
	end

	local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_ARRANGEMENTS);
	if (tExistIndex == nil) then
		VUHDO_Msg("Error: No arrangement named \"" .. tName .. "\" exists!", 1, 0.4, 0.4);
		return;
	end

	VUHDO_CURR_INDEX = tExistIndex;
	VUHDO_CURR_NAME = tName;
	VUHDO_CURR_BUTTON = aButton;
	VuhDoYesNoFrameText:SetText("Really delete arrangement \"" .. tName .. "\"?");
	VuhDoYesNoFrame:SetAttribute("callback", VUHDO_yesNoDeleteArrangeCallback);
	VuhDoYesNoFrame:Show();
end



--
function VUHDO_skinsInitAutoCheckButton(aButton, anIndex)
	local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
	local tSelected = strtrim(tEditBox:GetText());

	aButton:SetChecked(VUHDO_CONFIG["AUTO_ARRANGEMENTS"][anIndex] == tSelected);
	VUHDO_lnfCheckButtonClicked(aButton);
end



--
local tCnt;
local tButton;
function VUHDO_updateAllAutoArrang(aComponent)
	for tCnt = 1, 40 do
		tButton = VUHDO_GLOBAL[aComponent:GetParent():GetName() .. tCnt .. "CheckButton"];
		if (tButton ~= nil) then
			VUHDO_skinsInitAutoCheckButton(tButton, "" .. tCnt);
		end
	end
end



--
function VUHDO_skinsComboValueChanged(aComboBox, aValue)
	VUHDO_updateAllAutoArrang(aComboBox);
end






--
function VUHDO_skinsAutoCheckButtonClicked(aButton, anIndex)
	local tEditBox = VUHDO_GLOBAL[aButton:GetParent():GetName() .. "EnterNameEditBox"];
	local tSelected = strtrim(tEditBox:GetText());

	local tExistIndex = VUHDO_getSkinFromName(tSelected, VUHDO_ARRANGEMENTS);
	if (tExistIndex == nil) then
		VUHDO_Msg("Error: No arrangement named \"" .. tSelected .. "\" exists!", 1, 0.4, 0.4);
		aButton:SetChecked(false);
		VUHDO_lnfCheckButtonClicked(aButton);
		return;
	end

	if (aButton:GetChecked()) then
		VUHDO_CONFIG["AUTO_ARRANGEMENTS"][anIndex] = tSelected;
	else
		VUHDO_CONFIG["AUTO_ARRANGEMENTS"][anIndex] = nil;
	end
end



