local VUHDO_B_CONFIG = nil;
local VUHDO_B_PANEL_SETUP = nil;
local VUHDO_B_SPELL_ASSIGNMENTS = nil;
local VUHDO_B_BUFF_SETTINGS = nil;
local VUHDO_B_SPELL_CONFIG = nil;
local VUHDO_B_SPELLS_KEYBOARD = nil;


VUHDO_IS_CONFIG = false;

--
function VUHDO_tabbedFrameOnMouseDown(aPanel)
	aPanel:StartMoving();
end



--
function VUHDO_tabbedFrameOnMouseUp(aPanel)
	aPanel:StopMovingOrSizing();
end



--
function VUHDO_tabbedPanelOkayClicked(aButton)
	VUHDO_getMainPanel(aButton):Hide();

	table.wipe(VUHDO_B_CONFIG);
	table.wipe(VUHDO_B_PANEL_SETUP);
	table.wipe(VUHDO_B_SPELL_ASSIGNMENTS);
	table.wipe(VUHDO_B_BUFF_SETTINGS);
	table.wipe(VUHDO_B_SPELL_CONFIG);
	table.wipe(VUHDO_B_SPELLS_KEYBOARD);

	VUHDO_B_CONFIG = nil;
	VUHDO_B_PANEL_SETUP = nil;
	VUHDO_B_SPELL_ASSIGNMENTS = nil;
	VUHDO_B_BUFF_SETTINGS = nil;
	VUHDO_B_SPELL_CONFIG = nil;
	VUHDO_B_SPELLS_KEYBOARD = nil;

	VUHDO_initKeyboardMacros();
	VUHDO_initFromSpellbook();
  VUHDO_fixHotSettings();

	if (VUHDO_SPEC_LAYOUTS["selected"] ~= nil and VUHDO_SPEC_LAYOUTS["selected"] ~= "") then
		VUHDO_CURR_LAYOUT = VUHDO_SPEC_LAYOUTS["selected"];
		VUHDO_saveKeyLayoutCallback(VUHDO_YES);
	end

	local tName = VUHDO_CONFIG["CURRENT_SKIN"];
	if (tName ~= nil and tName ~= "") then
		local tNewSkin = { ["NAME"] = tName, ["DATA"] = { } };
		tNewSkin["DATA"] = VUHDO_saveToSkin(VUHDO_PANEL_SKIN_MODEL_SKIN, tNewSkin["DATA"]);

		local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_SKINS);
		if (tExistIndex ~= nil) then
			VUHDO_SKINS[tExistIndex] = tNewSkin;
			VUHDO_Msg("Skin \"" .. tName .. "\" successfully updated.");
		end
	end

	tName = VUHDO_CONFIG["CURRENT_ARRANGEMENT"];
	VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["dirty"] = true;
	if (tName ~= nil and tName ~= "") then
		local tNewArrange = { ["NAME"] = tName, ["DATA"] = { } };
		tNewArrange["DATA"] = VUHDO_saveToSkin(VUHDO_PANEL_SKIN_MODEL_SETUP, tNewArrange["DATA"]);

		local tExistIndex = VUHDO_getSkinFromName(tName, VUHDO_ARRANGEMENTS);
		if (tExistIndex ~= nil) then
			VUHDO_ARRANGEMENTS[tExistIndex] = tNewArrange;
			VUHDO_Msg("Arrangement \"" .. tName .. "\" successfully updated.");
			VUHDO_CONFIG["AUTO_ARRANGEMENTS"]["dirty"] = false;
		end
	end

	VUHDO_MAY_DEBUFF_ANIM = true;
	collectgarbage('collect');
end



--
function VUHDO_tabbedPanelCancelClicked(aButton)
	VUHDO_newOptionsRestoreVars();
	VUHDO_initKeyboardMacros();
	VUHDO_MAY_DEBUFF_ANIM = true;
end



--
local function VUHDO_newOptionsHideAllTabPanels()
	VuhDoNewOptionsGeneral:Hide();
	VuhDoNewOptionsPanelPanel:Hide();
	VuhDoNewOptionsSpell:Hide();
	VuhDoNewOptionsColors:Hide();
	VuhDoNewOptionsMove:Hide();
	VuhDoNewOptionsBuffs:Hide();
end



--
local tName;
function VUHDO_newOptionsTabbedClickedClicked(aTabRadio)
	tName = aTabRadio:GetName();

	VUHDO_newOptionsHideAllTabPanels();

	if (strfind(tName, "General")) then
		VuhDoNewOptionsGeneral:Show();
	elseif(strfind(tName, "Spell")) then
		VuhDoNewOptionsSpell:Show();
	elseif(strfind(tName, "Panels")) then
		VuhDoNewOptionsPanelPanel:Show();
	elseif(strfind(tName, "Colors")) then
		VuhDoNewOptionsColors:Show();
	elseif(strfind(tName, "Move")) then
		VuhDoNewOptionsMove:Show();
	elseif(strfind(tName, "Buffs")) then
		VuhDoNewOptionsBuffs:Show();
	end
end


--
function VUHDO_newOptionsBufferVars()
	if (VUHDO_B_CONFIG == nil) then
		VUHDO_B_CONFIG = VUHDO_deepCopyTable(VUHDO_CONFIG);
		VUHDO_B_PANEL_SETUP = VUHDO_deepCopyTable(VUHDO_PANEL_SETUP);
		VUHDO_B_SPELL_ASSIGNMENTS = VUHDO_deepCopyTable(VUHDO_SPELL_ASSIGNMENTS);
		VUHDO_B_BUFF_SETTINGS = VUHDO_deepCopyTable(VUHDO_BUFF_SETTINGS);
		VUHDO_B_SPELL_CONFIG = VUHDO_deepCopyTable(VUHDO_SPELL_CONFIG);
		VUHDO_B_SPELLS_KEYBOARD = VUHDO_deepCopyTable(VUHDO_SPELLS_KEYBOARD);
	end
end


--
function VUHDO_yesNoDiscardChangesCallback(aDecision)
	if (VUHDO_YES == aDecision) then
		VuhDoNewOptionsTabbedFrame:Hide();

		table.wipe(VUHDO_CONFIG);
		table.wipe(VUHDO_PANEL_SETUP);
		table.wipe(VUHDO_SPELL_ASSIGNMENTS);
		table.wipe(VUHDO_BUFF_SETTINGS);
		table.wipe(VUHDO_SPELL_CONFIG);
		table.wipe(VUHDO_SPELLS_KEYBOARD);

		VUHDO_CONFIG = VUHDO_deepCopyTable(VUHDO_B_CONFIG);
		VUHDO_PANEL_SETUP = VUHDO_deepCopyTable(VUHDO_B_PANEL_SETUP);
		VUHDO_SPELL_ASSIGNMENTS = VUHDO_deepCopyTable(VUHDO_B_SPELL_ASSIGNMENTS);
		VUHDO_BUFF_SETTINGS = VUHDO_deepCopyTable(VUHDO_B_BUFF_SETTINGS);
		VUHDO_SPELL_CONFIG = VUHDO_deepCopyTable(VUHDO_B_SPELL_CONFIG);
		VUHDO_SPELLS_KEYBOARD = VUHDO_deepCopyTable(VUHDO_B_SPELLS_KEYBOARD);

		table.wipe(VUHDO_B_CONFIG);
		table.wipe(VUHDO_B_PANEL_SETUP);
		table.wipe(VUHDO_B_SPELL_ASSIGNMENTS);
		table.wipe(VUHDO_B_BUFF_SETTINGS);
		table.wipe(VUHDO_B_SPELL_CONFIG);
		table.wipe(VUHDO_B_SPELLS_KEYBOARD);

		VUHDO_B_CONFIG = nil;
		VUHDO_B_PANEL_SETUP = nil;
		VUHDO_B_SPELL_ASSIGNMENTS = nil;
		VUHDO_B_BUFF_SETTINGS = nil;
		VUHDO_B_SPELL_CONFIG = nil;
		VUHDO_B_SPELLS_KEYBOARD = nil;
		VUHDO_initAllBurstCaches();
		VUHDO_reloadUI();
		collectgarbage('collect');
	end
end



--
local tChanges;
function VUHDO_newOptionsRestoreVars()
	tChanges =
		VUHDO_countTableDiffs(VUHDO_CONFIG, VUHDO_B_CONFIG)
		+ VUHDO_countTableDiffs(VUHDO_PANEL_SETUP, VUHDO_B_PANEL_SETUP)
		+ VUHDO_countTableDiffs(VUHDO_SPELL_ASSIGNMENTS, VUHDO_B_SPELL_ASSIGNMENTS)
		+ VUHDO_countTableDiffs(VUHDO_BUFF_SETTINGS, VUHDO_B_BUFF_SETTINGS)
		+ VUHDO_countTableDiffs(VUHDO_SPELL_CONFIG, VUHDO_B_SPELL_CONFIG)
		+ VUHDO_countTableDiffs(VUHDO_SPELLS_KEYBOARD, VUHDO_B_SPELLS_KEYBOARD);

	if (tChanges > 0) then
		VuhDoYesNoFrameText:SetText("You have made a total of " .. tChanges .. " setup changes.\nYou really wanna DISCARD them?");
		VuhDoYesNoFrame:SetAttribute("callback", VUHDO_yesNoDiscardChangesCallback);
		VuhDoYesNoFrame:Show();
	else
		VUHDO_yesNoDiscardChangesCallback(VUHDO_YES);
	end
end
